function [qlap,dqlap,q_sym,dq_sym] = abs2lapin(x_abs)
%ABS2LAPIN   Change from my absolute coorinates to the Lapin
%    coordinates.

%Copyright (c) 2003 by Eric Westervelt and Jessy Grizzle.  This code
%may be freely used for noncommercial ends. If use of this code in
%part or in whole results in publication, proper citation must be
%included in that publication.  This code comes with no guarantees or
%support.

%Eric R. Westervelt & Jessy W. Grizzle
%8/23/02
%11/30/03 - updated for the CDC

if nargin == 0
  syms q31L q32L q41L q42L q1L real
  syms dq31L dq32L dq41L dq42L dq1L real
  qlap  = [q31L;  q32L;  q41L;  q42L;  q1L];
  dqlap = [dq31L; dq32L; dq41L; dq42L; dq1L];
end

Tlap2abs = [ 1   0   0   0   1;
	     0   1   0   0   1;
	     1   0   1   0   1;
	     0   1   0   1   1;
	     0   0   0   0   1];

blap2abs = [0; 0; 0; 0; 0];

%qabs  = Tlap2abs*q_lap + blap2abs;
%dqabs = Tlap2abs*dq_lap;
%
%qlap  = inv(Tlap2abs)*qabs - blap2abs;
%dqlap = inv(Tlap2abs)*dqabs;

if nargin == 0
  % relative coordinates in terms of actual coords
  q_sym  = Tlap2abs*qlap + blap2abs; 
  dq_sym = Tlap2abs*dqlap;
else
  qlap(1:5)  = inv(Tlap2abs)*(x_abs(1:5) - blap2abs);
  qlap(6:10) = Tlap2abs*x_abs(6:10);
  qlap = qlap';
  qlap_sym = 0;
  dqlap_sym = 0;
end
