function out = impact_lap_red(x)
%IMPACT_LAP_RED    Map pre-impact state to post-impact state.
%
%    X_PLUS = IMPACT_REL_RED(X_MINUS)

%Copyright (c) 2003 by Eric Westervelt and Jessy Grizzle.  This code
%may be freely used for noncommercial ends. If use of this code in
%part or in whole results in publication, proper citation must be
%included in that publication.  This code comes with no guarantees or
%support.

%Eric R. Westervelt & Jessy W. Grizzle
%8/2/01
%11/30/03 - updated for the CDC

q = x(1:5);
dq = x(6:10);

[num_r,num_c] = size(q);
if num_r < num_c
  q = q';
  dq = dq';
end

x_f = red2full([q; dq]);

qe = x_f(1:7);
dqe_minus = x_f(8:14);

[De,Ce,Ge,Be,E1e] = dyn_mod_lap(qe,dqe_minus);

E = E1e(:,3:4);
% De*(dq^+ - dq^-) = E*impulsive forces=E*Fe
% E'*dq^+ = 0;
%
A = [De,-E;E',zeros(2,2)];
B = [De*dqe_minus; zeros(2,1)];
ans = inv(A)*B;

% to test that after impact the fixed foot raises itself from the
% ground

[vh,vv] = stance_foot_vel([x_f(1:7); ans(1:7)]);

Fe = ans(8:9);
test1 = min(100,abs(Fe(1)/Fe(2)));
test2 = vv;
if test1 <= 2/3 & test2 >= 0
  flag = 0;
  q_plus_new = xi(q);
  dq_plus_new = xi(ans(1:5));
  out = [q_plus_new;dq_plus_new;flag;test1;test2];
else
  error('swing leg end ground contact violation');
end
