function [beta] = beta(z1)
% BETA
%   [BETA] = BETA(Z1)  

%Eric Westervelt
%07-Mar-2003 16:51:41

modparams=modelParameters;
g=modparams.g;
L1=modparams.L1;   L3=modparams.L3;   L4=modparams.L4;
M1=modparams.M1;   M3=modparams.M3;   M4=modparams.M4;
MY1=modparams.MY1; MY3=modparams.MY3; MY4=modparams.MY4;
MZ1=modparams.MZ1; MZ3=modparams.MZ3; MZ4=modparams.MZ4;
XX1=modparams.XX1; XX3=modparams.XX3; XX4=modparams.XX4;
IA3=modparams.IA3; IA4=modparams.IA4;
FV1=modparams.FV1; FV2=modparams.FV2; FV3=modparams.FV3; FV4=modparams.FV4;
FS1=modparams.FS1; FS2=modparams.FS2; FS3=modparams.FS3; FS4=modparams.FS4;

Lb1=modparams.Lb1; Lt=modparams.Lt;
XXb=modparams.XXb; XXc=modparams.XXc; XXw=modparams.XXw;
PEbc=modparams.PEbc; PEcc=modparams.PEcc; PEwc=modparams.PEwc;
[a,b,m] = controlParameters;

a0=a(1); a1=a(2); a2=a(3); a3=a(4); a4=a(5); a5=a(6); a6=a(7); 
b0=a(8); b1=a(9); b2=a(10); b3=a(11); b4=a(12); b5=a(13); b6=a(14); 
c0=a(15); c1=a(16); c2=a(17); c3=a(18); c4=a(19); c5=a(20); c6=a(21); 
d0=a(22); d1=a(23); d2=a(24); d3=a(25); d4=a(26); d5=a(27); d6=a(28); 

hd1 = a0.*(1-(z1-b)./m).^6+6.*a1.*(z1-b)./m.*(1-(z1-b)./m).^5+15.*a2.* ...
      (z1-b).^2./m.^2.*(1-(z1-b)./m).^4+20.*a3.*(z1-b).^3./m.^3.*(1- ...
      (z1-b)./m).^3+15.*a4.*(z1-b).^4./m.^4.*(1-(z1-b)./m).^2+6.*a5.* ...
      (z1-b).^5./m.^5.*(1-(z1-b)./m)+a6.*(z1-b).^6./m.^6;
hd2 = b0.*(1-(z1-b)./m).^6+6.*b1.*(z1-b)./m.*(1-(z1-b)./m).^5+15.*b2.* ...
      (z1-b).^2./m.^2.*(1-(z1-b)./m).^4+20.*b3.*(z1-b).^3./m.^3.*(1- ...
      (z1-b)./m).^3+15.*b4.*(z1-b).^4./m.^4.*(1-(z1-b)./m).^2+6.*b5.* ...
      (z1-b).^5./m.^5.*(1-(z1-b)./m)+b6.*(z1-b).^6./m.^6;
hd3 = c0.*(1-(z1-b)./m).^6+6.*c1.*(z1-b)./m.*(1-(z1-b)./m).^5+15.*c2.* ...
      (z1-b).^2./m.^2.*(1-(z1-b)./m).^4+20.*c3.*(z1-b).^3./m.^3.*(1- ...
      (z1-b)./m).^3+15.*c4.*(z1-b).^4./m.^4.*(1-(z1-b)./m).^2+6.*c5.* ...
      (z1-b).^5./m.^5.*(1-(z1-b)./m)+c6.*(z1-b).^6./m.^6;
hd4 = d0.*(1-(z1-b)./m).^6+6.*d1.*(z1-b)./m.*(1-(z1-b)./m).^5+15.*d2.* ...
      (z1-b).^2./m.^2.*(1-(z1-b)./m).^4+20.*d3.*(z1-b).^3./m.^3.*(1- ...
      (z1-b)./m).^3+15.*d4.*(z1-b).^4./m.^4.*(1-(z1-b)./m).^2+6.*d5.* ...
      (z1-b).^5./m.^5.*(1-(z1-b)./m)+d6.*(z1-b).^6./m.^6;

jac_hd1 = -6.*a0.*(1-(z1-b)./m).^5./m+6.*a1./m.*(1-(z1-b)./m).^5-30.*a1.* ...
          (z1-b)./m.^2.*(1-(z1-b)./m).^4+30.*a2.*(z1-b)./m.^2.*(1-(z1- ...
          b)./m).^4-60.*a2.*(z1-b).^2./m.^3.*(1-(z1-b)./m).^3+60.*a3.*(z1- ...
          b).^2./m.^3.*(1-(z1-b)./m).^3-60.*a3.*(z1-b).^3./m.^4.*(1-(z1- ...
          b)./m).^2+60.*a4.*(z1-b).^3./m.^4.*(1-(z1-b)./m).^2-30.*a4.*(z1- ...
          b).^4./m.^5.*(1-(z1-b)./m)+30.*a5.*(z1-b).^4./m.^5.*(1-(z1- ...
          b)./m)-6.*a5.*(z1-b).^5./m.^6+6.*a6.*(z1-b).^5./m.^6;
jac_hd2 = -6.*b0.*(1-(z1-b)./m).^5./m+6.*b1./m.*(1-(z1-b)./m).^5-30.*b1.* ...
          (z1-b)./m.^2.*(1-(z1-b)./m).^4+30.*b2.*(z1-b)./m.^2.*(1-(z1- ...
          b)./m).^4-60.*b2.*(z1-b).^2./m.^3.*(1-(z1-b)./m).^3+60.*b3.*(z1- ...
          b).^2./m.^3.*(1-(z1-b)./m).^3-60.*b3.*(z1-b).^3./m.^4.*(1-(z1- ...
          b)./m).^2+60.*b4.*(z1-b).^3./m.^4.*(1-(z1-b)./m).^2-30.*b4.*(z1- ...
          b).^4./m.^5.*(1-(z1-b)./m)+30.*b5.*(z1-b).^4./m.^5.*(1-(z1- ...
          b)./m)-6.*b5.*(z1-b).^5./m.^6+6.*b6.*(z1-b).^5./m.^6;
jac_hd3 = -6.*c0.*(1-(z1-b)./m).^5./m+6.*c1./m.*(1-(z1-b)./m).^5-30.*c1.* ...
          (z1-b)./m.^2.*(1-(z1-b)./m).^4+30.*c2.*(z1-b)./m.^2.*(1-(z1- ...
          b)./m).^4-60.*c2.*(z1-b).^2./m.^3.*(1-(z1-b)./m).^3+60.*c3.*(z1- ...
          b).^2./m.^3.*(1-(z1-b)./m).^3-60.*c3.*(z1-b).^3./m.^4.*(1-(z1- ...
          b)./m).^2+60.*c4.*(z1-b).^3./m.^4.*(1-(z1-b)./m).^2-30.*c4.*(z1- ...
          b).^4./m.^5.*(1-(z1-b)./m)+30.*c5.*(z1-b).^4./m.^5.*(1-(z1- ...
          b)./m)-6.*c5.*(z1-b).^5./m.^6+6.*c6.*(z1-b).^5./m.^6;
jac_hd4 = -6.*d0.*(1-(z1-b)./m).^5./m+6.*d1./m.*(1-(z1-b)./m).^5-30.*d1.* ...
          (z1-b)./m.^2.*(1-(z1-b)./m).^4+30.*d2.*(z1-b)./m.^2.*(1-(z1- ...
          b)./m).^4-60.*d2.*(z1-b).^2./m.^3.*(1-(z1-b)./m).^3+60.*d3.*(z1- ...
          b).^2./m.^3.*(1-(z1-b)./m).^3-60.*d3.*(z1-b).^3./m.^4.*(1-(z1- ...
          b)./m).^2+60.*d4.*(z1-b).^3./m.^4.*(1-(z1-b)./m).^2-30.*d4.*(z1- ...
          b).^4./m.^5.*(1-(z1-b)./m)+30.*d5.*(z1-b).^4./m.^5.*(1-(z1- ...
          b)./m)-6.*d5.*(z1-b).^5./m.^6+6.*d6.*(z1-b).^5./m.^6;

beta = -g.*(Lb1.*L3.*sin(-hd2+hd1+1./2.*hd3+z1).*M4+2.*Lb1.*L4.* ...
       sin(1./2.*hd3-z1).*M3-Lb1.*L3.*sin(1./2.*hd3+z1).*M1+Lb1.*L4.* ...
       sin(1./2.*hd3-z1).*M1-Lb1.*L3.*sin(1./2.*hd3+z1).*M4+2.*Lb1.*L4.* ...
       sin(1./2.*hd3-z1).*M4+Lb1.*cos(-hd2+hd1+1./2.*hd3+z1).*MY3+Lb1.* ...
       cos(1./2.*hd3+z1).*MY3+Lb1.*cos(-hd2-hd4+hd1+1./2.*hd3+z1).*MY4+ ...
       Lb1.*cos(1./2.*hd3-z1).*MY4+Lb1.*sin(1./2.*hd3+z1).*MZ3-Lb1.* ...
       sin(1./2.*hd3-z1).*MZ4+Lb1.*cos(hd1+1./2.*hd3+z1).*MY1+PEwc.*L4.* ...
       sin(1./2.*hd3-z1)+Lb1.*sin(-hd2+hd1+1./2.*hd3+z1).*MZ3+PEcc.*L4.* ...
       sin(1./2.*hd3-z1)-PEcc.*L3.*sin(1./2.*hd3+z1)+Lb1.*sin(-hd2-hd4+ ...
       hd1+1./2.*hd3+z1).*MZ4-PEbc.*L3.*sin(1./2.*hd3+z1)+PEbc.*L4.* ...
       sin(1./2.*hd3-z1)+Lb1.*sin(hd1+1./2.*hd3+z1).*MZ1-PEwc.*L3.* ...
       sin(1./2.*hd3+z1)-2.*Lb1.*L3.*sin(1./2.*hd3+z1).*M3)./Lb1;