function [cmh,cmv,dcmh,dcmv,acmh,acmv] = center_of_mass_red(x,ddq)
% CENTER_OF_MASS_RED
%   [CMH,CMV,DCMH,DCMV,ACMH,ACMV] = CENTER_OF_MASS_RED(X,DDQ)  

%Eric Westervelt
%04-Mar-2003 10:28:49

modelP;

[nn,mm] = size(x);

if nn ~= 1 & mm ~= 1
  cmh = (L3.*sin(x(:,1)+x(:,5)).*M1+L4.*sin(x(:,1)+x(:,3)+x(:,5)).*M1+ ...
        cos(x(:,5)).*MY1-sin(x(:,5)).*MZ1+2.*L3.*sin(x(:,1)+x(:,5)).*M3+ ...
        2.*L4.*sin(x(:,1)+x(:,3)+x(:,5)).*M3+cos(x(:,1)+x(:,5)).*MY3- ...
        sin(x(:,1)+x(:,5)).*MZ3+cos(x(:,2)+x(:,5)).*MY3-sin(x(:,2)+ ...
        x(:,5)).*MZ3+2.*L4.*sin(x(:,1)+x(:,3)+x(:,5)).*M4+cos(x(:,1)+ ...
        x(:,3)+x(:,5)).*MY4-sin(x(:,1)+x(:,3)+x(:,5)).*MZ4+L3.* ...
        sin(x(:,1)+x(:,5)).*M4-L3.*sin(x(:,2)+x(:,5)).*M4+cos(x(:,2)+ ...
        x(:,4)+x(:,5)).*MY4-sin(x(:,2)+x(:,4)+x(:,5)).*MZ4)./(M1+2.*M3+ ...
        2.*M4);
  cmv = (-L3.*cos(x(:,1)+x(:,5)).*M1-L4.*cos(x(:,1)+x(:,3)+x(:,5)).*M1+ ...
        sin(x(:,5)).*MY1+cos(x(:,5)).*MZ1-2.*L3.*cos(x(:,1)+x(:,5)).*M3- ...
        2.*L4.*cos(x(:,1)+x(:,3)+x(:,5)).*M3+sin(x(:,1)+x(:,5)).*MY3+ ...
        cos(x(:,1)+x(:,5)).*MZ3+sin(x(:,2)+x(:,5)).*MY3+cos(x(:,2)+ ...
        x(:,5)).*MZ3-2.*L4.*cos(x(:,1)+x(:,3)+x(:,5)).*M4+sin(x(:,1)+ ...
        x(:,3)+x(:,5)).*MY4+cos(x(:,1)+x(:,3)+x(:,5)).*MZ4-L3.* ...
        cos(x(:,1)+x(:,5)).*M4+L3.*cos(x(:,2)+x(:,5)).*M4+sin(x(:,2)+ ...
        x(:,4)+x(:,5)).*MY4+cos(x(:,2)+x(:,4)+x(:,5)).*MZ4)./(M1+2.*M3+ ...
        2.*M4);
  dcmh = (L3.*cos(x(:,1)+x(:,5)).*M1+L4.*cos(x(:,1)+x(:,3)+x(:,5)).*M1+2.* ...
         L3.*cos(x(:,1)+x(:,5)).*M3+2.*L4.*cos(x(:,1)+x(:,3)+x(:,5)).*M3- ...
         sin(x(:,1)+x(:,5)).*MY3-cos(x(:,1)+x(:,5)).*MZ3+2.*L4.* ...
         cos(x(:,1)+x(:,3)+x(:,5)).*M4-sin(x(:,1)+x(:,3)+x(:,5)).*MY4- ...
         cos(x(:,1)+x(:,3)+x(:,5)).*MZ4+L3.*cos(x(:,1)+x(:,5)).*M4)./(M1+ ...
         2.*M3+2.*M4).*x(:,6)+(-sin(x(:,2)+x(:,5)).*MY3-cos(x(:,2)+ ...
         x(:,5)).*MZ3-L3.*cos(x(:,2)+x(:,5)).*M4-sin(x(:,2)+x(:,4)+ ...
         x(:,5)).*MY4-cos(x(:,2)+x(:,4)+x(:,5)).*MZ4)./(M1+2.*M3+2.*M4).* ...
         x(:,7)+(L4.*cos(x(:,1)+x(:,3)+x(:,5)).*M1+2.*L4.*cos(x(:,1)+ ...
         x(:,3)+x(:,5)).*M3+2.*L4.*cos(x(:,1)+x(:,3)+x(:,5)).*M4- ...
         sin(x(:,1)+x(:,3)+x(:,5)).*MY4-cos(x(:,1)+x(:,3)+x(:,5)).* ...
         MZ4)./(M1+2.*M3+2.*M4).*x(:,8)+(-sin(x(:,2)+x(:,4)+x(:,5)).*MY4- ...
         cos(x(:,2)+x(:,4)+x(:,5)).*MZ4)./(M1+2.*M3+2.*M4).*x(:,9)+(L3.* ...
         cos(x(:,1)+x(:,5)).*M1+L4.*cos(x(:,1)+x(:,3)+x(:,5)).*M1- ...
         sin(x(:,5)).*MY1-cos(x(:,5)).*MZ1+2.*L3.*cos(x(:,1)+x(:,5)).*M3+ ...
         2.*L4.*cos(x(:,1)+x(:,3)+x(:,5)).*M3-sin(x(:,1)+x(:,5)).*MY3- ...
         cos(x(:,1)+x(:,5)).*MZ3-sin(x(:,2)+x(:,5)).*MY3-cos(x(:,2)+ ...
         x(:,5)).*MZ3+2.*L4.*cos(x(:,1)+x(:,3)+x(:,5)).*M4-sin(x(:,1)+ ...
         x(:,3)+x(:,5)).*MY4-cos(x(:,1)+x(:,3)+x(:,5)).*MZ4+L3.* ...
         cos(x(:,1)+x(:,5)).*M4-L3.*cos(x(:,2)+x(:,5)).*M4-sin(x(:,2)+ ...
         x(:,4)+x(:,5)).*MY4-cos(x(:,2)+x(:,4)+x(:,5)).*MZ4)./(M1+2.*M3+ ...
         2.*M4).*x(:,10);
  dcmv = (L3.*sin(x(:,1)+x(:,5)).*M1+L4.*sin(x(:,1)+x(:,3)+x(:,5)).*M1+2.* ...
         L3.*sin(x(:,1)+x(:,5)).*M3+2.*L4.*sin(x(:,1)+x(:,3)+x(:,5)).*M3+ ...
         cos(x(:,1)+x(:,5)).*MY3-sin(x(:,1)+x(:,5)).*MZ3+2.*L4.* ...
         sin(x(:,1)+x(:,3)+x(:,5)).*M4+cos(x(:,1)+x(:,3)+x(:,5)).*MY4- ...
         sin(x(:,1)+x(:,3)+x(:,5)).*MZ4+L3.*sin(x(:,1)+x(:,5)).*M4)./(M1+ ...
         2.*M3+2.*M4).*x(:,6)+(cos(x(:,2)+x(:,5)).*MY3-sin(x(:,2)+ ...
         x(:,5)).*MZ3-L3.*sin(x(:,2)+x(:,5)).*M4+cos(x(:,2)+x(:,4)+ ...
         x(:,5)).*MY4-sin(x(:,2)+x(:,4)+x(:,5)).*MZ4)./(M1+2.*M3+2.*M4).* ...
         x(:,7)+(L4.*sin(x(:,1)+x(:,3)+x(:,5)).*M1+2.*L4.*sin(x(:,1)+ ...
         x(:,3)+x(:,5)).*M3+2.*L4.*sin(x(:,1)+x(:,3)+x(:,5)).*M4+ ...
         cos(x(:,1)+x(:,3)+x(:,5)).*MY4-sin(x(:,1)+x(:,3)+x(:,5)).* ...
         MZ4)./(M1+2.*M3+2.*M4).*x(:,8)+(cos(x(:,2)+x(:,4)+x(:,5)).*MY4- ...
         sin(x(:,2)+x(:,4)+x(:,5)).*MZ4)./(M1+2.*M3+2.*M4).*x(:,9)+(L3.* ...
         sin(x(:,1)+x(:,5)).*M1+L4.*sin(x(:,1)+x(:,3)+x(:,5)).*M1+ ...
         cos(x(:,5)).*MY1-sin(x(:,5)).*MZ1+2.*L3.*sin(x(:,1)+x(:,5)).*M3+ ...
         2.*L4.*sin(x(:,1)+x(:,3)+x(:,5)).*M3+cos(x(:,1)+x(:,5)).*MY3- ...
         sin(x(:,1)+x(:,5)).*MZ3+cos(x(:,2)+x(:,5)).*MY3-sin(x(:,2)+ ...
         x(:,5)).*MZ3+2.*L4.*sin(x(:,1)+x(:,3)+x(:,5)).*M4+cos(x(:,1)+ ...
         x(:,3)+x(:,5)).*MY4-sin(x(:,1)+x(:,3)+x(:,5)).*MZ4+L3.* ...
         sin(x(:,1)+x(:,5)).*M4-L3.*sin(x(:,2)+x(:,5)).*M4+cos(x(:,2)+ ...
         x(:,4)+x(:,5)).*MY4-sin(x(:,2)+x(:,4)+x(:,5)).*MZ4)./(M1+2.*M3+ ...
         2.*M4).*x(:,10);
  if nargin > 1
    acmh = ((-L3.*sin(x(:,1)+x(:,5)).*M1-L4.*sin(x(:,1)+x(:,3)+x(:,5)).*M1- ...
           2.*L3.*sin(x(:,1)+x(:,5)).*M3-2.*L4.*sin(x(:,1)+x(:,3)+x(:,5)).* ...
           M3-cos(x(:,1)+x(:,5)).*MY3+sin(x(:,1)+x(:,5)).*MZ3-2.*L4.* ...
           sin(x(:,1)+x(:,3)+x(:,5)).*M4-cos(x(:,1)+x(:,3)+x(:,5)).*MY4+ ...
           sin(x(:,1)+x(:,3)+x(:,5)).*MZ4-L3.*sin(x(:,1)+x(:,5)).*M4)./(M1+ ...
           2.*M3+2.*M4).*x(:,6)+(-L4.*sin(x(:,1)+x(:,3)+x(:,5)).*M1-2.*L4.* ...
           sin(x(:,1)+x(:,3)+x(:,5)).*M3-2.*L4.*sin(x(:,1)+x(:,3)+x(:,5)).* ...
           M4-cos(x(:,1)+x(:,3)+x(:,5)).*MY4+sin(x(:,1)+x(:,3)+x(:,5)).* ...
           MZ4)./(M1+2.*M3+2.*M4).*x(:,8)+(-L3.*sin(x(:,1)+x(:,5)).*M1-L4.* ...
           sin(x(:,1)+x(:,3)+x(:,5)).*M1-2.*L3.*sin(x(:,1)+x(:,5)).*M3-2.* ...
           L4.*sin(x(:,1)+x(:,3)+x(:,5)).*M3-cos(x(:,1)+x(:,5)).*MY3+ ...
           sin(x(:,1)+x(:,5)).*MZ3-2.*L4.*sin(x(:,1)+x(:,3)+x(:,5)).*M4- ...
           cos(x(:,1)+x(:,3)+x(:,5)).*MY4+sin(x(:,1)+x(:,3)+x(:,5)).*MZ4- ...
           L3.*sin(x(:,1)+x(:,5)).*M4)./(M1+2.*M3+2.*M4).*x(:,10)).*x(:,6)+ ...
           ((-cos(x(:,2)+x(:,5)).*MY3+sin(x(:,2)+x(:,5)).*MZ3+L3.* ...
           sin(x(:,2)+x(:,5)).*M4-cos(x(:,2)+x(:,4)+x(:,5)).*MY4+sin(x(:,2)+ ...
           x(:,4)+x(:,5)).*MZ4)./(M1+2.*M3+2.*M4).*x(:,7)+(-cos(x(:,2)+ ...
           x(:,4)+x(:,5)).*MY4+sin(x(:,2)+x(:,4)+x(:,5)).*MZ4)./(M1+2.*M3+ ...
           2.*M4).*x(:,9)+(-cos(x(:,2)+x(:,5)).*MY3+sin(x(:,2)+x(:,5)).*MZ3+ ...
           L3.*sin(x(:,2)+x(:,5)).*M4-cos(x(:,2)+x(:,4)+x(:,5)).*MY4+ ...
           sin(x(:,2)+x(:,4)+x(:,5)).*MZ4)./(M1+2.*M3+2.*M4).*x(:,10)).* ...
           x(:,7)+((-L4.*sin(x(:,1)+x(:,3)+x(:,5)).*M1-2.*L4.*sin(x(:,1)+ ...
           x(:,3)+x(:,5)).*M3-2.*L4.*sin(x(:,1)+x(:,3)+x(:,5)).*M4- ...
           cos(x(:,1)+x(:,3)+x(:,5)).*MY4+sin(x(:,1)+x(:,3)+x(:,5)).* ...
           MZ4)./(M1+2.*M3+2.*M4).*x(:,6)+(-L4.*sin(x(:,1)+x(:,3)+x(:,5)).* ...
           M1-2.*L4.*sin(x(:,1)+x(:,3)+x(:,5)).*M3-2.*L4.*sin(x(:,1)+x(:,3)+ ...
           x(:,5)).*M4-cos(x(:,1)+x(:,3)+x(:,5)).*MY4+sin(x(:,1)+x(:,3)+ ...
           x(:,5)).*MZ4)./(M1+2.*M3+2.*M4).*x(:,8)+(-L4.*sin(x(:,1)+x(:,3)+ ...
           x(:,5)).*M1-2.*L4.*sin(x(:,1)+x(:,3)+x(:,5)).*M3-2.*L4.* ...
           sin(x(:,1)+x(:,3)+x(:,5)).*M4-cos(x(:,1)+x(:,3)+x(:,5)).*MY4+ ...
           sin(x(:,1)+x(:,3)+x(:,5)).*MZ4)./(M1+2.*M3+2.*M4).*x(:,10)).* ...
           x(:,8)+((-cos(x(:,2)+x(:,4)+x(:,5)).*MY4+sin(x(:,2)+x(:,4)+ ...
           x(:,5)).*MZ4)./(M1+2.*M3+2.*M4).*x(:,7)+(-cos(x(:,2)+x(:,4)+ ...
           x(:,5)).*MY4+sin(x(:,2)+x(:,4)+x(:,5)).*MZ4)./(M1+2.*M3+2.*M4).* ...
           x(:,9)+(-cos(x(:,2)+x(:,4)+x(:,5)).*MY4+sin(x(:,2)+x(:,4)+ ...
           x(:,5)).*MZ4)./(M1+2.*M3+2.*M4).*x(:,10)).*x(:,9)+((-L3.* ...
           sin(x(:,1)+x(:,5)).*M1-L4.*sin(x(:,1)+x(:,3)+x(:,5)).*M1-2.*L3.* ...
           sin(x(:,1)+x(:,5)).*M3-2.*L4.*sin(x(:,1)+x(:,3)+x(:,5)).*M3- ...
           cos(x(:,1)+x(:,5)).*MY3+sin(x(:,1)+x(:,5)).*MZ3-2.*L4.* ...
           sin(x(:,1)+x(:,3)+x(:,5)).*M4-cos(x(:,1)+x(:,3)+x(:,5)).*MY4+ ...
           sin(x(:,1)+x(:,3)+x(:,5)).*MZ4-L3.*sin(x(:,1)+x(:,5)).*M4)./(M1+ ...
           2.*M3+2.*M4).*x(:,6)+(-cos(x(:,2)+x(:,5)).*MY3+sin(x(:,2)+ ...
           x(:,5)).*MZ3+L3.*sin(x(:,2)+x(:,5)).*M4-cos(x(:,2)+x(:,4)+ ...
           x(:,5)).*MY4+sin(x(:,2)+x(:,4)+x(:,5)).*MZ4)./(M1+2.*M3+2.*M4).* ...
           x(:,7)+(-L4.*sin(x(:,1)+x(:,3)+x(:,5)).*M1-2.*L4.*sin(x(:,1)+ ...
           x(:,3)+x(:,5)).*M3-2.*L4.*sin(x(:,1)+x(:,3)+x(:,5)).*M4- ...
           cos(x(:,1)+x(:,3)+x(:,5)).*MY4+sin(x(:,1)+x(:,3)+x(:,5)).* ...
           MZ4)./(M1+2.*M3+2.*M4).*x(:,8)+(-cos(x(:,2)+x(:,4)+x(:,5)).*MY4+ ...
           sin(x(:,2)+x(:,4)+x(:,5)).*MZ4)./(M1+2.*M3+2.*M4).*x(:,9)+(-L3.* ...
           sin(x(:,1)+x(:,5)).*M1-L4.*sin(x(:,1)+x(:,3)+x(:,5)).*M1- ...
           cos(x(:,5)).*MY1+sin(x(:,5)).*MZ1-2.*L3.*sin(x(:,1)+x(:,5)).*M3- ...
           2.*L4.*sin(x(:,1)+x(:,3)+x(:,5)).*M3-cos(x(:,1)+x(:,5)).*MY3+ ...
           sin(x(:,1)+x(:,5)).*MZ3-cos(x(:,2)+x(:,5)).*MY3+sin(x(:,2)+ ...
           x(:,5)).*MZ3-2.*L4.*sin(x(:,1)+x(:,3)+x(:,5)).*M4-cos(x(:,1)+ ...
           x(:,3)+x(:,5)).*MY4+sin(x(:,1)+x(:,3)+x(:,5)).*MZ4-L3.* ...
           sin(x(:,1)+x(:,5)).*M4+L3.*sin(x(:,2)+x(:,5)).*M4-cos(x(:,2)+ ...
           x(:,4)+x(:,5)).*MY4+sin(x(:,2)+x(:,4)+x(:,5)).*MZ4)./(M1+2.*M3+ ...
           2.*M4).*x(:,10)).*x(:,10)+(L3.*cos(x(:,1)+x(:,5)).*M1+L4.* ...
           cos(x(:,1)+x(:,3)+x(:,5)).*M1+2.*L3.*cos(x(:,1)+x(:,5)).*M3+2.* ...
           L4.*cos(x(:,1)+x(:,3)+x(:,5)).*M3-sin(x(:,1)+x(:,5)).*MY3- ...
           cos(x(:,1)+x(:,5)).*MZ3+2.*L4.*cos(x(:,1)+x(:,3)+x(:,5)).*M4- ...
           sin(x(:,1)+x(:,3)+x(:,5)).*MY4-cos(x(:,1)+x(:,3)+x(:,5)).*MZ4+ ...
           L3.*cos(x(:,1)+x(:,5)).*M4)./(M1+2.*M3+2.*M4).*ddq(:,1)+(- ...
           sin(x(:,2)+x(:,5)).*MY3-cos(x(:,2)+x(:,5)).*MZ3-L3.*cos(x(:,2)+ ...
           x(:,5)).*M4-sin(x(:,2)+x(:,4)+x(:,5)).*MY4-cos(x(:,2)+x(:,4)+ ...
           x(:,5)).*MZ4)./(M1+2.*M3+2.*M4).*ddq(:,2)+(L4.*cos(x(:,1)+x(:,3)+ ...
           x(:,5)).*M1+2.*L4.*cos(x(:,1)+x(:,3)+x(:,5)).*M3+2.*L4.* ...
           cos(x(:,1)+x(:,3)+x(:,5)).*M4-sin(x(:,1)+x(:,3)+x(:,5)).*MY4- ...
           cos(x(:,1)+x(:,3)+x(:,5)).*MZ4)./(M1+2.*M3+2.*M4).*ddq(:,3)+(- ...
           sin(x(:,2)+x(:,4)+x(:,5)).*MY4-cos(x(:,2)+x(:,4)+x(:,5)).* ...
           MZ4)./(M1+2.*M3+2.*M4).*ddq(:,4)+(L3.*cos(x(:,1)+x(:,5)).*M1+L4.* ...
           cos(x(:,1)+x(:,3)+x(:,5)).*M1-sin(x(:,5)).*MY1-cos(x(:,5)).*MZ1+ ...
           2.*L3.*cos(x(:,1)+x(:,5)).*M3+2.*L4.*cos(x(:,1)+x(:,3)+x(:,5)).* ...
           M3-sin(x(:,1)+x(:,5)).*MY3-cos(x(:,1)+x(:,5)).*MZ3-sin(x(:,2)+ ...
           x(:,5)).*MY3-cos(x(:,2)+x(:,5)).*MZ3+2.*L4.*cos(x(:,1)+x(:,3)+ ...
           x(:,5)).*M4-sin(x(:,1)+x(:,3)+x(:,5)).*MY4-cos(x(:,1)+x(:,3)+ ...
           x(:,5)).*MZ4+L3.*cos(x(:,1)+x(:,5)).*M4-L3.*cos(x(:,2)+x(:,5)).* ...
           M4-sin(x(:,2)+x(:,4)+x(:,5)).*MY4-cos(x(:,2)+x(:,4)+x(:,5)).* ...
           MZ4)./(M1+2.*M3+2.*M4).*ddq(:,5);
    acmv = ((L3.*cos(x(:,1)+x(:,5)).*M1+L4.*cos(x(:,1)+x(:,3)+x(:,5)).*M1+ ...
           2.*L3.*cos(x(:,1)+x(:,5)).*M3+2.*L4.*cos(x(:,1)+x(:,3)+x(:,5)).* ...
           M3-sin(x(:,1)+x(:,5)).*MY3-cos(x(:,1)+x(:,5)).*MZ3+2.*L4.* ...
           cos(x(:,1)+x(:,3)+x(:,5)).*M4-sin(x(:,1)+x(:,3)+x(:,5)).*MY4- ...
           cos(x(:,1)+x(:,3)+x(:,5)).*MZ4+L3.*cos(x(:,1)+x(:,5)).*M4)./(M1+ ...
           2.*M3+2.*M4).*x(:,6)+(L4.*cos(x(:,1)+x(:,3)+x(:,5)).*M1+2.*L4.* ...
           cos(x(:,1)+x(:,3)+x(:,5)).*M3+2.*L4.*cos(x(:,1)+x(:,3)+x(:,5)).* ...
           M4-sin(x(:,1)+x(:,3)+x(:,5)).*MY4-cos(x(:,1)+x(:,3)+x(:,5)).* ...
           MZ4)./(M1+2.*M3+2.*M4).*x(:,8)+(L3.*cos(x(:,1)+x(:,5)).*M1+L4.* ...
           cos(x(:,1)+x(:,3)+x(:,5)).*M1+2.*L3.*cos(x(:,1)+x(:,5)).*M3+2.* ...
           L4.*cos(x(:,1)+x(:,3)+x(:,5)).*M3-sin(x(:,1)+x(:,5)).*MY3- ...
           cos(x(:,1)+x(:,5)).*MZ3+2.*L4.*cos(x(:,1)+x(:,3)+x(:,5)).*M4- ...
           sin(x(:,1)+x(:,3)+x(:,5)).*MY4-cos(x(:,1)+x(:,3)+x(:,5)).*MZ4+ ...
           L3.*cos(x(:,1)+x(:,5)).*M4)./(M1+2.*M3+2.*M4).*x(:,10)).*x(:,6)+ ...
           ((-sin(x(:,2)+x(:,5)).*MY3-cos(x(:,2)+x(:,5)).*MZ3-L3.* ...
           cos(x(:,2)+x(:,5)).*M4-sin(x(:,2)+x(:,4)+x(:,5)).*MY4-cos(x(:,2)+ ...
           x(:,4)+x(:,5)).*MZ4)./(M1+2.*M3+2.*M4).*x(:,7)+(-sin(x(:,2)+ ...
           x(:,4)+x(:,5)).*MY4-cos(x(:,2)+x(:,4)+x(:,5)).*MZ4)./(M1+2.*M3+ ...
           2.*M4).*x(:,9)+(-sin(x(:,2)+x(:,5)).*MY3-cos(x(:,2)+x(:,5)).*MZ3- ...
           L3.*cos(x(:,2)+x(:,5)).*M4-sin(x(:,2)+x(:,4)+x(:,5)).*MY4- ...
           cos(x(:,2)+x(:,4)+x(:,5)).*MZ4)./(M1+2.*M3+2.*M4).*x(:,10)).* ...
           x(:,7)+((L4.*cos(x(:,1)+x(:,3)+x(:,5)).*M1+2.*L4.*cos(x(:,1)+ ...
           x(:,3)+x(:,5)).*M3+2.*L4.*cos(x(:,1)+x(:,3)+x(:,5)).*M4- ...
           sin(x(:,1)+x(:,3)+x(:,5)).*MY4-cos(x(:,1)+x(:,3)+x(:,5)).* ...
           MZ4)./(M1+2.*M3+2.*M4).*x(:,6)+(L4.*cos(x(:,1)+x(:,3)+x(:,5)).* ...
           M1+2.*L4.*cos(x(:,1)+x(:,3)+x(:,5)).*M3+2.*L4.*cos(x(:,1)+x(:,3)+ ...
           x(:,5)).*M4-sin(x(:,1)+x(:,3)+x(:,5)).*MY4-cos(x(:,1)+x(:,3)+ ...
           x(:,5)).*MZ4)./(M1+2.*M3+2.*M4).*x(:,8)+(L4.*cos(x(:,1)+x(:,3)+ ...
           x(:,5)).*M1+2.*L4.*cos(x(:,1)+x(:,3)+x(:,5)).*M3+2.*L4.* ...
           cos(x(:,1)+x(:,3)+x(:,5)).*M4-sin(x(:,1)+x(:,3)+x(:,5)).*MY4- ...
           cos(x(:,1)+x(:,3)+x(:,5)).*MZ4)./(M1+2.*M3+2.*M4).*x(:,10)).* ...
           x(:,8)+((-sin(x(:,2)+x(:,4)+x(:,5)).*MY4-cos(x(:,2)+x(:,4)+ ...
           x(:,5)).*MZ4)./(M1+2.*M3+2.*M4).*x(:,7)+(-sin(x(:,2)+x(:,4)+ ...
           x(:,5)).*MY4-cos(x(:,2)+x(:,4)+x(:,5)).*MZ4)./(M1+2.*M3+2.*M4).* ...
           x(:,9)+(-sin(x(:,2)+x(:,4)+x(:,5)).*MY4-cos(x(:,2)+x(:,4)+ ...
           x(:,5)).*MZ4)./(M1+2.*M3+2.*M4).*x(:,10)).*x(:,9)+((L3.* ...
           cos(x(:,1)+x(:,5)).*M1+L4.*cos(x(:,1)+x(:,3)+x(:,5)).*M1+2.*L3.* ...
           cos(x(:,1)+x(:,5)).*M3+2.*L4.*cos(x(:,1)+x(:,3)+x(:,5)).*M3- ...
           sin(x(:,1)+x(:,5)).*MY3-cos(x(:,1)+x(:,5)).*MZ3+2.*L4.* ...
           cos(x(:,1)+x(:,3)+x(:,5)).*M4-sin(x(:,1)+x(:,3)+x(:,5)).*MY4- ...
           cos(x(:,1)+x(:,3)+x(:,5)).*MZ4+L3.*cos(x(:,1)+x(:,5)).*M4)./(M1+ ...
           2.*M3+2.*M4).*x(:,6)+(-sin(x(:,2)+x(:,5)).*MY3-cos(x(:,2)+ ...
           x(:,5)).*MZ3-L3.*cos(x(:,2)+x(:,5)).*M4-sin(x(:,2)+x(:,4)+ ...
           x(:,5)).*MY4-cos(x(:,2)+x(:,4)+x(:,5)).*MZ4)./(M1+2.*M3+2.*M4).* ...
           x(:,7)+(L4.*cos(x(:,1)+x(:,3)+x(:,5)).*M1+2.*L4.*cos(x(:,1)+ ...
           x(:,3)+x(:,5)).*M3+2.*L4.*cos(x(:,1)+x(:,3)+x(:,5)).*M4- ...
           sin(x(:,1)+x(:,3)+x(:,5)).*MY4-cos(x(:,1)+x(:,3)+x(:,5)).* ...
           MZ4)./(M1+2.*M3+2.*M4).*x(:,8)+(-sin(x(:,2)+x(:,4)+x(:,5)).*MY4- ...
           cos(x(:,2)+x(:,4)+x(:,5)).*MZ4)./(M1+2.*M3+2.*M4).*x(:,9)+(L3.* ...
           cos(x(:,1)+x(:,5)).*M1+L4.*cos(x(:,1)+x(:,3)+x(:,5)).*M1- ...
           sin(x(:,5)).*MY1-cos(x(:,5)).*MZ1+2.*L3.*cos(x(:,1)+x(:,5)).*M3+ ...
           2.*L4.*cos(x(:,1)+x(:,3)+x(:,5)).*M3-sin(x(:,1)+x(:,5)).*MY3- ...
           cos(x(:,1)+x(:,5)).*MZ3-sin(x(:,2)+x(:,5)).*MY3-cos(x(:,2)+ ...
           x(:,5)).*MZ3+2.*L4.*cos(x(:,1)+x(:,3)+x(:,5)).*M4-sin(x(:,1)+ ...
           x(:,3)+x(:,5)).*MY4-cos(x(:,1)+x(:,3)+x(:,5)).*MZ4+L3.* ...
           cos(x(:,1)+x(:,5)).*M4-L3.*cos(x(:,2)+x(:,5)).*M4-sin(x(:,2)+ ...
           x(:,4)+x(:,5)).*MY4-cos(x(:,2)+x(:,4)+x(:,5)).*MZ4)./(M1+2.*M3+ ...
           2.*M4).*x(:,10)).*x(:,10)+(L3.*sin(x(:,1)+x(:,5)).*M1+L4.* ...
           sin(x(:,1)+x(:,3)+x(:,5)).*M1+2.*L3.*sin(x(:,1)+x(:,5)).*M3+2.* ...
           L4.*sin(x(:,1)+x(:,3)+x(:,5)).*M3+cos(x(:,1)+x(:,5)).*MY3- ...
           sin(x(:,1)+x(:,5)).*MZ3+2.*L4.*sin(x(:,1)+x(:,3)+x(:,5)).*M4+ ...
           cos(x(:,1)+x(:,3)+x(:,5)).*MY4-sin(x(:,1)+x(:,3)+x(:,5)).*MZ4+ ...
           L3.*sin(x(:,1)+x(:,5)).*M4)./(M1+2.*M3+2.*M4).*ddq(:,1)+ ...
           (cos(x(:,2)+x(:,5)).*MY3-sin(x(:,2)+x(:,5)).*MZ3-L3.*sin(x(:,2)+ ...
           x(:,5)).*M4+cos(x(:,2)+x(:,4)+x(:,5)).*MY4-sin(x(:,2)+x(:,4)+ ...
           x(:,5)).*MZ4)./(M1+2.*M3+2.*M4).*ddq(:,2)+(L4.*sin(x(:,1)+x(:,3)+ ...
           x(:,5)).*M1+2.*L4.*sin(x(:,1)+x(:,3)+x(:,5)).*M3+2.*L4.* ...
           sin(x(:,1)+x(:,3)+x(:,5)).*M4+cos(x(:,1)+x(:,3)+x(:,5)).*MY4- ...
           sin(x(:,1)+x(:,3)+x(:,5)).*MZ4)./(M1+2.*M3+2.*M4).*ddq(:,3)+ ...
           (cos(x(:,2)+x(:,4)+x(:,5)).*MY4-sin(x(:,2)+x(:,4)+x(:,5)).* ...
           MZ4)./(M1+2.*M3+2.*M4).*ddq(:,4)+(L3.*sin(x(:,1)+x(:,5)).*M1+L4.* ...
           sin(x(:,1)+x(:,3)+x(:,5)).*M1+cos(x(:,5)).*MY1-sin(x(:,5)).*MZ1+ ...
           2.*L3.*sin(x(:,1)+x(:,5)).*M3+2.*L4.*sin(x(:,1)+x(:,3)+x(:,5)).* ...
           M3+cos(x(:,1)+x(:,5)).*MY3-sin(x(:,1)+x(:,5)).*MZ3+cos(x(:,2)+ ...
           x(:,5)).*MY3-sin(x(:,2)+x(:,5)).*MZ3+2.*L4.*sin(x(:,1)+x(:,3)+ ...
           x(:,5)).*M4+cos(x(:,1)+x(:,3)+x(:,5)).*MY4-sin(x(:,1)+x(:,3)+ ...
           x(:,5)).*MZ4+L3.*sin(x(:,1)+x(:,5)).*M4-L3.*sin(x(:,2)+x(:,5)).* ...
           M4+cos(x(:,2)+x(:,4)+x(:,5)).*MY4-sin(x(:,2)+x(:,4)+x(:,5)).* ...
           MZ4)./(M1+2.*M3+2.*M4).*ddq(:,5);
  end
else
  cmh = (L3*sin(x(1)+x(5))*M1+L4*sin(x(1)+x(3)+x(5))*M1+cos(x(5))*MY1- ...
        sin(x(5))*MZ1+2*L3*sin(x(1)+x(5))*M3+2*L4*sin(x(1)+x(3)+x(5))*M3+ ...
        cos(x(1)+x(5))*MY3-sin(x(1)+x(5))*MZ3+cos(x(2)+x(5))*MY3- ...
        sin(x(2)+x(5))*MZ3+2*L4*sin(x(1)+x(3)+x(5))*M4+cos(x(1)+x(3)+ ...
        x(5))*MY4-sin(x(1)+x(3)+x(5))*MZ4+L3*sin(x(1)+x(5))*M4-L3* ...
        sin(x(2)+x(5))*M4+cos(x(2)+x(4)+x(5))*MY4-sin(x(2)+x(4)+x(5))* ...
        MZ4)/(M1+2*M3+2*M4);
  cmv = (-L3*cos(x(1)+x(5))*M1-L4*cos(x(1)+x(3)+x(5))*M1+sin(x(5))*MY1+ ...
        cos(x(5))*MZ1-2*L3*cos(x(1)+x(5))*M3-2*L4*cos(x(1)+x(3)+x(5))*M3+ ...
        sin(x(1)+x(5))*MY3+cos(x(1)+x(5))*MZ3+sin(x(2)+x(5))*MY3+ ...
        cos(x(2)+x(5))*MZ3-2*L4*cos(x(1)+x(3)+x(5))*M4+sin(x(1)+x(3)+ ...
        x(5))*MY4+cos(x(1)+x(3)+x(5))*MZ4-L3*cos(x(1)+x(5))*M4+L3* ...
        cos(x(2)+x(5))*M4+sin(x(2)+x(4)+x(5))*MY4+cos(x(2)+x(4)+x(5))* ...
        MZ4)/(M1+2*M3+2*M4);
  dcmh = (L3*cos(x(1)+x(5))*M1+L4*cos(x(1)+x(3)+x(5))*M1+2*L3*cos(x(1)+ ...
         x(5))*M3+2*L4*cos(x(1)+x(3)+x(5))*M3-sin(x(1)+x(5))*MY3-cos(x(1)+ ...
         x(5))*MZ3+2*L4*cos(x(1)+x(3)+x(5))*M4-sin(x(1)+x(3)+x(5))*MY4- ...
         cos(x(1)+x(3)+x(5))*MZ4+L3*cos(x(1)+x(5))*M4)/(M1+2*M3+2*M4)* ...
         x(6)+(-sin(x(2)+x(5))*MY3-cos(x(2)+x(5))*MZ3-L3*cos(x(2)+x(5))* ...
         M4-sin(x(2)+x(4)+x(5))*MY4-cos(x(2)+x(4)+x(5))*MZ4)/(M1+2*M3+2* ...
         M4)*x(7)+(L4*cos(x(1)+x(3)+x(5))*M1+2*L4*cos(x(1)+x(3)+x(5))*M3+ ...
         2*L4*cos(x(1)+x(3)+x(5))*M4-sin(x(1)+x(3)+x(5))*MY4-cos(x(1)+ ...
         x(3)+x(5))*MZ4)/(M1+2*M3+2*M4)*x(8)+(-sin(x(2)+x(4)+x(5))*MY4- ...
         cos(x(2)+x(4)+x(5))*MZ4)/(M1+2*M3+2*M4)*x(9)+(L3*cos(x(1)+x(5))* ...
         M1+L4*cos(x(1)+x(3)+x(5))*M1-sin(x(5))*MY1-cos(x(5))*MZ1+2*L3* ...
         cos(x(1)+x(5))*M3+2*L4*cos(x(1)+x(3)+x(5))*M3-sin(x(1)+x(5))*MY3- ...
         cos(x(1)+x(5))*MZ3-sin(x(2)+x(5))*MY3-cos(x(2)+x(5))*MZ3+2*L4* ...
         cos(x(1)+x(3)+x(5))*M4-sin(x(1)+x(3)+x(5))*MY4-cos(x(1)+x(3)+ ...
         x(5))*MZ4+L3*cos(x(1)+x(5))*M4-L3*cos(x(2)+x(5))*M4-sin(x(2)+ ...
         x(4)+x(5))*MY4-cos(x(2)+x(4)+x(5))*MZ4)/(M1+2*M3+2*M4)*x(10);
  dcmv = (L3*sin(x(1)+x(5))*M1+L4*sin(x(1)+x(3)+x(5))*M1+2*L3*sin(x(1)+ ...
         x(5))*M3+2*L4*sin(x(1)+x(3)+x(5))*M3+cos(x(1)+x(5))*MY3-sin(x(1)+ ...
         x(5))*MZ3+2*L4*sin(x(1)+x(3)+x(5))*M4+cos(x(1)+x(3)+x(5))*MY4- ...
         sin(x(1)+x(3)+x(5))*MZ4+L3*sin(x(1)+x(5))*M4)/(M1+2*M3+2*M4)* ...
         x(6)+(cos(x(2)+x(5))*MY3-sin(x(2)+x(5))*MZ3-L3*sin(x(2)+x(5))*M4+ ...
         cos(x(2)+x(4)+x(5))*MY4-sin(x(2)+x(4)+x(5))*MZ4)/(M1+2*M3+2*M4)* ...
         x(7)+(L4*sin(x(1)+x(3)+x(5))*M1+2*L4*sin(x(1)+x(3)+x(5))*M3+2*L4* ...
         sin(x(1)+x(3)+x(5))*M4+cos(x(1)+x(3)+x(5))*MY4-sin(x(1)+x(3)+ ...
         x(5))*MZ4)/(M1+2*M3+2*M4)*x(8)+(cos(x(2)+x(4)+x(5))*MY4-sin(x(2)+ ...
         x(4)+x(5))*MZ4)/(M1+2*M3+2*M4)*x(9)+(L3*sin(x(1)+x(5))*M1+L4* ...
         sin(x(1)+x(3)+x(5))*M1+cos(x(5))*MY1-sin(x(5))*MZ1+2*L3*sin(x(1)+ ...
         x(5))*M3+2*L4*sin(x(1)+x(3)+x(5))*M3+cos(x(1)+x(5))*MY3-sin(x(1)+ ...
         x(5))*MZ3+cos(x(2)+x(5))*MY3-sin(x(2)+x(5))*MZ3+2*L4*sin(x(1)+ ...
         x(3)+x(5))*M4+cos(x(1)+x(3)+x(5))*MY4-sin(x(1)+x(3)+x(5))*MZ4+L3* ...
         sin(x(1)+x(5))*M4-L3*sin(x(2)+x(5))*M4+cos(x(2)+x(4)+x(5))*MY4- ...
         sin(x(2)+x(4)+x(5))*MZ4)/(M1+2*M3+2*M4)*x(10);
  if nargin > 1
    acmh = ((-L3*sin(x(1)+x(5))*M1-L4*sin(x(1)+x(3)+x(5))*M1-2*L3*sin(x(1)+ ...
           x(5))*M3-2*L4*sin(x(1)+x(3)+x(5))*M3-cos(x(1)+x(5))*MY3+sin(x(1)+ ...
           x(5))*MZ3-2*L4*sin(x(1)+x(3)+x(5))*M4-cos(x(1)+x(3)+x(5))*MY4+ ...
           sin(x(1)+x(3)+x(5))*MZ4-L3*sin(x(1)+x(5))*M4)/(M1+2*M3+2*M4)* ...
           x(6)+(-L4*sin(x(1)+x(3)+x(5))*M1-2*L4*sin(x(1)+x(3)+x(5))*M3-2* ...
           L4*sin(x(1)+x(3)+x(5))*M4-cos(x(1)+x(3)+x(5))*MY4+sin(x(1)+x(3)+ ...
           x(5))*MZ4)/(M1+2*M3+2*M4)*x(8)+(-L3*sin(x(1)+x(5))*M1-L4* ...
           sin(x(1)+x(3)+x(5))*M1-2*L3*sin(x(1)+x(5))*M3-2*L4*sin(x(1)+x(3)+ ...
           x(5))*M3-cos(x(1)+x(5))*MY3+sin(x(1)+x(5))*MZ3-2*L4*sin(x(1)+ ...
           x(3)+x(5))*M4-cos(x(1)+x(3)+x(5))*MY4+sin(x(1)+x(3)+x(5))*MZ4-L3* ...
           sin(x(1)+x(5))*M4)/(M1+2*M3+2*M4)*x(10))*x(6)+((-cos(x(2)+x(5))* ...
           MY3+sin(x(2)+x(5))*MZ3+L3*sin(x(2)+x(5))*M4-cos(x(2)+x(4)+x(5))* ...
           MY4+sin(x(2)+x(4)+x(5))*MZ4)/(M1+2*M3+2*M4)*x(7)+(-cos(x(2)+x(4)+ ...
           x(5))*MY4+sin(x(2)+x(4)+x(5))*MZ4)/(M1+2*M3+2*M4)*x(9)+(- ...
           cos(x(2)+x(5))*MY3+sin(x(2)+x(5))*MZ3+L3*sin(x(2)+x(5))*M4- ...
           cos(x(2)+x(4)+x(5))*MY4+sin(x(2)+x(4)+x(5))*MZ4)/(M1+2*M3+2*M4)* ...
           x(10))*x(7)+((-L4*sin(x(1)+x(3)+x(5))*M1-2*L4*sin(x(1)+x(3)+ ...
           x(5))*M3-2*L4*sin(x(1)+x(3)+x(5))*M4-cos(x(1)+x(3)+x(5))*MY4+ ...
           sin(x(1)+x(3)+x(5))*MZ4)/(M1+2*M3+2*M4)*x(6)+(-L4*sin(x(1)+x(3)+ ...
           x(5))*M1-2*L4*sin(x(1)+x(3)+x(5))*M3-2*L4*sin(x(1)+x(3)+x(5))*M4- ...
           cos(x(1)+x(3)+x(5))*MY4+sin(x(1)+x(3)+x(5))*MZ4)/(M1+2*M3+2*M4)* ...
           x(8)+(-L4*sin(x(1)+x(3)+x(5))*M1-2*L4*sin(x(1)+x(3)+x(5))*M3-2* ...
           L4*sin(x(1)+x(3)+x(5))*M4-cos(x(1)+x(3)+x(5))*MY4+sin(x(1)+x(3)+ ...
           x(5))*MZ4)/(M1+2*M3+2*M4)*x(10))*x(8)+((-cos(x(2)+x(4)+x(5))*MY4+ ...
           sin(x(2)+x(4)+x(5))*MZ4)/(M1+2*M3+2*M4)*x(7)+(-cos(x(2)+x(4)+ ...
           x(5))*MY4+sin(x(2)+x(4)+x(5))*MZ4)/(M1+2*M3+2*M4)*x(9)+(- ...
           cos(x(2)+x(4)+x(5))*MY4+sin(x(2)+x(4)+x(5))*MZ4)/(M1+2*M3+2*M4)* ...
           x(10))*x(9)+((-L3*sin(x(1)+x(5))*M1-L4*sin(x(1)+x(3)+x(5))*M1-2* ...
           L3*sin(x(1)+x(5))*M3-2*L4*sin(x(1)+x(3)+x(5))*M3-cos(x(1)+x(5))* ...
           MY3+sin(x(1)+x(5))*MZ3-2*L4*sin(x(1)+x(3)+x(5))*M4-cos(x(1)+x(3)+ ...
           x(5))*MY4+sin(x(1)+x(3)+x(5))*MZ4-L3*sin(x(1)+x(5))*M4)/(M1+2*M3+ ...
           2*M4)*x(6)+(-cos(x(2)+x(5))*MY3+sin(x(2)+x(5))*MZ3+L3*sin(x(2)+ ...
           x(5))*M4-cos(x(2)+x(4)+x(5))*MY4+sin(x(2)+x(4)+x(5))*MZ4)/(M1+2* ...
           M3+2*M4)*x(7)+(-L4*sin(x(1)+x(3)+x(5))*M1-2*L4*sin(x(1)+x(3)+ ...
           x(5))*M3-2*L4*sin(x(1)+x(3)+x(5))*M4-cos(x(1)+x(3)+x(5))*MY4+ ...
           sin(x(1)+x(3)+x(5))*MZ4)/(M1+2*M3+2*M4)*x(8)+(-cos(x(2)+x(4)+ ...
           x(5))*MY4+sin(x(2)+x(4)+x(5))*MZ4)/(M1+2*M3+2*M4)*x(9)+(-L3* ...
           sin(x(1)+x(5))*M1-L4*sin(x(1)+x(3)+x(5))*M1-cos(x(5))*MY1+ ...
           sin(x(5))*MZ1-2*L3*sin(x(1)+x(5))*M3-2*L4*sin(x(1)+x(3)+x(5))*M3- ...
           cos(x(1)+x(5))*MY3+sin(x(1)+x(5))*MZ3-cos(x(2)+x(5))*MY3+ ...
           sin(x(2)+x(5))*MZ3-2*L4*sin(x(1)+x(3)+x(5))*M4-cos(x(1)+x(3)+ ...
           x(5))*MY4+sin(x(1)+x(3)+x(5))*MZ4-L3*sin(x(1)+x(5))*M4+L3* ...
           sin(x(2)+x(5))*M4-cos(x(2)+x(4)+x(5))*MY4+sin(x(2)+x(4)+x(5))* ...
           MZ4)/(M1+2*M3+2*M4)*x(10))*x(10)+(L3*cos(x(1)+x(5))*M1+L4* ...
           cos(x(1)+x(3)+x(5))*M1+2*L3*cos(x(1)+x(5))*M3+2*L4*cos(x(1)+x(3)+ ...
           x(5))*M3-sin(x(1)+x(5))*MY3-cos(x(1)+x(5))*MZ3+2*L4*cos(x(1)+ ...
           x(3)+x(5))*M4-sin(x(1)+x(3)+x(5))*MY4-cos(x(1)+x(3)+x(5))*MZ4+L3* ...
           cos(x(1)+x(5))*M4)/(M1+2*M3+2*M4)*ddq(1)+(-sin(x(2)+x(5))*MY3- ...
           cos(x(2)+x(5))*MZ3-L3*cos(x(2)+x(5))*M4-sin(x(2)+x(4)+x(5))*MY4- ...
           cos(x(2)+x(4)+x(5))*MZ4)/(M1+2*M3+2*M4)*ddq(2)+(L4*cos(x(1)+x(3)+ ...
           x(5))*M1+2*L4*cos(x(1)+x(3)+x(5))*M3+2*L4*cos(x(1)+x(3)+x(5))*M4- ...
           sin(x(1)+x(3)+x(5))*MY4-cos(x(1)+x(3)+x(5))*MZ4)/(M1+2*M3+2*M4)* ...
           ddq(3)+(-sin(x(2)+x(4)+x(5))*MY4-cos(x(2)+x(4)+x(5))*MZ4)/(M1+2* ...
           M3+2*M4)*ddq(4)+(L3*cos(x(1)+x(5))*M1+L4*cos(x(1)+x(3)+x(5))*M1- ...
           sin(x(5))*MY1-cos(x(5))*MZ1+2*L3*cos(x(1)+x(5))*M3+2*L4*cos(x(1)+ ...
           x(3)+x(5))*M3-sin(x(1)+x(5))*MY3-cos(x(1)+x(5))*MZ3-sin(x(2)+ ...
           x(5))*MY3-cos(x(2)+x(5))*MZ3+2*L4*cos(x(1)+x(3)+x(5))*M4- ...
           sin(x(1)+x(3)+x(5))*MY4-cos(x(1)+x(3)+x(5))*MZ4+L3*cos(x(1)+ ...
           x(5))*M4-L3*cos(x(2)+x(5))*M4-sin(x(2)+x(4)+x(5))*MY4-cos(x(2)+ ...
           x(4)+x(5))*MZ4)/(M1+2*M3+2*M4)*ddq(5);
    acmv = ((L3*cos(x(1)+x(5))*M1+L4*cos(x(1)+x(3)+x(5))*M1+2*L3*cos(x(1)+ ...
           x(5))*M3+2*L4*cos(x(1)+x(3)+x(5))*M3-sin(x(1)+x(5))*MY3-cos(x(1)+ ...
           x(5))*MZ3+2*L4*cos(x(1)+x(3)+x(5))*M4-sin(x(1)+x(3)+x(5))*MY4- ...
           cos(x(1)+x(3)+x(5))*MZ4+L3*cos(x(1)+x(5))*M4)/(M1+2*M3+2*M4)* ...
           x(6)+(L4*cos(x(1)+x(3)+x(5))*M1+2*L4*cos(x(1)+x(3)+x(5))*M3+2*L4* ...
           cos(x(1)+x(3)+x(5))*M4-sin(x(1)+x(3)+x(5))*MY4-cos(x(1)+x(3)+ ...
           x(5))*MZ4)/(M1+2*M3+2*M4)*x(8)+(L3*cos(x(1)+x(5))*M1+L4*cos(x(1)+ ...
           x(3)+x(5))*M1+2*L3*cos(x(1)+x(5))*M3+2*L4*cos(x(1)+x(3)+x(5))*M3- ...
           sin(x(1)+x(5))*MY3-cos(x(1)+x(5))*MZ3+2*L4*cos(x(1)+x(3)+x(5))* ...
           M4-sin(x(1)+x(3)+x(5))*MY4-cos(x(1)+x(3)+x(5))*MZ4+L3*cos(x(1)+ ...
           x(5))*M4)/(M1+2*M3+2*M4)*x(10))*x(6)+((-sin(x(2)+x(5))*MY3- ...
           cos(x(2)+x(5))*MZ3-L3*cos(x(2)+x(5))*M4-sin(x(2)+x(4)+x(5))*MY4- ...
           cos(x(2)+x(4)+x(5))*MZ4)/(M1+2*M3+2*M4)*x(7)+(-sin(x(2)+x(4)+ ...
           x(5))*MY4-cos(x(2)+x(4)+x(5))*MZ4)/(M1+2*M3+2*M4)*x(9)+(- ...
           sin(x(2)+x(5))*MY3-cos(x(2)+x(5))*MZ3-L3*cos(x(2)+x(5))*M4- ...
           sin(x(2)+x(4)+x(5))*MY4-cos(x(2)+x(4)+x(5))*MZ4)/(M1+2*M3+2*M4)* ...
           x(10))*x(7)+((L4*cos(x(1)+x(3)+x(5))*M1+2*L4*cos(x(1)+x(3)+x(5))* ...
           M3+2*L4*cos(x(1)+x(3)+x(5))*M4-sin(x(1)+x(3)+x(5))*MY4-cos(x(1)+ ...
           x(3)+x(5))*MZ4)/(M1+2*M3+2*M4)*x(6)+(L4*cos(x(1)+x(3)+x(5))*M1+2* ...
           L4*cos(x(1)+x(3)+x(5))*M3+2*L4*cos(x(1)+x(3)+x(5))*M4-sin(x(1)+ ...
           x(3)+x(5))*MY4-cos(x(1)+x(3)+x(5))*MZ4)/(M1+2*M3+2*M4)*x(8)+(L4* ...
           cos(x(1)+x(3)+x(5))*M1+2*L4*cos(x(1)+x(3)+x(5))*M3+2*L4*cos(x(1)+ ...
           x(3)+x(5))*M4-sin(x(1)+x(3)+x(5))*MY4-cos(x(1)+x(3)+x(5))* ...
           MZ4)/(M1+2*M3+2*M4)*x(10))*x(8)+((-sin(x(2)+x(4)+x(5))*MY4- ...
           cos(x(2)+x(4)+x(5))*MZ4)/(M1+2*M3+2*M4)*x(7)+(-sin(x(2)+x(4)+ ...
           x(5))*MY4-cos(x(2)+x(4)+x(5))*MZ4)/(M1+2*M3+2*M4)*x(9)+(- ...
           sin(x(2)+x(4)+x(5))*MY4-cos(x(2)+x(4)+x(5))*MZ4)/(M1+2*M3+2*M4)* ...
           x(10))*x(9)+((L3*cos(x(1)+x(5))*M1+L4*cos(x(1)+x(3)+x(5))*M1+2* ...
           L3*cos(x(1)+x(5))*M3+2*L4*cos(x(1)+x(3)+x(5))*M3-sin(x(1)+x(5))* ...
           MY3-cos(x(1)+x(5))*MZ3+2*L4*cos(x(1)+x(3)+x(5))*M4-sin(x(1)+x(3)+ ...
           x(5))*MY4-cos(x(1)+x(3)+x(5))*MZ4+L3*cos(x(1)+x(5))*M4)/(M1+2*M3+ ...
           2*M4)*x(6)+(-sin(x(2)+x(5))*MY3-cos(x(2)+x(5))*MZ3-L3*cos(x(2)+ ...
           x(5))*M4-sin(x(2)+x(4)+x(5))*MY4-cos(x(2)+x(4)+x(5))*MZ4)/(M1+2* ...
           M3+2*M4)*x(7)+(L4*cos(x(1)+x(3)+x(5))*M1+2*L4*cos(x(1)+x(3)+ ...
           x(5))*M3+2*L4*cos(x(1)+x(3)+x(5))*M4-sin(x(1)+x(3)+x(5))*MY4- ...
           cos(x(1)+x(3)+x(5))*MZ4)/(M1+2*M3+2*M4)*x(8)+(-sin(x(2)+x(4)+ ...
           x(5))*MY4-cos(x(2)+x(4)+x(5))*MZ4)/(M1+2*M3+2*M4)*x(9)+(L3* ...
           cos(x(1)+x(5))*M1+L4*cos(x(1)+x(3)+x(5))*M1-sin(x(5))*MY1- ...
           cos(x(5))*MZ1+2*L3*cos(x(1)+x(5))*M3+2*L4*cos(x(1)+x(3)+x(5))*M3- ...
           sin(x(1)+x(5))*MY3-cos(x(1)+x(5))*MZ3-sin(x(2)+x(5))*MY3- ...
           cos(x(2)+x(5))*MZ3+2*L4*cos(x(1)+x(3)+x(5))*M4-sin(x(1)+x(3)+ ...
           x(5))*MY4-cos(x(1)+x(3)+x(5))*MZ4+L3*cos(x(1)+x(5))*M4-L3* ...
           cos(x(2)+x(5))*M4-sin(x(2)+x(4)+x(5))*MY4-cos(x(2)+x(4)+x(5))* ...
           MZ4)/(M1+2*M3+2*M4)*x(10))*x(10)+(L3*sin(x(1)+x(5))*M1+L4* ...
           sin(x(1)+x(3)+x(5))*M1+2*L3*sin(x(1)+x(5))*M3+2*L4*sin(x(1)+x(3)+ ...
           x(5))*M3+cos(x(1)+x(5))*MY3-sin(x(1)+x(5))*MZ3+2*L4*sin(x(1)+ ...
           x(3)+x(5))*M4+cos(x(1)+x(3)+x(5))*MY4-sin(x(1)+x(3)+x(5))*MZ4+L3* ...
           sin(x(1)+x(5))*M4)/(M1+2*M3+2*M4)*ddq(1)+(cos(x(2)+x(5))*MY3- ...
           sin(x(2)+x(5))*MZ3-L3*sin(x(2)+x(5))*M4+cos(x(2)+x(4)+x(5))*MY4- ...
           sin(x(2)+x(4)+x(5))*MZ4)/(M1+2*M3+2*M4)*ddq(2)+(L4*sin(x(1)+x(3)+ ...
           x(5))*M1+2*L4*sin(x(1)+x(3)+x(5))*M3+2*L4*sin(x(1)+x(3)+x(5))*M4+ ...
           cos(x(1)+x(3)+x(5))*MY4-sin(x(1)+x(3)+x(5))*MZ4)/(M1+2*M3+2*M4)* ...
           ddq(3)+(cos(x(2)+x(4)+x(5))*MY4-sin(x(2)+x(4)+x(5))*MZ4)/(M1+2* ...
           M3+2*M4)*ddq(4)+(L3*sin(x(1)+x(5))*M1+L4*sin(x(1)+x(3)+x(5))*M1+ ...
           cos(x(5))*MY1-sin(x(5))*MZ1+2*L3*sin(x(1)+x(5))*M3+2*L4*sin(x(1)+ ...
           x(3)+x(5))*M3+cos(x(1)+x(5))*MY3-sin(x(1)+x(5))*MZ3+cos(x(2)+ ...
           x(5))*MY3-sin(x(2)+x(5))*MZ3+2*L4*sin(x(1)+x(3)+x(5))*M4+ ...
           cos(x(1)+x(3)+x(5))*MY4-sin(x(1)+x(3)+x(5))*MZ4+L3*sin(x(1)+ ...
           x(5))*M4-L3*sin(x(2)+x(5))*M4+cos(x(2)+x(4)+x(5))*MY4-sin(x(2)+ ...
           x(4)+x(5))*MZ4)/(M1+2*M3+2*M4)*ddq(5);
  end
end
