function [h,lfh,l2fh,lglfh,jac_h,inv_D,C,G,B,EFV,EFS] = decouple_lap_red(q,dq)
% DECOUPLE_LAP_RED
%   [H,LFH,L2FH,LGLFH,JAC_H,INV_D,C,G,B,EFV,EFS] = 
%    DECOUPLE_LAP_RED(Q,DQ)  

%Eric Westervelt
%04-Mar-2003 15:42:15

q31L=q(1);q32L=q(2);q41L=q(3);q42L=q(4);q1L=q(5);
dq31L=dq(1);dq32L=dq(2);dq41L=dq(3);dq42L=dq(4);dq1L=dq(5);

[a,b,m] = controlParameters;

a0=a(1); a1=a(2); a2=a(3); a3=a(4); a4=a(5); a5=a(6); a6=a(7); 
b0=a(8); b1=a(9); b2=a(10); b3=a(11); b4=a(12); b5=a(13); b6=a(14); 
c0=a(15); c1=a(16); c2=a(17); c3=a(18); c4=a(19); c5=a(20); c6=a(21); 
d0=a(22); d1=a(23); d2=a(24); d3=a(25); d4=a(26); d5=a(27); d6=a(28); 


s = (-1/2*q41L-q31L-q1L - b)/m;
if s > 1
  s = 1;
elseif s < 0
  s = 0;
end
z1 = m*s + b;

dz1 = -1/2*dq41L-dq31L-dq1L;

h = zeros(4,1);
h(1) = q31L-a0*(1-(z1-b)/m)^6-6*a1*(z1-b)/m*(1-(z1-b)/m)^5-15*a2*(z1- ...
       b)^2/m^2*(1-(z1-b)/m)^4-20*a3*(z1-b)^3/m^3*(1-(z1-b)/m)^3-15* ...
       a4*(z1-b)^4/m^4*(1-(z1-b)/m)^2-6*a5*(z1-b)^5/m^5*(1-(z1-b)/m)- ...
       a6*(z1-b)^6/m^6;
h(2) = q32L-b0*(1-(z1-b)/m)^6-6*b1*(z1-b)/m*(1-(z1-b)/m)^5-15*b2*(z1- ...
       b)^2/m^2*(1-(z1-b)/m)^4-20*b3*(z1-b)^3/m^3*(1-(z1-b)/m)^3-15* ...
       b4*(z1-b)^4/m^4*(1-(z1-b)/m)^2-6*b5*(z1-b)^5/m^5*(1-(z1-b)/m)- ...
       b6*(z1-b)^6/m^6;
h(3) = q41L-c0*(1-(z1-b)/m)^6-6*c1*(z1-b)/m*(1-(z1-b)/m)^5-15*c2*(z1- ...
       b)^2/m^2*(1-(z1-b)/m)^4-20*c3*(z1-b)^3/m^3*(1-(z1-b)/m)^3-15* ...
       c4*(z1-b)^4/m^4*(1-(z1-b)/m)^2-6*c5*(z1-b)^5/m^5*(1-(z1-b)/m)- ...
       c6*(z1-b)^6/m^6;
h(4) = q42L-d0*(1-(z1-b)/m)^6-6*d1*(z1-b)/m*(1-(z1-b)/m)^5-15*d2*(z1- ...
       b)^2/m^2*(1-(z1-b)/m)^4-20*d3*(z1-b)^3/m^3*(1-(z1-b)/m)^3-15* ...
       d4*(z1-b)^4/m^4*(1-(z1-b)/m)^2-6*d5*(z1-b)^5/m^5*(1-(z1-b)/m)- ...
       d6*(z1-b)^6/m^6;
%
lfh = zeros(4,1);
lfh(1) = dq31L-dz1*(-6*a0*(1-(z1-b)/m)^5/m+6*a1/m*(1-(z1-b)/m)^5-30*a1* ...
         (z1-b)/m^2*(1-(z1-b)/m)^4+30*a2*(z1-b)/m^2*(1-(z1-b)/m)^4-60* ...
         a2*(z1-b)^2/m^3*(1-(z1-b)/m)^3+60*a3*(z1-b)^2/m^3*(1-(z1- ...
         b)/m)^3-60*a3*(z1-b)^3/m^4*(1-(z1-b)/m)^2+60*a4*(z1-b)^3/m^4* ...
         (1-(z1-b)/m)^2-30*a4*(z1-b)^4/m^5*(1-(z1-b)/m)+30*a5*(z1- ...
         b)^4/m^5*(1-(z1-b)/m)-6*a5*(z1-b)^5/m^6+6*a6*(z1-b)^5/m^6);
lfh(2) = dq32L-dz1*(-6*b0*(1-(z1-b)/m)^5/m+6*b1/m*(1-(z1-b)/m)^5-30*b1* ...
         (z1-b)/m^2*(1-(z1-b)/m)^4+30*b2*(z1-b)/m^2*(1-(z1-b)/m)^4-60* ...
         b2*(z1-b)^2/m^3*(1-(z1-b)/m)^3+60*b3*(z1-b)^2/m^3*(1-(z1- ...
         b)/m)^3-60*b3*(z1-b)^3/m^4*(1-(z1-b)/m)^2+60*b4*(z1-b)^3/m^4* ...
         (1-(z1-b)/m)^2-30*b4*(z1-b)^4/m^5*(1-(z1-b)/m)+30*b5*(z1- ...
         b)^4/m^5*(1-(z1-b)/m)-6*b5*(z1-b)^5/m^6+6*b6*(z1-b)^5/m^6);
lfh(3) = dq41L-dz1*(-6*c0*(1-(z1-b)/m)^5/m+6*c1/m*(1-(z1-b)/m)^5-30*c1* ...
         (z1-b)/m^2*(1-(z1-b)/m)^4+30*c2*(z1-b)/m^2*(1-(z1-b)/m)^4-60* ...
         c2*(z1-b)^2/m^3*(1-(z1-b)/m)^3+60*c3*(z1-b)^2/m^3*(1-(z1- ...
         b)/m)^3-60*c3*(z1-b)^3/m^4*(1-(z1-b)/m)^2+60*c4*(z1-b)^3/m^4* ...
         (1-(z1-b)/m)^2-30*c4*(z1-b)^4/m^5*(1-(z1-b)/m)+30*c5*(z1- ...
         b)^4/m^5*(1-(z1-b)/m)-6*c5*(z1-b)^5/m^6+6*c6*(z1-b)^5/m^6);
lfh(4) = dq42L-dz1*(-6*d0*(1-(z1-b)/m)^5/m+6*d1/m*(1-(z1-b)/m)^5-30*d1* ...
         (z1-b)/m^2*(1-(z1-b)/m)^4+30*d2*(z1-b)/m^2*(1-(z1-b)/m)^4-60* ...
         d2*(z1-b)^2/m^3*(1-(z1-b)/m)^3+60*d3*(z1-b)^2/m^3*(1-(z1- ...
         b)/m)^3-60*d3*(z1-b)^3/m^4*(1-(z1-b)/m)^2+60*d4*(z1-b)^3/m^4* ...
         (1-(z1-b)/m)^2-30*d4*(z1-b)^4/m^5*(1-(z1-b)/m)+30*d5*(z1- ...
         b)^4/m^5*(1-(z1-b)/m)-6*d5*(z1-b)^5/m^6+6*d6*(z1-b)^5/m^6);

%
jac_h = zeros(4,5);

jac_h(1,1) = 1-6*a0*(1-(z1-b)/m)^5/m+6*a1/m*(1-(z1-b)/m)^5-30*a1*(z1- ...
             b)/m^2*(1-(z1-b)/m)^4+30*a2*(z1-b)/m^2*(1-(z1-b)/m)^4-60*a2* ...
             (z1-b)^2/m^3*(1-(z1-b)/m)^3+60*a3*(z1-b)^2/m^3*(1-(z1- ...
             b)/m)^3-60*a3*(z1-b)^3/m^4*(1-(z1-b)/m)^2+60*a4*(z1- ...
             b)^3/m^4*(1-(z1-b)/m)^2-30*a4*(z1-b)^4/m^5*(1-(z1-b)/m)+30* ...
             a5*(z1-b)^4/m^5*(1-(z1-b)/m)-6*a5*(z1-b)^5/m^6+6*a6*(z1- ...
             b)^5/m^6;
jac_h(1,3) = -3*a0*(1-(z1-b)/m)^5/m+3*a1/m*(1-(z1-b)/m)^5-15*a1*(z1- ...
             b)/m^2*(1-(z1-b)/m)^4+15*a2*(z1-b)/m^2*(1-(z1-b)/m)^4-30*a2* ...
             (z1-b)^2/m^3*(1-(z1-b)/m)^3+30*a3*(z1-b)^2/m^3*(1-(z1- ...
             b)/m)^3-30*a3*(z1-b)^3/m^4*(1-(z1-b)/m)^2+30*a4*(z1- ...
             b)^3/m^4*(1-(z1-b)/m)^2-15*a4*(z1-b)^4/m^5*(1-(z1-b)/m)+15* ...
             a5*(z1-b)^4/m^5*(1-(z1-b)/m)-3*a5*(z1-b)^5/m^6+3*a6*(z1- ...
             b)^5/m^6;
jac_h(1,5) = -6*a0*(1-(z1-b)/m)^5/m+6*a1/m*(1-(z1-b)/m)^5-30*a1*(z1- ...
             b)/m^2*(1-(z1-b)/m)^4+30*a2*(z1-b)/m^2*(1-(z1-b)/m)^4-60*a2* ...
             (z1-b)^2/m^3*(1-(z1-b)/m)^3+60*a3*(z1-b)^2/m^3*(1-(z1- ...
             b)/m)^3-60*a3*(z1-b)^3/m^4*(1-(z1-b)/m)^2+60*a4*(z1- ...
             b)^3/m^4*(1-(z1-b)/m)^2-30*a4*(z1-b)^4/m^5*(1-(z1-b)/m)+30* ...
             a5*(z1-b)^4/m^5*(1-(z1-b)/m)-6*a5*(z1-b)^5/m^6+6*a6*(z1- ...
             b)^5/m^6;
jac_h(2,1) = -6*b0*(1-(z1-b)/m)^5/m+6*b1/m*(1-(z1-b)/m)^5-30*b1*(z1- ...
             b)/m^2*(1-(z1-b)/m)^4+30*b2*(z1-b)/m^2*(1-(z1-b)/m)^4-60*b2* ...
             (z1-b)^2/m^3*(1-(z1-b)/m)^3+60*b3*(z1-b)^2/m^3*(1-(z1- ...
             b)/m)^3-60*b3*(z1-b)^3/m^4*(1-(z1-b)/m)^2+60*b4*(z1- ...
             b)^3/m^4*(1-(z1-b)/m)^2-30*b4*(z1-b)^4/m^5*(1-(z1-b)/m)+30* ...
             b5*(z1-b)^4/m^5*(1-(z1-b)/m)-6*b5*(z1-b)^5/m^6+6*b6*(z1- ...
             b)^5/m^6;
jac_h(2,2) = 1;
jac_h(2,3) = -3*b0*(1-(z1-b)/m)^5/m+3*b1/m*(1-(z1-b)/m)^5-15*b1*(z1- ...
             b)/m^2*(1-(z1-b)/m)^4+15*b2*(z1-b)/m^2*(1-(z1-b)/m)^4-30*b2* ...
             (z1-b)^2/m^3*(1-(z1-b)/m)^3+30*b3*(z1-b)^2/m^3*(1-(z1- ...
             b)/m)^3-30*b3*(z1-b)^3/m^4*(1-(z1-b)/m)^2+30*b4*(z1- ...
             b)^3/m^4*(1-(z1-b)/m)^2-15*b4*(z1-b)^4/m^5*(1-(z1-b)/m)+15* ...
             b5*(z1-b)^4/m^5*(1-(z1-b)/m)-3*b5*(z1-b)^5/m^6+3*b6*(z1- ...
             b)^5/m^6;
jac_h(2,5) = -6*b0*(1-(z1-b)/m)^5/m+6*b1/m*(1-(z1-b)/m)^5-30*b1*(z1- ...
             b)/m^2*(1-(z1-b)/m)^4+30*b2*(z1-b)/m^2*(1-(z1-b)/m)^4-60*b2* ...
             (z1-b)^2/m^3*(1-(z1-b)/m)^3+60*b3*(z1-b)^2/m^3*(1-(z1- ...
             b)/m)^3-60*b3*(z1-b)^3/m^4*(1-(z1-b)/m)^2+60*b4*(z1- ...
             b)^3/m^4*(1-(z1-b)/m)^2-30*b4*(z1-b)^4/m^5*(1-(z1-b)/m)+30* ...
             b5*(z1-b)^4/m^5*(1-(z1-b)/m)-6*b5*(z1-b)^5/m^6+6*b6*(z1- ...
             b)^5/m^6;
jac_h(3,1) = -6*c0*(1-(z1-b)/m)^5/m+6*c1/m*(1-(z1-b)/m)^5-30*c1*(z1- ...
             b)/m^2*(1-(z1-b)/m)^4+30*c2*(z1-b)/m^2*(1-(z1-b)/m)^4-60*c2* ...
             (z1-b)^2/m^3*(1-(z1-b)/m)^3+60*c3*(z1-b)^2/m^3*(1-(z1- ...
             b)/m)^3-60*c3*(z1-b)^3/m^4*(1-(z1-b)/m)^2+60*c4*(z1- ...
             b)^3/m^4*(1-(z1-b)/m)^2-30*c4*(z1-b)^4/m^5*(1-(z1-b)/m)+30* ...
             c5*(z1-b)^4/m^5*(1-(z1-b)/m)-6*c5*(z1-b)^5/m^6+6*c6*(z1- ...
             b)^5/m^6;
jac_h(3,3) = 1-3*c0*(1-(z1-b)/m)^5/m+3*c1/m*(1-(z1-b)/m)^5-15*c1*(z1- ...
             b)/m^2*(1-(z1-b)/m)^4+15*c2*(z1-b)/m^2*(1-(z1-b)/m)^4-30*c2* ...
             (z1-b)^2/m^3*(1-(z1-b)/m)^3+30*c3*(z1-b)^2/m^3*(1-(z1- ...
             b)/m)^3-30*c3*(z1-b)^3/m^4*(1-(z1-b)/m)^2+30*c4*(z1- ...
             b)^3/m^4*(1-(z1-b)/m)^2-15*c4*(z1-b)^4/m^5*(1-(z1-b)/m)+15* ...
             c5*(z1-b)^4/m^5*(1-(z1-b)/m)-3*c5*(z1-b)^5/m^6+3*c6*(z1- ...
             b)^5/m^6;
jac_h(3,5) = -6*c0*(1-(z1-b)/m)^5/m+6*c1/m*(1-(z1-b)/m)^5-30*c1*(z1- ...
             b)/m^2*(1-(z1-b)/m)^4+30*c2*(z1-b)/m^2*(1-(z1-b)/m)^4-60*c2* ...
             (z1-b)^2/m^3*(1-(z1-b)/m)^3+60*c3*(z1-b)^2/m^3*(1-(z1- ...
             b)/m)^3-60*c3*(z1-b)^3/m^4*(1-(z1-b)/m)^2+60*c4*(z1- ...
             b)^3/m^4*(1-(z1-b)/m)^2-30*c4*(z1-b)^4/m^5*(1-(z1-b)/m)+30* ...
             c5*(z1-b)^4/m^5*(1-(z1-b)/m)-6*c5*(z1-b)^5/m^6+6*c6*(z1- ...
             b)^5/m^6;
jac_h(4,1) = -6*d0*(1-(z1-b)/m)^5/m+6*d1/m*(1-(z1-b)/m)^5-30*d1*(z1- ...
             b)/m^2*(1-(z1-b)/m)^4+30*d2*(z1-b)/m^2*(1-(z1-b)/m)^4-60*d2* ...
             (z1-b)^2/m^3*(1-(z1-b)/m)^3+60*d3*(z1-b)^2/m^3*(1-(z1- ...
             b)/m)^3-60*d3*(z1-b)^3/m^4*(1-(z1-b)/m)^2+60*d4*(z1- ...
             b)^3/m^4*(1-(z1-b)/m)^2-30*d4*(z1-b)^4/m^5*(1-(z1-b)/m)+30* ...
             d5*(z1-b)^4/m^5*(1-(z1-b)/m)-6*d5*(z1-b)^5/m^6+6*d6*(z1- ...
             b)^5/m^6;
jac_h(4,3) = -3*d0*(1-(z1-b)/m)^5/m+3*d1/m*(1-(z1-b)/m)^5-15*d1*(z1- ...
             b)/m^2*(1-(z1-b)/m)^4+15*d2*(z1-b)/m^2*(1-(z1-b)/m)^4-30*d2* ...
             (z1-b)^2/m^3*(1-(z1-b)/m)^3+30*d3*(z1-b)^2/m^3*(1-(z1- ...
             b)/m)^3-30*d3*(z1-b)^3/m^4*(1-(z1-b)/m)^2+30*d4*(z1- ...
             b)^3/m^4*(1-(z1-b)/m)^2-15*d4*(z1-b)^4/m^5*(1-(z1-b)/m)+15* ...
             d5*(z1-b)^4/m^5*(1-(z1-b)/m)-3*d5*(z1-b)^5/m^6+3*d6*(z1- ...
             b)^5/m^6;
jac_h(4,4) = 1;
jac_h(4,5) = -6*d0*(1-(z1-b)/m)^5/m+6*d1/m*(1-(z1-b)/m)^5-30*d1*(z1- ...
             b)/m^2*(1-(z1-b)/m)^4+30*d2*(z1-b)/m^2*(1-(z1-b)/m)^4-60*d2* ...
             (z1-b)^2/m^3*(1-(z1-b)/m)^3+60*d3*(z1-b)^2/m^3*(1-(z1- ...
             b)/m)^3-60*d3*(z1-b)^3/m^4*(1-(z1-b)/m)^2+60*d4*(z1- ...
             b)^3/m^4*(1-(z1-b)/m)^2-30*d4*(z1-b)^4/m^5*(1-(z1-b)/m)+30* ...
             d5*(z1-b)^4/m^5*(1-(z1-b)/m)-6*d5*(z1-b)^5/m^6+6*d6*(z1- ...
             b)^5/m^6;
%
%
%
gamma = zeros(4,1);
gamma(1) = dz1^2*(-30*a0*(1-(z1-b)/m)^4/m^2+60*a1/m^2*(1-(z1-b)/m)^4-120* ...
           a1*(z1-b)/m^3*(1-(z1-b)/m)^3-30*a2/m^2*(1-(z1-b)/m)^4+240*a2* ...
           (z1-b)/m^3*(1-(z1-b)/m)^3-180*a2*(z1-b)^2/m^4*(1-(z1-b)/m)^2- ...
           120*a3*(z1-b)/m^3*(1-(z1-b)/m)^3+360*a3*(z1-b)^2/m^4*(1-(z1- ...
           b)/m)^2-120*a3*(z1-b)^3/m^5*(1-(z1-b)/m)-180*a4*(z1-b)^2/m^4* ...
           (1-(z1-b)/m)^2+240*a4*(z1-b)^3/m^5*(1-(z1-b)/m)-30*a4*(z1- ...
           b)^4/m^6-120*a5*(z1-b)^3/m^5*(1-(z1-b)/m)+60*a5*(z1-b)^4/m^6- ...
           30*a6*(z1-b)^4/m^6);
gamma(2) = dz1^2*(-30*b0*(1-(z1-b)/m)^4/m^2+60*b1/m^2*(1-(z1-b)/m)^4-120* ...
           b1*(z1-b)/m^3*(1-(z1-b)/m)^3-30*b2/m^2*(1-(z1-b)/m)^4+240*b2* ...
           (z1-b)/m^3*(1-(z1-b)/m)^3-180*b2*(z1-b)^2/m^4*(1-(z1-b)/m)^2- ...
           120*b3*(z1-b)/m^3*(1-(z1-b)/m)^3+360*b3*(z1-b)^2/m^4*(1-(z1- ...
           b)/m)^2-120*b3*(z1-b)^3/m^5*(1-(z1-b)/m)-180*b4*(z1-b)^2/m^4* ...
           (1-(z1-b)/m)^2+240*b4*(z1-b)^3/m^5*(1-(z1-b)/m)-30*b4*(z1- ...
           b)^4/m^6-120*b5*(z1-b)^3/m^5*(1-(z1-b)/m)+60*b5*(z1-b)^4/m^6- ...
           30*b6*(z1-b)^4/m^6);
gamma(3) = dz1^2*(-30*c0*(1-(z1-b)/m)^4/m^2+60*c1/m^2*(1-(z1-b)/m)^4-120* ...
           c1*(z1-b)/m^3*(1-(z1-b)/m)^3-30*c2/m^2*(1-(z1-b)/m)^4+240*c2* ...
           (z1-b)/m^3*(1-(z1-b)/m)^3-180*c2*(z1-b)^2/m^4*(1-(z1-b)/m)^2- ...
           120*c3*(z1-b)/m^3*(1-(z1-b)/m)^3+360*c3*(z1-b)^2/m^4*(1-(z1- ...
           b)/m)^2-120*c3*(z1-b)^3/m^5*(1-(z1-b)/m)-180*c4*(z1-b)^2/m^4* ...
           (1-(z1-b)/m)^2+240*c4*(z1-b)^3/m^5*(1-(z1-b)/m)-30*c4*(z1- ...
           b)^4/m^6-120*c5*(z1-b)^3/m^5*(1-(z1-b)/m)+60*c5*(z1-b)^4/m^6- ...
           30*c6*(z1-b)^4/m^6);
gamma(4) = dz1^2*(-30*d0*(1-(z1-b)/m)^4/m^2+60*d1/m^2*(1-(z1-b)/m)^4-120* ...
           d1*(z1-b)/m^3*(1-(z1-b)/m)^3-30*d2/m^2*(1-(z1-b)/m)^4+240*d2* ...
           (z1-b)/m^3*(1-(z1-b)/m)^3-180*d2*(z1-b)^2/m^4*(1-(z1-b)/m)^2- ...
           120*d3*(z1-b)/m^3*(1-(z1-b)/m)^3+360*d3*(z1-b)^2/m^4*(1-(z1- ...
           b)/m)^2-120*d3*(z1-b)^3/m^5*(1-(z1-b)/m)-180*d4*(z1-b)^2/m^4* ...
           (1-(z1-b)/m)^2+240*d4*(z1-b)^3/m^5*(1-(z1-b)/m)-30*d4*(z1- ...
           b)^4/m^6-120*d5*(z1-b)^3/m^5*(1-(z1-b)/m)+60*d5*(z1-b)^4/m^6- ...
           30*d6*(z1-b)^4/m^6);
%
%
[D,C,G,B,EFV,EFS] = dyn_mod_lap_red(q,dq);
inv_D = inv(D);
l2fh  = gamma-jac_h*inv_D*(C*dq+G+EFV+EFS);
lglfh = jac_h*inv_D*B;