function [D,C,G,B,E1,EFV,EFS] = dyn_mod_lap(q,dq)
% DYN_MOD_LAP
%   [D,C,G,B,E1,EFV,EFS] = DYN_MOD_LAP(Q,DQ)  Model NOTATION: Spong 
%    and Vidyasagar, page 142, Eq. (6.3.12)     D(q)ddq + C(q,dq)*dq + 
%    G(q) = B*tau + E*F_external

%Eric Westervelt
%04-Mar-2003 10:16:15

modelP;


q31L=q(1);q32L=q(2);q41L=q(3);q42L=q(4);q1L=q(5);ycm=q(6);zcm=q(7);
dq31L=dq(1);dq32L=dq(2);dq41L=dq(3);dq42L=dq(4);dq1L=dq(5);dycm=dq(6);dzcm=dq(7);
%
%
%
%
D=zeros(7,7);
clear s
s(1) = -q32L+q31L+q41L;
s(2) = q31L-q32L-q42L;
s(3) = sin(q31L+q41L-q32L-q42L);

D(1,1)=(-2*Lb1^2*MZ3*L3*M4+8*XXc*L3*L4*M3+8*XXw*L3*L4*M4+4*M1*XXc*L3* ...
       L4-2*Lb1^2*MZ3*MY4*sin(q41L)-2*Lb1^2*MY3*MY4*cos(q41L)+M1* ...
       Lb1^2*M4*L3^2+4*M1*XXw*L3*L4+8*XXw*L3*L4*M3+8*XXb*L3*L4*M3+8* ...
       XXb*L3*L4*M4+2*Lb1^2*M4*L3^2*M3-2*Lb1^2*MZ4*MZ3*cos(q41L)+2* ...
       Lb1^2*MZ4*MY3*sin(q41L)+8*XXc*L3*L4*M4+2*Lb1^2*XX4*M4+4*M1*XXb* ...
       L3*L4+2*M1*XXb*L3^2-Lb1^2*MY3^2-Lb1^2*MY4^2-Lb1^2*MZ4^2-Lb1^2* ...
       MZ3^2+4*XXw*L4^2*M3+4*XXb*L4^2*M3+2*Lb1^2*IA3*M4+4*XXw*L3^2*M3+ ...
       4*XXc*L3^2*M3+4*XXc*L4^2*M4+2*M1*XXc*L4^2+4*XXb*L3^2*M4+2*M1* ...
       XXc*L3^2+2*M1*XXb*L4^2+2*Lb1^2*IA3*M3+2*M1*XXw*L4^2+2*M1*XXw* ...
       L3^2+4*XXc*L4^2*M3+4*XXw*L3^2*M4+2*Lb1^2*XX3*M4+4*XXc*L3^2*M4+ ...
       2*Lb1^2*XX3*M3+4*XXb*L3^2*M3+4*Lb1^2*L3*M3*MZ4*cos(q41L)+Lb1^2* ...
       L3^2*M4^2+M1*Lb1^2*XX3+2*Lb1^2*MZ4*L3*M4*cos(q41L)+M1*Lb1^2* ...
       XX4+4*Lb1^2*L3*M3*MY4*sin(q41L)+2*Lb1^2*MY4*L3*M4*sin(q41L)+2* ...
       M1*Lb1^2*L3*MY4*sin(q41L)+2*M1*Lb1^2*L3*MZ4*cos(q41L)+2*Lb1^2* ...
       XX4*M3+4*XXb*L4^2*M4+M1*Lb1^2*IA3+4*XXw*L4^2*M4)/Lb1^2/(M1+2* ...
       M3+2*M4);
clear s
s(1) = q31L-q32L-q42L;
s(2) = -q32L+q31L+q41L;

D(1,2)=(-Lb1^2*MY3*MY4*cos(s(1))-Lb1^2*MZ3*MZ4*cos(s(1))-Lb1^2*MY4* ...
       MY3*cos(s(2))-Lb1^2*MZ4*MZ3*cos(s(2))-Lb1^2*MY4*MZ3*sin(s(2))- ...
       Lb1^2*MY3*MZ4*sin(s(1))+Lb1^2*MZ4*MY3*sin(s(2))+Lb1^2*MY4*MZ3* ...
       sin(s(1))-Lb1^2*MY3^2*cos(-q32L+q31L)-Lb1^2*MY4^2*cos(q31L+ ...
       q41L-q32L-q42L)-Lb1^2*MZ3^2*cos(-q32L+q31L)-Lb1^2*MZ4^2* ...
       cos(q31L+q41L-q32L-q42L)-Lb1^2*M4*MY4*L3*sin(s(2))-Lb1^2*M4* ...
       MZ4*L3*cos(s(2))-Lb1^2*M4*MZ4*L3*cos(s(1))+Lb1^2*M4*MY4*L3* ...
       sin(s(1))-2*Lb1^2*M4*MZ3*L3*cos(-q32L+q31L)-Lb1^2*L3^2*M4^2* ...
       cos(-q32L+q31L))/Lb1^2/(M1+2*M3+2*M4);
clear s

D(1,3)=(2*Lb1^2*L3*M3*MZ4*cos(q41L)+Lb1^2*MZ4*L3*M4*cos(q41L)+2*Lb1^2* ...
       L3*M3*MY4*sin(q41L)+Lb1^2*MY4*L3*M4*sin(q41L)+M1*Lb1^2*L3*MY4* ...
       sin(q41L)+M1*Lb1^2*L3*MZ4*cos(q41L)+4*XXb*L3^2*M3+4*XXc*L3^2* ...
       M4+4*XXw*L3^2*M4+4*XXb*L4^2*M4+2*Lb1^2*XX4*M3-Lb1^2*MZ4^2+4* ...
       XXw*L3^2*M3+4*XXw*L4^2*M3+4*XXw*L4^2*M4+4*XXb*L4^2*M3+4*M1*XXb* ...
       L3*L4+4*XXc*L3^2*M3+4*XXc*L4^2*M4+2*M1*XXc*L4^2+4*XXb*L3^2*M4+ ...
       2*M1*XXb*L3^2+2*M1*XXc*L3^2+2*M1*XXb*L4^2+2*M1*XXw*L4^2+2*M1* ...
       XXw*L3^2+4*XXc*L4^2*M3+8*XXc*L3*L4*M3+8*XXw*L3*L4*M4+4*M1*XXc* ...
       L3*L4+M1*Lb1^2*XX4-Lb1^2*MZ3*MY4*sin(q41L)-Lb1^2*MY3*MY4* ...
       cos(q41L)+4*M1*XXw*L3*L4+8*XXw*L3*L4*M3+8*XXb*L3*L4*M3+8*XXb* ...
       L3*L4*M4-Lb1^2*MZ4*MZ3*cos(q41L)+Lb1^2*MZ4*MY3*sin(q41L)-Lb1^2* ...
       MY4^2+8*XXc*L3*L4*M4+2*Lb1^2*XX4*M4)/Lb1^2/(M1+2*M3+2*M4);
clear s
s(1) = q31L-q32L-q42L;

D(1,4)=(-Lb1^2*MY3*MY4*cos(s)+Lb1^2*MY4*MZ3*sin(s)-Lb1^2*MZ3*MZ4* ...
       cos(s)-Lb1^2*MY3*MZ4*sin(s)-Lb1^2*MY4^2*cos(q31L+q41L-q32L- ...
       q42L)-Lb1^2*MZ4^2*cos(q31L+q41L-q32L-q42L)+Lb1^2*M4*MY4*L3* ...
       sin(s)-Lb1^2*M4*MZ4*L3*cos(s))/Lb1^2/(M1+2*M3+2*M4);
clear s
s(1) = q31L-q32L-q42L;
s(2) = -q32L+q31L+q41L;

D(1,5)=(-Lb1^2*MY4^2*cos(q31L+q41L-q32L-q42L)-Lb1^2*MZ4^2*cos(q31L+ ...
       q41L-q32L-q42L)-Lb1^2*MZ3^2*cos(-q32L+q31L)-Lb1^2*L3^2*M4^2* ...
       cos(-q32L+q31L)-Lb1^2*MY3^2*cos(-q32L+q31L)-2*Lb1^2*M4*MZ3*L3* ...
       cos(-q32L+q31L)-2*Lb1^2*MZ3*L3*M4+4*XXc*L3*L4*M3+4*XXw*L3*L4* ...
       M4+2*M1*XXc*L3*L4-2*Lb1^2*MZ3*MY4*sin(q41L)-2*Lb1^2*MY3*MY4* ...
       cos(q41L)+M1*Lb1^2*M4*L3^2+2*M1*XXw*L3*L4-Lb1^2*M4*MZ4*L3* ...
       cos(s(2))-Lb1^2*M4*MY4*L3*sin(s(2))+4*XXw*L3*L4*M3+4*XXb*L3*L4* ...
       M3+4*XXb*L3*L4*M4-Lb1^2*MY4*MY3*cos(s(2))-Lb1^2*MZ4*MZ3* ...
       cos(s(2))-Lb1^2*MY4*MZ3*sin(s(2))+Lb1^2*MZ4*MY3*sin(s(2))+2* ...
       Lb1^2*M4*L3^2*M3-2*Lb1^2*MZ4*MZ3*cos(q41L)+2*Lb1^2*MZ4*MY3* ...
       sin(q41L)+4*XXc*L3*L4*M4+2*Lb1^2*XX4*M4+2*M1*XXb*L3*L4-Lb1^2* ...
       M4*MZ4*L3*cos(s(1))+Lb1^2*M4*MY4*L3*sin(s(1))+Lb1^2*MY4*MZ3* ...
       sin(s(1))-Lb1^2*MY3*MZ4*sin(s(1))-Lb1^2*MY3*MY4*cos(s(1))- ...
       Lb1^2*MZ3*MZ4*cos(s(1))-Lb1^2*MY3^2-Lb1^2*MY4^2-Lb1^2*MZ4^2- ...
       Lb1^2*MZ3^2+4*XXw*L4^2*M3+4*XXb*L4^2*M3+4*XXc*L4^2*M4+2*M1*XXc* ...
       L4^2+2*M1*XXb*L4^2+2*M1*XXw*L4^2+4*XXc*L4^2*M3+2*Lb1^2*XX3*M4+ ...
       2*Lb1^2*XX3*M3+4*Lb1^2*L3*M3*MZ4*cos(q41L)+Lb1^2*L3^2*M4^2+M1* ...
       Lb1^2*XX3+2*Lb1^2*MZ4*L3*M4*cos(q41L)+M1*Lb1^2*XX4+4*Lb1^2*L3* ...
       M3*MY4*sin(q41L)+2*Lb1^2*MY4*L3*M4*sin(q41L)+2*M1*Lb1^2*L3*MY4* ...
       sin(q41L)+2*M1*Lb1^2*L3*MZ4*cos(q41L)+2*Lb1^2*XX4*M3+4*XXb* ...
       L4^2*M4+4*XXw*L4^2*M4-Lb1^2*M4*L3*MZ1*cos(q31L)-Lb1^2*MY4*MY1* ...
       cos(q31L+q41L)-Lb1^2*MY4*MZ1*sin(q31L+q41L)-Lb1^2*MZ1*MZ3* ...
       cos(q31L)+Lb1^2*M4*L3*MY1*sin(q31L)-Lb1^2*MY3*MZ1*sin(q31L)- ...
       Lb1^2*MY1*MY3*cos(q31L)+Lb1^2*MY1*MZ3*sin(q31L)+Lb1^2*MZ4*MY1* ...
       sin(q31L+q41L)-Lb1^2*MZ4*MZ1*cos(q31L+q41L))/Lb1^2/(M1+2*M3+2* ...
       M4);
clear s
s(1) = -q32L+q31L+q41L;
s(2) = q31L-q32L-q42L;

D(2,1)=(-2*M4*MZ3*L3*cos(-q32L+q31L)-M4*MZ4*L3*cos(s(1))-M4*MY4*L3* ...
       sin(s(1))+M4*MY4*L3*sin(s(2))-M4*MZ4*L3*cos(s(2))+MZ4*MY3* ...
       sin(s(1))-MY3*MY4*cos(s(2))-MY4*MZ3*sin(s(1))+MY4*MZ3* ...
       sin(s(2))-MZ3*MZ4*cos(s(2))-MZ4*MZ3*cos(s(1))-L3^2*M4^2*cos(- ...
       q32L+q31L)-MY3*MZ4*sin(s(2))-MY4*MY3*cos(s(1))-MZ4^2*cos(q31L+ ...
       q41L-q32L-q42L)-MZ3^2*cos(-q32L+q31L)-MY3^2*cos(-q32L+q31L)- ...
       MY4^2*cos(q31L+q41L-q32L-q42L))/(M1+2*M3+2*M4);
clear s

D(2,2)=(-MY3^2+L3^2*M4^2-MZ3^2-MZ4^2-MY4^2+2*M4*MY4*L3*sin(q42L)-2* ...
       MY3*MY4*cos(q42L)-2*M4*MZ3*L3+2*M4*MZ4*L3*cos(q42L)+4*MY4*L3* ...
       M3*sin(q42L)+2*M4*L3^2*M3+M1*M4*L3^2+4*MZ4*L3*M3*cos(q42L)-2* ...
       MZ3*MY4*sin(q42L)+2*MY3*MZ4*sin(q42L)-2*MZ3*MZ4*cos(q42L)+2*M1* ...
       MZ4*L3*cos(q42L)+2*M1*MY4*L3*sin(q42L)+2*XX3*M3+2*IA3*M4+2*XX3* ...
       M4+M1*XX3+M1*IA3+2*XX4*M3+M1*XX4+2*XX4*M4+2*IA3*M3)/(M1+2*M3+2* ...
       M4);
clear s
s(1) = -q32L+q31L+q41L;

D(2,3)=(-M4*MZ4*L3*cos(s)-M4*MY4*L3*sin(s)+MZ4*MY3*sin(s)-MY4*MZ3* ...
       sin(s)-MZ4*MZ3*cos(s)-MY4*MY3*cos(s)-MZ4^2*cos(q31L+q41L-q32L- ...
       q42L)-MY4^2*cos(q31L+q41L-q32L-q42L))/(M1+2*M3+2*M4);
clear s

D(2,4)=(2*MY4*L3*M3*sin(q42L)+2*MZ4*L3*M3*cos(q42L)+M1*MZ4*L3* ...
       cos(q42L)+M4*MZ4*L3*cos(q42L)+M4*MY4*L3*sin(q42L)+M1*MY4*L3* ...
       sin(q42L)+2*XX4*M4-MY3*MY4*cos(q42L)-MZ3*MY4*sin(q42L)+MY3*MZ4* ...
       sin(q42L)-MZ3*MZ4*cos(q42L)-MZ4^2-MY4^2+M1*XX4+2*XX4*M3)/(M1+2* ...
       M3+2*M4);
clear s
s(1) = q31L-q32L-q42L;
s(2) = -q32L+q31L+q41L;

D(2,5)=(-MY3^2+MY4*MZ3*sin(s(1))-MY3*MZ4*sin(s(1))-MZ3*MZ4*cos(s(1))- ...
       MY3*MY4*cos(s(1))-MZ3^2-MZ4^2-MY4^2-M4*MZ1*L3*cos(q32L)+M4*MY1* ...
       L3*sin(q32L)-M4*MY4*L3*sin(s(2))-M4*MZ4*L3*cos(s(2))-MY4*MZ1* ...
       sin(q32L+q42L)-MY3*MY1*cos(q32L)-MY4*MY1*cos(q32L+q42L)+MZ3* ...
       MY1*sin(q32L)-MZ4*MZ1*cos(q32L+q42L)-MZ3*MZ1*cos(q32L)-MY3*MZ1* ...
       sin(q32L)+MZ4*MY1*sin(q32L+q42L)+M4*MY4*L3*sin(s(1))-M4*MZ4*L3* ...
       cos(s(1))-MZ4*MZ3*cos(s(2))-MY4*MY3*cos(s(2))-MY4*MZ3* ...
       sin(s(2))+MZ4*MY3*sin(s(2))-L3^2*M4^2*cos(-q32L+q31L)-2*M4*MZ3* ...
       L3*cos(-q32L+q31L)-MZ4^2*cos(q31L+q41L-q32L-q42L)-MZ3^2*cos(- ...
       q32L+q31L)-MY3^2*cos(-q32L+q31L)-MY4^2*cos(q31L+q41L-q32L- ...
       q42L)+L3^2*M4^2+M1*M4*L3^2-2*M4*MZ3*L3+2*M4*L3^2*M3+2*M4*MY4* ...
       L3*sin(q42L)+M1*XX4+4*MZ4*L3*M3*cos(q42L)+2*M1*MZ4*L3* ...
       cos(q42L)+2*M1*MY4*L3*sin(q42L)+2*M4*MZ4*L3*cos(q42L)+4*MY4*L3* ...
       M3*sin(q42L)-2*MZ3*MY4*sin(q42L)+2*MY3*MZ4*sin(q42L)-2*MZ3*MZ4* ...
       cos(q42L)+2*XX3*M4+2*XX4*M3+2*XX4*M4+M1*XX3+2*XX3*M3-2*MY3*MY4* ...
       cos(q42L))/(M1+2*M3+2*M4);
clear s

D(3,1)=(8*XXc*L3*L4*M4+8*XXc*L3*L4*M3+8*XXw*L3*L4*M3+8*XXb*L3*L4*M3+8* ...
       XXb*L3*L4*M4+4*XXw*L3^2*M4+2*Lb1^2*XX4*M3+4*XXw*L3^2*M3+4*XXb* ...
       L4^2*M4-Lb1^2*MZ3*MY4*sin(q41L)-Lb1^2*MY3*MY4*cos(q41L)+4*M1* ...
       XXb*L3*L4+8*XXw*L3*L4*M4+4*M1*XXc*L3*L4+4*M1*XXw*L3*L4-Lb1^2* ...
       MY4^2+2*Lb1^2*L3*M3*MZ4*cos(q41L)+M1*Lb1^2*L3*MZ4*cos(q41L)+ ...
       Lb1^2*MZ4*L3*M4*cos(q41L)+Lb1^2*MY4*L3*M4*sin(q41L)+M1*Lb1^2* ...
       L3*MY4*sin(q41L)+4*XXc*L4^2*M3+2*Lb1^2*XX4*M4+4*XXw*L4^2*M3+4* ...
       XXb*L4^2*M3+M1*Lb1^2*XX4+4*XXb*L3^2*M3+4*XXc*L3^2*M4+2*Lb1^2* ...
       L3*M3*MY4*sin(q41L)+2*M1*XXc*L4^2+4*XXb*L3^2*M4+2*M1*XXb*L3^2+ ...
       2*M1*XXc*L3^2+2*M1*XXb*L4^2+2*M1*XXw*L4^2+2*M1*XXw*L3^2-Lb1^2* ...
       MZ4^2+4*XXw*L4^2*M4+4*XXc*L3^2*M3+4*XXc*L4^2*M4-Lb1^2*MZ4*MZ3* ...
       cos(q41L)+Lb1^2*MZ4*MY3*sin(q41L))/Lb1^2/(M1+2*M3+2*M4);
clear s
s(1) = -q32L+q31L+q41L;

D(3,2)=(-M4*MZ4*L3*cos(s)-M4*MY4*L3*sin(s)+MZ4*MY3*sin(s)-MY4*MZ3* ...
       sin(s)-MZ4*MZ3*cos(s)-MY4*MY3*cos(s)-MZ4^2*cos(q31L+q41L-q32L- ...
       q42L)-MY4^2*cos(q31L+q41L-q32L-q42L))/(M1+2*M3+2*M4);
clear s
s(1) = -q32L+q31L+q41L;

D(3,3)=-(-2*Lb1^2*XX4*M3-4*XXc*L4^2*M4-2*M1*XXw*L4^2-M1*Lb1^2*XX4-4* ...
       XXw*L3^2*M3+Lb1^2*MZ4^2+Lb1^2*MY4^2-8*XXc*L3*L4*M4-2*M1*XXb* ...
       L4^2-4*XXb*L3^2*M3-4*XXb*L4^2*M3-4*XXw*L3^2*M4-2*M1*XXc*L4^2-2* ...
       Lb1^2*XX4*M4-4*XXw*L4^2*M3-4*XXb*L3^2*M4-4*XXc*L3^2*M4-2*M1* ...
       XXb*L3^2-2*M1*XXc*L3^2-4*XXb*L4^2*M4-4*XXc*L4^2*M3-4*XXw*L4^2* ...
       M4-2*M1*XXw*L3^2-4*XXc*L3^2*M3-8*XXc*L3*L4*M3-4*M1*XXb*L3*L4-8* ...
       XXw*L3*L4*M4-4*M1*XXc*L3*L4-4*M1*XXw*L3*L4-8*XXw*L3*L4*M3-8* ...
       XXb*L3*L4*M3-8*XXb*L3*L4*M4-M1*Lb1^2*IA4-2*Lb1^2*IA4*M4-2* ...
       Lb1^2*IA4*M3)/Lb1^2/(M1+2*M3+2*M4);
clear s

D(3,4)=-(Lb1^2*MY4^2*cos(q31L+q41L-q32L-q42L)+Lb1^2*MZ4^2*cos(q31L+ ...
       q41L-q32L-q42L))/Lb1^2/(M1+2*M3+2*M4);
clear s
s(1) = -q32L+q31L+q41L;

D(3,5)=-(Lb1^2*MY4^2*cos(q31L+q41L-q32L-q42L)+Lb1^2*MZ4^2*cos(q31L+ ...
       q41L-q32L-q42L)+Lb1^2*MY4*MY1*cos(q31L+q41L)+Lb1^2*MY4*MZ1* ...
       sin(q31L+q41L)-Lb1^2*MZ4*MY1*sin(q31L+q41L)+Lb1^2*MZ4*MZ1* ...
       cos(q31L+q41L)-2*Lb1^2*XX4*M3-4*XXc*L4^2*M4-2*M1*XXw*L4^2-M1* ...
       Lb1^2*XX4+Lb1^2*MZ4^2+Lb1^2*MY4^2-4*XXc*L3*L4*M4+Lb1^2*M4*MZ4* ...
       L3*cos(s)+Lb1^2*M4*MY4*L3*sin(s)+Lb1^2*MY4*MZ3*sin(s)+Lb1^2* ...
       MZ4*MZ3*cos(s)+Lb1^2*MY4*MY3*cos(s)-Lb1^2*MZ4*MY3*sin(s)-2*M1* ...
       XXb*L4^2-Lb1^2*MY4*L3*M4*sin(q41L)-M1*Lb1^2*L3*MZ4*cos(q41L)- ...
       Lb1^2*MZ4*L3*M4*cos(q41L)-2*Lb1^2*L3*M3*MZ4*cos(q41L)-M1*Lb1^2* ...
       L3*MY4*sin(q41L)-4*XXb*L4^2*M3-2*M1*XXc*L4^2-2*Lb1^2*XX4*M4-4* ...
       XXw*L4^2*M3-2*Lb1^2*L3*M3*MY4*sin(q41L)-4*XXb*L4^2*M4-4*XXc* ...
       L4^2*M3-4*XXw*L4^2*M4+Lb1^2*MZ4*MZ3*cos(q41L)-Lb1^2*MZ4*MY3* ...
       sin(q41L)+Lb1^2*MY3*MY4*cos(q41L)-4*XXc*L3*L4*M3-2*M1*XXb*L3* ...
       L4-4*XXw*L3*L4*M4-2*M1*XXc*L3*L4+Lb1^2*MZ3*MY4*sin(q41L)-2*M1* ...
       XXw*L3*L4-4*XXw*L3*L4*M3-4*XXb*L3*L4*M3-4*XXb*L3*L4* ...
       M4)/Lb1^2/(M1+2*M3+2*M4);
clear s
s(1) = q31L-q32L-q42L;

D(4,1)=(M4*MY4*L3*sin(s)-M4*MZ4*L3*cos(s)-MY4*MY3*cos(s)+MY4*MZ3* ...
       sin(s)-MZ4*MZ3*cos(s)-MZ4*MY3*sin(s)-MZ4^2*cos(q31L+q41L-q32L- ...
       q42L)-MY4^2*cos(q31L+q41L-q32L-q42L))/(M1+2*M3+2*M4);
clear s

D(4,2)=(2*MY4*L3*M3*sin(q42L)+2*MZ4*L3*M3*cos(q42L)+M1*MZ4*L3* ...
       cos(q42L)+M4*MZ4*L3*cos(q42L)+M4*MY4*L3*sin(q42L)+M1*MY4*L3* ...
       sin(q42L)+2*XX4*M4-MY3*MY4*cos(q42L)-MZ3*MY4*sin(q42L)+MY3*MZ4* ...
       sin(q42L)-MZ3*MZ4*cos(q42L)-MZ4^2-MY4^2+M1*XX4+2*XX4*M3)/(M1+2* ...
       M3+2*M4);
clear s

D(4,3)=-cos(q31L+q41L-q32L-q42L)*(MY4^2+MZ4^2)/(M1+2*M3+2*M4);
clear s

D(4,4)=XX4+(-MZ4^2-MY4^2+M1*IA4+2*IA4*M3+2*IA4*M4)/(M1+2*M3+2*M4);
clear s
s(1) = q31L-q32L-q42L;

D(4,5)=(-MY4*MY3*cos(s)-MZ4^2-MY4^2+M4*MY4*L3*sin(s)-M4*MZ4*L3*cos(s)- ...
       MY4*MZ1*sin(q32L+q42L)-MY4*MY1*cos(q32L+q42L)-MZ4*MZ1*cos(q32L+ ...
       q42L)+MZ4*MY1*sin(q32L+q42L)-MZ4^2*cos(q31L+q41L-q32L-q42L)- ...
       MY4^2*cos(q31L+q41L-q32L-q42L)+M4*MY4*L3*sin(q42L)+M1*XX4+2* ...
       MZ4*L3*M3*cos(q42L)+M1*MZ4*L3*cos(q42L)+M1*MY4*L3*sin(q42L)+M4* ...
       MZ4*L3*cos(q42L)+2*MY4*L3*M3*sin(q42L)-MZ3*MY4*sin(q42L)+MY3* ...
       MZ4*sin(q42L)-MZ3*MZ4*cos(q42L)+2*XX4*M3+2*XX4*M4-MY3*MY4* ...
       cos(q42L)-MZ4*MY3*sin(s)+MY4*MZ3*sin(s)-MZ4*MZ3*cos(s))/(M1+2* ...
       M3+2*M4);
clear s
s(1) = q31L-q32L-q42L;
s(2) = -q32L+q31L+q41L;

D(5,1)=(-Lb1^2*MY4^2*cos(q31L+q41L-q32L-q42L)-Lb1^2*MZ4^2*cos(q31L+ ...
       q41L-q32L-q42L)-Lb1^2*MY4*MY1*cos(q31L+q41L)-Lb1^2*MY4*MZ1* ...
       sin(q31L+q41L)+Lb1^2*MZ4*MY1*sin(q31L+q41L)-Lb1^2*MZ4*MZ1* ...
       cos(q31L+q41L)+2*Lb1^2*XX4*M3+4*XXc*L4^2*M4+2*M1*XXw*L4^2+M1* ...
       Lb1^2*XX4-Lb1^2*MZ4^2-Lb1^2*MY4^2+4*XXc*L3*L4*M4+2*M1*XXb*L4^2+ ...
       2*Lb1^2*MY4*L3*M4*sin(q41L)+2*M1*Lb1^2*L3*MZ4*cos(q41L)+2* ...
       Lb1^2*MZ4*L3*M4*cos(q41L)+4*Lb1^2*L3*M3*MZ4*cos(q41L)+2*M1* ...
       Lb1^2*L3*MY4*sin(q41L)+4*XXb*L4^2*M3+2*M1*XXc*L4^2+2*Lb1^2*XX4* ...
       M4+4*XXw*L4^2*M3+4*Lb1^2*L3*M3*MY4*sin(q41L)+4*XXb*L4^2*M4+4* ...
       XXc*L4^2*M3+4*XXw*L4^2*M4-Lb1^2*MY3^2-Lb1^2*MZ3^2+M1*Lb1^2*XX3- ...
       2*Lb1^2*M4*MZ3*L3*cos(-q32L+q31L)+M1*Lb1^2*M4*L3^2+Lb1^2*MY1* ...
       MZ3*sin(q31L)-Lb1^2*MZ3^2*cos(-q32L+q31L)-2*Lb1^2*MZ3*L3*M4+2* ...
       Lb1^2*M4*L3^2*M3-Lb1^2*MZ1*MZ3*cos(q31L)-Lb1^2*MY3*MZ1* ...
       sin(q31L)-Lb1^2*MY3^2*cos(-q32L+q31L)+Lb1^2*L3^2*M4^2+2*Lb1^2* ...
       XX3*M3+2*Lb1^2*XX3*M4+Lb1^2*M4*L3*MY1*sin(q31L)-Lb1^2*M4*L3* ...
       MZ1*cos(q31L)-Lb1^2*L3^2*M4^2*cos(-q32L+q31L)-Lb1^2*MY1*MY3* ...
       cos(q31L)-Lb1^2*MY4*MZ3*sin(s(2))-Lb1^2*MZ4*MZ3*cos(s(2))- ...
       Lb1^2*MY4*MY3*cos(s(2))+Lb1^2*MZ4*MY3*sin(s(2))-Lb1^2*M4*MY4* ...
       L3*sin(s(2))-Lb1^2*M4*MZ4*L3*cos(s(2))-2*Lb1^2*MZ4*MZ3* ...
       cos(q41L)+2*Lb1^2*MZ4*MY3*sin(q41L)-2*Lb1^2*MY3*MY4*cos(q41L)+ ...
       4*XXc*L3*L4*M3+2*M1*XXb*L3*L4+4*XXw*L3*L4*M4+2*M1*XXc*L3*L4-2* ...
       Lb1^2*MZ3*MY4*sin(q41L)+2*M1*XXw*L3*L4+4*XXw*L3*L4*M3+4*XXb*L3* ...
       L4*M3-Lb1^2*MZ3*MZ4*cos(s(1))-Lb1^2*M4*MZ4*L3*cos(s(1))+Lb1^2* ...
       M4*MY4*L3*sin(s(1))+Lb1^2*MY4*MZ3*sin(s(1))-Lb1^2*MY3*MY4* ...
       cos(s(1))+4*XXb*L3*L4*M4-Lb1^2*MY3*MZ4*sin(s(1)))/Lb1^2/(M1+2* ...
       M3+2*M4);
clear s
s(1) = q31L-q32L-q42L;
s(2) = -q32L+q31L+q41L;

D(5,2)=(-MY3^2+2*XX4*M4-MZ3^2*cos(-q32L+q31L)-MZ4^2*cos(q31L+q41L- ...
       q32L-q42L)-MY3^2*cos(-q32L+q31L)-MY4^2*cos(q31L+q41L-q32L- ...
       q42L)+M1*XX4+M1*XX3+L3^2*M4^2+2*XX4*M3+2*XX3*M3+2*XX3*M4-MZ3^2- ...
       MZ4^2-MY4^2+2*M4*MZ4*L3*cos(q42L)+2*M4*MY4*L3*sin(q42L)+2*M1* ...
       MY4*L3*sin(q42L)+4*MZ4*L3*M3*cos(q42L)+2*M1*MZ4*L3*cos(q42L)-2* ...
       M4*MZ3*L3*cos(-q32L+q31L)+4*MY4*L3*M3*sin(q42L)+M4*MY1*L3* ...
       sin(q32L)-M4*MZ1*L3*cos(q32L)+MZ4*MY3*sin(s(2))-MZ4*MZ3* ...
       cos(s(2))-MY4*MZ3*sin(s(2))-MY4*MY3*cos(s(2))-M4*MZ4*L3* ...
       cos(s(2))-M4*MY4*L3*sin(s(2))+M4*MY4*L3*sin(s(1))-M4*MZ4*L3* ...
       cos(s(1))-MZ3*MZ4*cos(s(1))-MY3*MY4*cos(s(1))+MY4*MZ3* ...
       sin(s(1))-MY3*MZ4*sin(s(1))-MZ4*MZ1*cos(q32L+q42L)-MY4*MY1* ...
       cos(q32L+q42L)-MY4*MZ1*sin(q32L+q42L)-MY3*MZ1*sin(q32L)+M1*M4* ...
       L3^2-L3^2*M4^2*cos(-q32L+q31L)-MY3*MY1*cos(q32L)-MZ3*MZ1* ...
       cos(q32L)+MZ4*MY1*sin(q32L+q42L)+MZ3*MY1*sin(q32L)-2*MY3*MY4* ...
       cos(q42L)-2*MZ3*MZ4*cos(q42L)-2*MZ3*MY4*sin(q42L)+2*M4*L3^2*M3- ...
       2*MZ3*L3*M4+2*MY3*MZ4*sin(q42L))/(M1+2*M3+2*M4);
clear s
s(1) = -q32L+q31L+q41L;

D(5,3)=(-Lb1^2*M4*MZ4*L3*cos(s)-Lb1^2*M4*MY4*L3*sin(s)-Lb1^2*MY4^2* ...
       cos(q31L+q41L-q32L-q42L)-Lb1^2*MZ4^2*cos(q31L+q41L-q32L-q42L)- ...
       Lb1^2*MY4*MY1*cos(q31L+q41L)-Lb1^2*MY4*MZ1*sin(q31L+q41L)+ ...
       Lb1^2*MZ4*MY1*sin(q31L+q41L)-Lb1^2*MZ4*MZ1*cos(q31L+q41L)+2* ...
       Lb1^2*XX4*M3+4*XXc*L4^2*M4+2*M1*XXw*L4^2+M1*Lb1^2*XX4-Lb1^2* ...
       MZ4^2-Lb1^2*MY4^2+4*XXc*L3*L4*M4+2*M1*XXb*L4^2+Lb1^2*MY4*L3*M4* ...
       sin(q41L)+M1*Lb1^2*L3*MZ4*cos(q41L)+Lb1^2*MZ4*L3*M4*cos(q41L)+ ...
       2*Lb1^2*L3*M3*MZ4*cos(q41L)+M1*Lb1^2*L3*MY4*sin(q41L)+4*XXb* ...
       L4^2*M3+2*M1*XXc*L4^2+2*Lb1^2*XX4*M4+4*XXw*L4^2*M3+2*Lb1^2*L3* ...
       M3*MY4*sin(q41L)+4*XXb*L4^2*M4+4*XXc*L4^2*M3+4*XXw*L4^2*M4- ...
       Lb1^2*MZ4*MZ3*cos(q41L)+Lb1^2*MZ4*MY3*sin(q41L)-Lb1^2*MY3*MY4* ...
       cos(q41L)+4*XXc*L3*L4*M3+2*M1*XXb*L3*L4+4*XXw*L3*L4*M4+2*M1* ...
       XXc*L3*L4-Lb1^2*MZ3*MY4*sin(q41L)+2*M1*XXw*L3*L4+4*XXw*L3*L4* ...
       M3+4*XXb*L3*L4*M3+4*XXb*L3*L4*M4-Lb1^2*MZ4*MZ3*cos(s)-Lb1^2* ...
       MY4*MZ3*sin(s)-Lb1^2*MY4*MY3*cos(s)+Lb1^2*MZ4*MY3* ...
       sin(s))/Lb1^2/(M1+2*M3+2*M4);
clear s
s(1) = q31L-q32L-q42L;

D(5,4)=(2*XX4*M4-MZ4^2*cos(q31L+q41L-q32L-q42L)-MY4^2*cos(q31L+q41L- ...
       q32L-q42L)+M1*XX4+2*XX4*M3-MZ4^2-MY4^2+M4*MZ4*L3*cos(q42L)+M4* ...
       MY4*L3*sin(q42L)+M1*MY4*L3*sin(q42L)+2*MZ4*L3*M3*cos(q42L)+M1* ...
       MZ4*L3*cos(q42L)+2*MY4*L3*M3*sin(q42L)-MY3*MZ4*sin(s)-MY3*MY4* ...
       cos(s)-MZ3*MZ4*cos(s)+MY4*MZ3*sin(s)+M4*MY4*L3*sin(s)-M4*MZ4* ...
       L3*cos(s)-MZ4*MZ1*cos(q32L+q42L)-MY4*MY1*cos(q32L+q42L)-MY4* ...
       MZ1*sin(q32L+q42L)+MZ4*MY1*sin(q32L+q42L)-MY3*MY4*cos(q42L)- ...
       MZ3*MZ4*cos(q42L)-MZ3*MY4*sin(q42L)+MY3*MZ4*sin(q42L))/(M1+2* ...
       M3+2*M4);
clear s
s(1) = q31L-q32L-q42L;
s(2) = -q32L+q31L+q41L;

D(5,5)=(-2*Lb1^2*MY4^2*cos(q31L+q41L-q32L-q42L)-2*Lb1^2*MZ4^2* ...
       cos(q31L+q41L-q32L-q42L)-2*Lb1^2*MY4*MY1*cos(q31L+q41L)-2* ...
       Lb1^2*MY4*MZ1*sin(q31L+q41L)+2*Lb1^2*MZ4*MY1*sin(q31L+q41L)-2* ...
       Lb1^2*MZ4*MZ1*cos(q31L+q41L)+4*Lb1^2*XX4*M3+4*XXc*L4^2*M4+2*M1* ...
       XXw*L4^2+2*M1*Lb1^2*XX4-2*Lb1^2*MZ4^2-2*Lb1^2*MY4^2+2*M1*XXb* ...
       L4^2+2*Lb1^2*MY4*L3*M4*sin(q41L)+2*M1*Lb1^2*L3*MZ4*cos(q41L)+2* ...
       Lb1^2*MZ4*L3*M4*cos(q41L)+4*Lb1^2*L3*M3*MZ4*cos(q41L)+2*M1* ...
       Lb1^2*L3*MY4*sin(q41L)+4*XXb*L4^2*M3+2*M1*XXc*L4^2+4*Lb1^2*XX4* ...
       M4+4*XXw*L4^2*M3+4*Lb1^2*L3*M3*MY4*sin(q41L)+4*XXb*L4^2*M4+4* ...
       XXc*L4^2*M3+4*XXw*L4^2*M4-2*Lb1^2*MY3^2-2*Lb1^2*MZ3^2+2*M1* ...
       Lb1^2*XX3-2*Lb1^2*MY4*MY1*cos(q32L+q42L)-2*Lb1^2*MY4*MZ1* ...
       sin(q32L+q42L)-2*Lb1^2*MZ3*MZ1*cos(q32L)-2*Lb1^2*MZ3*MY4* ...
       sin(q42L)-2*Lb1^2*MZ4*MZ1*cos(q32L+q42L)+2*M1*Lb1^2*MZ4*L3* ...
       cos(q42L)+2*Lb1^2*XX1*M3-4*Lb1^2*M4*MZ3*L3*cos(-q32L+q31L)+2* ...
       M1*Lb1^2*M4*L3^2+2*Lb1^2*MY1*MZ3*sin(q31L)-2*Lb1^2*MZ3^2*cos(- ...
       q32L+q31L)-4*Lb1^2*MZ3*L3*M4+4*Lb1^2*M4*L3^2*M3-2*Lb1^2*MZ1* ...
       MZ3*cos(q31L)-2*Lb1^2*MY3*MZ1*sin(q31L)-2*Lb1^2*MY3^2*cos(- ...
       q32L+q31L)+2*Lb1^2*L3^2*M4^2+4*Lb1^2*XX3*M3+4*Lb1^2*XX3*M4-2* ...
       Lb1^2*MZ3*MZ4*cos(q42L)-2*Lb1^2*MY3*MY4*cos(q42L)+2*M1*Lb1^2* ...
       MY4*L3*sin(q42L)+4*Lb1^2*MY4*L3*M3*sin(q42L)+2*Lb1^2*M4*MZ4*L3* ...
       cos(q42L)+2*Lb1^2*M4*MY4*L3*sin(q42L)+4*Lb1^2*MZ4*L3*M3* ...
       cos(q42L)-2*Lb1^2*MY3*MY1*cos(q32L)+2*Lb1^2*XX1*M4+M1*Lb1^2* ...
       XX1+2*Lb1^2*M4*L3*MY1*sin(q31L)-2*Lb1^2*M4*L3*MZ1*cos(q31L)+2* ...
       Lb1^2*MZ4*MY1*sin(q32L+q42L)+2*Lb1^2*MY3*MZ4*sin(q42L)-2*Lb1^2* ...
       MY3*MZ1*sin(q32L)+2*Lb1^2*MZ3*MY1*sin(q32L)+2*Lb1^2*M4*MY1*L3* ...
       sin(q32L)-2*Lb1^2*M4*MZ1*L3*cos(q32L)-2*Lb1^2*L3^2*M4^2*cos(- ...
       q32L+q31L)-2*Lb1^2*MY1*MY3*cos(q31L)-2*Lb1^2*MY4*MZ3*sin(s(2))- ...
       2*Lb1^2*MZ4*MZ3*cos(s(2))-2*Lb1^2*MY4*MY3*cos(s(2))+2*Lb1^2* ...
       MZ4*MY3*sin(s(2))-2*Lb1^2*M4*MY4*L3*sin(s(2))-2*Lb1^2*M4*MZ4* ...
       L3*cos(s(2))-Lb1^2*MY1^2-Lb1^2*MZ1^2-2*Lb1^2*MZ4*MZ3*cos(q41L)+ ...
       2*Lb1^2*MZ4*MY3*sin(q41L)-2*Lb1^2*MY3*MY4*cos(q41L)-2*Lb1^2* ...
       MZ3*MY4*sin(q41L)-2*Lb1^2*MZ3*MZ4*cos(s(1))-2*Lb1^2*M4*MZ4*L3* ...
       cos(s(1))+2*Lb1^2*M4*MY4*L3*sin(s(1))+2*Lb1^2*MY4*MZ3* ...
       sin(s(1))-2*Lb1^2*MY3*MY4*cos(s(1))-2*Lb1^2*MY3*MZ4* ...
       sin(s(1)))/Lb1^2/(M1+2*M3+2*M4);
clear s

D(6,6)=M1+2*M3+2*M4;
clear s

D(7,7)=M1+2*M3+2*M4;
%
%
%
%
C=zeros(7,7);
clear s

C(1,1)=(MZ4*MZ3*sin(q41L)+MZ4*MY3*cos(q41L)-MZ3*MY4*cos(q41L)+MY3*MY4* ...
       sin(q41L)-2*L3*M3*MZ4*sin(q41L)-MZ4*L3*M4*sin(q41L)+2*L3*M3* ...
       MY4*cos(q41L)+MY4*L3*M4*cos(q41L)+M1*L3*MY4*cos(q41L)-M1*L3* ...
       MZ4*sin(q41L))*dq41L/(M1+2*M3+2*M4);
clear s
s(1) = M1+2*M3+2*M4;
s(2) = -q32L+q31L+q41L;
s(3) = q31L-q32L-q42L;
s(4) = sin(q31L+q41L-q32L-q42L);

C(2,1)=(2*M4*MZ3*L3*sin(-q32L+q31L)+M4*MZ4*L3*sin(s(2))-M4*MY4*L3* ...
       cos(s(2))+M4*MY4*L3*cos(s(3))+M4*MZ4*L3*sin(s(3))+MZ4*MY3* ...
       cos(s(2))+MY3*MY4*sin(s(3))-MY4*MZ3*cos(s(2))+MY4*MZ3* ...
       cos(s(3))+MZ3*MZ4*sin(s(3))+MZ4*MZ3*sin(s(2))+L3^2*M4^2*sin(- ...
       q32L+q31L)-MY3*MZ4*cos(s(3))+MY4*MY3*sin(s(2))+MZ4^2*s(4)+ ...
       MZ3^2*sin(-q32L+q31L)+MY3^2*sin(-q32L+q31L)+MY4^2*s(4))/s(1)* ...
       dq31L+(M4*MZ4*L3*sin(s(2))-M4*MY4*L3*cos(s(2))+MZ4*MY3* ...
       cos(s(2))-MY4*MZ3*cos(s(2))+MZ4*MZ3*sin(s(2))+MY4*MY3* ...
       sin(s(2))+MZ4^2*s(4)+MY4^2*s(4))/s(1)*dq41L+(1/2*(2*M4*MZ3*L3* ...
       sin(-q32L+q31L)+M4*MZ4*L3*sin(s(2))-M4*MY4*L3*cos(s(2))+M4*MY4* ...
       L3*cos(s(3))+M4*MZ4*L3*sin(s(3))+MZ4*MY3*cos(s(2))+MY3*MY4* ...
       sin(s(3))-MY4*MZ3*cos(s(2))+MY4*MZ3*cos(s(3))+MZ3*MZ4* ...
       sin(s(3))+MZ4*MZ3*sin(s(2))+L3^2*M4^2*sin(-q32L+q31L)-MY3*MZ4* ...
       cos(s(3))+MY4*MY3*sin(s(2))+MZ4^2*s(4)+MZ3^2*sin(-q32L+q31L)+ ...
       MY3^2*sin(-q32L+q31L)+MY4^2*s(4))/s(1)-1/2*(-Lb1^2*M4*MY4*L3* ...
       cos(s(3))-Lb1^2*M4*MZ4*L3*sin(s(2))-Lb1^2*M4*MZ4*L3*sin(s(3))- ...
       2*Lb1^2*M4*MZ3*L3*sin(-q32L+q31L)-Lb1^2*MY3*MY4*sin(s(3))- ...
       Lb1^2*MY4*MZ3*cos(s(3))+Lb1^2*MY4*MZ3*cos(s(2))+Lb1^2*M4*MY4* ...
       L3*cos(s(2))-Lb1^2*MZ4^2*s(4)-Lb1^2*MY3^2*sin(-q32L+q31L)- ...
       Lb1^2*MY4^2*s(4)-Lb1^2*MZ3^2*sin(-q32L+q31L)-Lb1^2*MZ4*MZ3* ...
       sin(s(2))+Lb1^2*MY3*MZ4*cos(s(3))-Lb1^2*L3^2*M4^2*sin(-q32L+ ...
       q31L)-Lb1^2*MZ4*MY3*cos(s(2))-Lb1^2*MZ3*MZ4*sin(s(3))-Lb1^2* ...
       MY4*MY3*sin(s(2)))/Lb1^2/s(1))*dq1L;
clear s
s(1) = M1+2*M3+2*M4;
s(2) = -q32L+q31L+q41L;
s(3) = q31L-q32L-q42L;
s(4) = sin(q31L+q41L-q32L-q42L);

C(2,2)=(MY3*MY4*sin(q42L)-MZ3*MY4*cos(q42L)+MY3*MZ4*cos(q42L)+MZ3*MZ4* ...
       sin(q42L)+M4*MY4*L3*cos(q42L)-M4*MZ4*L3*sin(q42L)+M1*MY4*L3* ...
       cos(q42L)-2*MZ4*L3*M3*sin(q42L)-M1*MZ4*L3*sin(q42L)+2*MY4*L3* ...
       M3*cos(q42L))*dq42L/s(1);
clear s
s(1) = M1+2*M3+2*M4;
s(2) = -q32L+q31L+q41L;
s(3) = sin(q31L+q41L-q32L-q42L);

C(3,1)=-1/2*(-4*Lb1^2*L3*M3*MZ4*sin(q41L)+4*Lb1^2*L3*M3*MY4*cos(q41L)- ...
       2*Lb1^2*MZ4*L3*M4*sin(q41L)+2*Lb1^2*MY4*L3*M4*cos(q41L)-2*M1* ...
       Lb1^2*L3*MZ4*sin(q41L)+2*M1*Lb1^2*L3*MY4*cos(q41L)+2*Lb1^2*MZ4* ...
       MY3*cos(q41L)+2*Lb1^2*MZ4*MZ3*sin(q41L)-2*Lb1^2*MZ3*MY4* ...
       cos(q41L)+2*Lb1^2*MY3*MY4*sin(q41L))/Lb1^2/s(1)*dq31L+(-1/2*(- ...
       Lb1^2*MY4^2*s(3)-Lb1^2*MZ4^2*s(3))/Lb1^2/s(1)-1/2*(MZ4^2*s(3)+ ...
       MY4^2*s(3))/s(1))*dq42L+(-1/2*(-Lb1^2*MY4^2*s(3)-Lb1^2*MZ4^2* ...
       s(3)+Lb1^2*M4*MY4*L3*cos(s(2))+Lb1^2*MY4*MZ3*cos(s(2))-Lb1^2* ...
       MY4*MY3*sin(s(2))-Lb1^2*M4*MZ4*L3*sin(s(2))-Lb1^2*MZ4*MY3* ...
       cos(s(2))-Lb1^2*MY4*MY1*sin(q31L+q41L)+Lb1^2*MY4*MZ1*cos(q31L+ ...
       q41L)-Lb1^2*MZ4*MY1*cos(q31L+q41L)-Lb1^2*MZ4*MZ1*sin(q31L+ ...
       q41L)-Lb1^2*MZ4*MZ3*sin(s(2)))/Lb1^2/s(1)-1/2*(-4*Lb1^2*L3*M3* ...
       MZ4*sin(q41L)+4*Lb1^2*L3*M3*MY4*cos(q41L)-2*Lb1^2*MZ4*L3*M4* ...
       sin(q41L)+2*Lb1^2*MY4*L3*M4*cos(q41L)-2*M1*Lb1^2*L3*MZ4* ...
       sin(q41L)+2*M1*Lb1^2*L3*MY4*cos(q41L)+2*Lb1^2*MZ4*MY3* ...
       cos(q41L)+Lb1^2*MY4^2*s(3)+Lb1^2*MZ4^2*s(3)+2*Lb1^2*MZ4*MZ3* ...
       sin(q41L)-2*Lb1^2*MZ3*MY4*cos(q41L)+2*Lb1^2*MY3*MY4*sin(q41L)- ...
       Lb1^2*M4*MY4*L3*cos(s(2))-Lb1^2*MY4*MZ3*cos(s(2))+Lb1^2*MY4* ...
       MY3*sin(s(2))+Lb1^2*M4*MZ4*L3*sin(s(2))+Lb1^2*MZ4*MY3* ...
       cos(s(2))+Lb1^2*MY4*MY1*sin(q31L+q41L)-Lb1^2*MY4*MZ1*cos(q31L+ ...
       q41L)+Lb1^2*MZ4*MY1*cos(q31L+q41L)+Lb1^2*MZ4*MZ1*sin(q31L+ ...
       q41L)+Lb1^2*MZ4*MZ3*sin(s(2)))/Lb1^2/s(1))*dq1L;
clear s
s(1) = M1+2*M3+2*M4;
s(2) = sin(q31L+q41L-q32L-q42L);
s(3) = -q32L+q31L+q41L;

C(3,2)=(1/2*(M4*MZ4*L3*sin(s(3))-M4*MY4*L3*cos(s(3))+MY3*MZ4* ...
       cos(s(3))-MY4*MZ3*cos(s(3))+MZ3*MZ4*sin(s(3))+MY3*MY4* ...
       sin(s(3))+MZ4^2*s(2)+MY4^2*s(2))/s(1)-1/2*(Lb1^2*MY3*MY4* ...
       sin(s(3))+Lb1^2*MZ3*MZ4*sin(s(3))-Lb1^2*MY4*MZ3*cos(s(3))+ ...
       Lb1^2*MY3*MZ4*cos(s(3))+Lb1^2*MY4^2*s(2)+Lb1^2*MZ4^2*s(2)- ...
       Lb1^2*M4*MY4*L3*cos(s(3))+Lb1^2*M4*MZ4*L3* ...
       sin(s(3)))/Lb1^2/s(1))*dq31L+(-MY3*MY4*sin(s(3))-MZ3*MZ4* ...
       sin(s(3))+MY4*MZ3*cos(s(3))-MY3*MZ4*cos(s(3))-MY4^2*s(2)-MZ4^2* ...
       s(2)+M4*MY4*L3*cos(s(3))-M4*MZ4*L3*sin(s(3)))/s(1)*dq32L+(1/2* ...
       (-MY4^2*s(2)-MZ4^2*s(2))/s(1)-1/2*(Lb1^2*MY4^2*s(2)+Lb1^2* ...
       MZ4^2*s(2))/Lb1^2/s(1))*dq42L+(-1/2*(Lb1^2*MY3*MY4*sin(s(3))+ ...
       Lb1^2*MZ3*MZ4*sin(s(3))-Lb1^2*MY4*MZ3*cos(s(3))+Lb1^2*MY3*MZ4* ...
       cos(s(3))+Lb1^2*MY4^2*s(2)+Lb1^2*MZ4^2*s(2)-Lb1^2*M4*MY4*L3* ...
       cos(s(3))+Lb1^2*M4*MZ4*L3*sin(s(3)))/Lb1^2/s(1)-1/2*(M4*MZ4*L3* ...
       sin(s(3))-M4*MY4*L3*cos(s(3))+MY3*MZ4*cos(s(3))-MY4*MZ3* ...
       cos(s(3))+MZ3*MZ4*sin(s(3))+MY3*MY4*sin(s(3))+MZ4^2*s(2)+MY4^2* ...
       s(2))/s(1))*dq1L;
clear s
s(1) = M1+2*M3+2*M4;
s(2) = q31L-q32L-q42L;
s(3) = sin(q31L+q41L-q32L-q42L);

C(4,1)=(M4*MY4*L3*cos(s(2))+M4*MZ4*L3*sin(s(2))+MY4*MY3*sin(s(2))+MY4* ...
       MZ3*cos(s(2))+MZ4*MZ3*sin(s(2))-MZ4*MY3*cos(s(2))+MZ4^2*s(3)+ ...
       MY4^2*s(3))/s(1)*dq31L+(1/2*(MZ4^2*s(3)+MY4^2*s(3))/s(1)+1/2* ...
       s(3)*(MY4^2+MZ4^2)/s(1))*dq41L+(1/2*(M4*MY4*L3*cos(s(2))+M4* ...
       MZ4*L3*sin(s(2))+MY4*MY3*sin(s(2))+MY4*MZ3*cos(s(2))+MZ4*MZ3* ...
       sin(s(2))-MZ4*MY3*cos(s(2))+MZ4^2*s(3)+MY4^2*s(3))/s(1)-1/2*(- ...
       Lb1^2*MY4*MY3*sin(s(2))-Lb1^2*MY4^2*s(3)-Lb1^2*MZ4^2*s(3)- ...
       Lb1^2*MZ4*MZ3*sin(s(2))-Lb1^2*M4*MZ4*L3*sin(s(2))-Lb1^2*MY4* ...
       MZ3*cos(s(2))+Lb1^2*MZ4*MY3*cos(s(2))-Lb1^2*M4*MY4*L3* ...
       cos(s(2)))/Lb1^2/s(1))*dq1L;
clear s
s(1) = M1+2*M3+2*M4;
s(2) = sin(q31L+q41L-q32L-q42L);
s(3) = q31L-q32L-q42L;

C(4,2)=(1/2*(-M4*MY4*L3*cos(s(3))-M4*MZ4*L3*sin(s(3))-MY3*MY4* ...
       sin(s(3))-MY4*MZ3*cos(s(3))-MZ3*MZ4*sin(s(3))+MY3*MZ4* ...
       cos(s(3))-MZ4^2*s(2)-MY4^2*s(2))/s(1)-1/2*(-Lb1^2*MY3*MY4* ...
       sin(s(3))-Lb1^2*MY4^2*s(2)-Lb1^2*MZ4^2*s(2)-Lb1^2*MZ3*MZ4* ...
       sin(s(3))-Lb1^2*M4*MZ4*L3*sin(s(3))-Lb1^2*MY4*MZ3*cos(s(3))+ ...
       Lb1^2*MY3*MZ4*cos(s(3))-Lb1^2*M4*MY4*L3*cos(s(3)))/Lb1^2/s(1))* ...
       dq31L-1/2*(2*MY3*MY4*sin(q42L)-2*MZ3*MY4*cos(q42L)+2*MY3*MZ4* ...
       cos(q42L)+2*MZ3*MZ4*sin(q42L)+2*M4*MY4*L3*cos(q42L)-2*M4*MZ4* ...
       L3*sin(q42L)-2*M1*MZ4*L3*sin(q42L)-4*MZ4*L3*M3*sin(q42L)+4*MY4* ...
       L3*M3*cos(q42L)+2*M1*MY4*L3*cos(q42L))/s(1)*dq32L+(-1/2*s(2)* ...
       (MY4^2+MZ4^2)/s(1)-1/2*(-MY4^2*s(2)-MZ4^2*s(2))/s(1))*dq41L+ ...
       (1/2*(-MY3*MY4*sin(s(3))-MY4*MZ3*cos(s(3))-MZ3*MZ4*sin(s(3))+ ...
       MY3*MZ4*cos(s(3))-M4*MZ4*L3*sin(s(3))-M4*MY4*L3*cos(s(3))- ...
       MY4^2*s(2)-MZ4^2*s(2)+MY4*MY1*sin(q32L+q42L)-MY4*MZ1*cos(q32L+ ...
       q42L)+MZ4*MZ1*sin(q32L+q42L)+MZ4*MY1*cos(q32L+q42L))/s(1)-1/2* ...
       (-MY3*MY4*sin(s(3))-MY4*MZ3*cos(s(3))-MZ3*MZ4*sin(s(3))+MY3* ...
       MZ4*cos(s(3))+2*MY3*MY4*sin(q42L)-2*MZ3*MY4*cos(q42L)+2*MY3* ...
       MZ4*cos(q42L)+2*MZ3*MZ4*sin(q42L)-M4*MZ4*L3*sin(s(3))-M4*MY4* ...
       L3*cos(s(3))-MY4^2*s(2)-MZ4^2*s(2)+MY4*MY1*sin(q32L+q42L)-MY4* ...
       MZ1*cos(q32L+q42L)+MZ4*MZ1*sin(q32L+q42L)+MZ4*MY1*cos(q32L+ ...
       q42L)+2*M4*MY4*L3*cos(q42L)-2*M4*MZ4*L3*sin(q42L)-2*M1*MZ4*L3* ...
       sin(q42L)-4*MZ4*L3*M3*sin(q42L)+4*MY4*L3*M3*cos(q42L)+2*M1*MY4* ...
       L3*cos(q42L))/s(1))*dq1L;
clear s
s(1) = M1+2*M3+2*M4;
s(2) = sin(q31L+q41L-q32L-q42L);

C(4,3)=(1/2*s(2)*(MY4^2+MZ4^2)/s(1)+1/2*(MZ4^2*s(2)+MY4^2*s(2))/s(1))* ...
       dq31L+(-1/2*s(2)*(MY4^2+MZ4^2)/s(1)-1/2*(-MY4^2*s(2)-MZ4^2* ...
       s(2))/s(1))*dq32L+s(2)*(MY4^2+MZ4^2)/s(1)*dq41L+(1/2*(MZ4^2* ...
       s(2)+MY4^2*s(2))/s(1)-1/2*(-Lb1^2*MZ4^2*s(2)-Lb1^2*MY4^2* ...
       s(2))/Lb1^2/s(1))*dq1L;
clear s
s(1) = M1+2*M3+2*M4;
s(2) = q31L-q32L-q42L;
s(3) = Lb1^2*MZ3*MZ4*sin(q31L-q32L-q42L);
s(4) = Lb1^2*MY3*MZ4*cos(q31L-q32L-q42L);
s(5) = Lb1^2*MY3*MY4*sin(q31L-q32L-q42L);
s(6) = Lb1^2*M4*MY4*L3*cos(q31L-q32L-q42L);
s(7) = Lb1^2*MY4*MZ3*cos(q31L-q32L-q42L);
s(8) = Lb1^2*M4*MZ4*L3*sin(q31L-q32L-q42L);
s(9) = sin(q31L+q41L-q32L-q42L);
s(10) = Lb1^2*MZ4*MZ1*sin(q31L+q41L);
s(11) = -q32L+q31L+q41L;
s(12) = Lb1^2*MZ4*MZ3*sin(-q32L+q31L+q41L);
s(13) = Lb1^2*MZ4*MY1*cos(q31L+q41L);
s(14) = Lb1^2*MY4*MY1*sin(q31L+q41L);
s(15) = Lb1^2*MY4*MY3*sin(-q32L+q31L+q41L);
s(16) = Lb1^2*MZ4*MY3*cos(-q32L+q31L+q41L);
s(17) = Lb1^2*MY4*MZ1*cos(q31L+q41L);
s(18) = Lb1^2*MY4*MZ3*cos(-q32L+q31L+q41L);
s(19) = Lb1^2*M4*MY4*L3*cos(-q32L+q31L+q41L);
s(20) = Lb1^2*M4*MZ4*L3*sin(-q32L+q31L+q41L);

C(5,1)=(-s(4)+s(14)+Lb1^2*M4*L3*MZ1*sin(q31L)+Lb1^2*M4*L3*MY1* ...
       cos(q31L)+Lb1^2*MY3^2*sin(-q32L+q31L)+Lb1^2*MZ3^2*sin(-q32L+ ...
       q31L)+2*Lb1^2*M4*MZ3*L3*sin(-q32L+q31L)+s(12)+s(20)+s(15)+ ...
       s(13)-s(18)+s(5)-Lb1^2*MY3*MZ1*cos(q31L)+Lb1^2*MY1*MY3* ...
       sin(q31L)+Lb1^2*MY1*MZ3*cos(q31L)+Lb1^2*L3^2*M4^2*sin(-q32L+ ...
       q31L)+Lb1^2*MZ1*MZ3*sin(q31L)-s(19)+s(3)+s(8)+s(7)+s(16)+s(10)+ ...
       Lb1^2*MZ4^2*s(9)+Lb1^2*MY4^2*s(9)-s(17)+s(6))/Lb1^2/s(1)*dq31L+ ...
       (1/2*(-Lb1^2*MY3^2*sin(-q32L+q31L)-Lb1^2*MY4^2*s(9)+s(19)-2* ...
       Lb1^2*M4*MZ3*L3*sin(-q32L+q31L)-Lb1^2*MZ4^2*s(9)-Lb1^2*MZ3^2* ...
       sin(-q32L+q31L)-s(8)-s(20)-s(12)-s(15)-s(3)+s(18)-s(7)+s(4)- ...
       s(16)-Lb1^2*L3^2*M4^2*sin(-q32L+q31L)-s(5)-s(6))/Lb1^2/s(1)+ ...
       1/2*(MY3^2*sin(-q32L+q31L)+MY4^2*s(9)+MZ4^2*s(9)+MY3*MY4* ...
       sin(s(2))-MY3*MZ4*cos(s(2))-MY4*MZ3*cos(s(11))+MY4*MY3* ...
       sin(s(11))+L3^2*M4^2*sin(-q32L+q31L)+MZ3*MZ4*sin(s(2))+MZ4*MZ3* ...
       sin(s(11))+MZ3^2*sin(-q32L+q31L)+M4*MZ4*L3*sin(s(2))+M4*MY4*L3* ...
       cos(s(2))+MY4*MZ3*cos(s(2))+2*M4*MZ3*L3*sin(-q32L+q31L)-M4*MY4* ...
       L3*cos(s(11))+M4*MZ4*L3*sin(s(11))+MZ4*MY3*cos(s(11)))/s(1))* ...
       dq32L+(1/2*(4*Lb1^2*L3*M3*MY4*cos(q41L)+Lb1^2*MY4^2*s(9)-s(19)- ...
       2*M1*Lb1^2*L3*MZ4*sin(q41L)-2*Lb1^2*MZ4*L3*M4*sin(q41L)+2* ...
       Lb1^2*MY4*L3*M4*cos(q41L)+2*M1*Lb1^2*L3*MY4*cos(q41L)-4*Lb1^2* ...
       L3*M3*MZ4*sin(q41L)+Lb1^2*MZ4^2*s(9)+s(20)+s(13)+2*Lb1^2*MY3* ...
       MY4*sin(q41L)+s(12)+s(15)-s(18)+s(14)+s(16)-2*Lb1^2*MZ3*MY4* ...
       cos(q41L)+2*Lb1^2*MZ4*MY3*cos(q41L)-s(17)+s(10)+2*Lb1^2*MZ4* ...
       MZ3*sin(q41L))/Lb1^2/s(1)+1/2*(Lb1^2*MY4^2*s(9)-s(19)+Lb1^2* ...
       MZ4^2*s(9)+s(20)+s(13)+s(12)+s(15)-s(18)+s(14)+s(16)-s(17)+ ...
       s(10))/Lb1^2/s(1))*dq41L+(1/2*(-s(5)-Lb1^2*MY4^2*s(9)-Lb1^2* ...
       MZ4^2*s(9)-s(3)-s(8)-s(7)+s(4)-s(6))/Lb1^2/s(1)+1/2*(M4*MY4*L3* ...
       cos(s(2))+M4*MZ4*L3*sin(s(2))+MY3*MY4*sin(s(2))+MY4*MZ3* ...
       cos(s(2))+MZ3*MZ4*sin(s(2))-MY3*MZ4*cos(s(2))+MZ4^2*s(9)+MY4^2* ...
       s(9))/s(1))*dq42L+1/2*(-2*s(4)+2*s(14)+2*Lb1^2*M4*L3*MZ1* ...
       sin(q31L)+2*Lb1^2*M4*L3*MY1*cos(q31L)+2*Lb1^2*MY3^2*sin(-q32L+ ...
       q31L)+2*Lb1^2*MZ3^2*sin(-q32L+q31L)+4*Lb1^2*M4*MZ3*L3*sin(- ...
       q32L+q31L)+2*s(12)+2*s(20)+2*s(15)+2*s(13)-2*s(18)+2*s(5)-2* ...
       Lb1^2*MY3*MZ1*cos(q31L)+2*Lb1^2*MY1*MY3*sin(q31L)+2*Lb1^2*MY1* ...
       MZ3*cos(q31L)+2*Lb1^2*L3^2*M4^2*sin(-q32L+q31L)+2*Lb1^2*MZ1* ...
       MZ3*sin(q31L)-2*s(19)+2*s(3)+2*s(8)+2*s(7)+2*s(16)+2*s(10)+2* ...
       Lb1^2*MZ4^2*s(9)+2*Lb1^2*MY4^2*s(9)-2*s(17)+2*s(6))/Lb1^2/s(1)* ...
       dq1L;
clear s
s(1) = M1+2*M3+2*M4;
s(2) = q31L-q32L-q42L;
s(3) = sin(q31L+q41L-q32L-q42L);
s(4) = -q32L+q31L+q41L;
s(5) = M4*MZ4*L3*sin(q31L-q32L-q42L);
s(6) = M4*MY4*L3*cos(q31L-q32L-q42L);

C(5,2)=(1/2*(-Lb1^2*MY3^2*sin(-q32L+q31L)-Lb1^2*MY4^2*s(3)+Lb1^2*M4* ...
       MY4*L3*cos(s(4))-2*Lb1^2*M4*MZ3*L3*sin(-q32L+q31L)-Lb1^2*MZ4^2* ...
       s(3)-Lb1^2*MZ3^2*sin(-q32L+q31L)-Lb1^2*M4*MZ4*L3*sin(s(2))- ...
       Lb1^2*M4*MZ4*L3*sin(s(4))-Lb1^2*MZ4*MZ3*sin(s(4))-Lb1^2*MY4* ...
       MY3*sin(s(4))-Lb1^2*MZ3*MZ4*sin(s(2))+Lb1^2*MY4*MZ3*cos(s(4))- ...
       Lb1^2*MY4*MZ3*cos(s(2))+Lb1^2*MY3*MZ4*cos(s(2))-Lb1^2*MZ4*MY3* ...
       cos(s(4))-Lb1^2*L3^2*M4^2*sin(-q32L+q31L)-Lb1^2*MY3*MY4* ...
       sin(s(2))-Lb1^2*M4*MY4*L3*cos(s(2)))/Lb1^2/s(1)+1/2*(MY3^2* ...
       sin(-q32L+q31L)+MY4^2*s(3)+MZ4^2*s(3)+MY3*MY4*sin(s(2))-MY3* ...
       MZ4*cos(s(2))-MY4*MZ3*cos(s(4))+MY4*MY3*sin(s(4))+L3^2*M4^2* ...
       sin(-q32L+q31L)+MZ3*MZ4*sin(s(2))+MZ4*MZ3*sin(s(4))+MZ3^2*sin(- ...
       q32L+q31L)+s(5)+s(6)+MY4*MZ3*cos(s(2))+2*M4*MZ3*L3*sin(-q32L+ ...
       q31L)-M4*MY4*L3*cos(s(4))+M4*MZ4*L3*sin(s(4))+MZ4*MY3* ...
       cos(s(4)))/s(1))*dq31L+(-MZ3^2*sin(-q32L+q31L)-L3^2*M4^2*sin(- ...
       q32L+q31L)-MY3^2*sin(-q32L+q31L)+MZ4*MY1*cos(q32L+q42L)+MZ3* ...
       MY1*cos(q32L)-MY4*MZ1*cos(q32L+q42L)+MY3*MY1*sin(q32L)-MY3*MZ1* ...
       cos(q32L)+MZ3*MZ1*sin(q32L)+MZ4*MZ1*sin(q32L+q42L)+MY4*MY1* ...
       sin(q32L+q42L)+M4*MY1*L3*cos(q32L)+M4*MZ1*L3*sin(q32L)-s(5)- ...
       MZ4^2*s(3)-MY4^2*s(3)-2*M4*MZ3*L3*sin(-q32L+q31L)+M4*MY4*L3* ...
       cos(s(4))-M4*MZ4*L3*sin(s(4))+MY4*MZ3*cos(s(4))-MY4*MY3* ...
       sin(s(4))-MZ4*MZ3*sin(s(4))-MZ4*MY3*cos(s(4))-MY3*MY4* ...
       sin(s(2))-MZ3*MZ4*sin(s(2))+MY3*MZ4*cos(s(2))-MY4*MZ3* ...
       cos(s(2))-s(6))/s(1)*dq32L+(1/2*(MZ4^2*s(3)+MY4^2*s(3)-MY4*MZ3* ...
       cos(s(4))+MY4*MY3*sin(s(4))+MZ4*MZ3*sin(s(4))+MZ4*MY3* ...
       cos(s(4))-M4*MY4*L3*cos(s(4))+M4*MZ4*L3*sin(s(4)))/s(1)+1/2* ...
       (Lb1^2*M4*MY4*L3*cos(s(4))-Lb1^2*MZ4*MY3*cos(s(4))-Lb1^2*MY4* ...
       MY3*sin(s(4))-Lb1^2*MZ4*MZ3*sin(s(4))-Lb1^2*M4*MZ4*L3* ...
       sin(s(4))+Lb1^2*MY4*MZ3*cos(s(4))-Lb1^2*MZ4^2*s(3)-Lb1^2*MY4^2* ...
       s(3))/Lb1^2/s(1))*dq41L+(1/2*(2*MZ3*MZ4*sin(q42L)+2*MY3*MZ4* ...
       cos(q42L)+2*MY3*MY4*sin(q42L)-2*MZ3*MY4*cos(q42L)+4*MY4*L3*M3* ...
       cos(q42L)-MZ4^2*s(3)-MY4^2*s(3)-MY4*MZ3*cos(s(2))+MZ4*MY1* ...
       cos(q32L+q42L)+MZ4*MZ1*sin(q32L+q42L)+MY4*MY1*sin(q32L+q42L)- ...
       MY4*MZ1*cos(q32L+q42L)-2*M4*MZ4*L3*sin(q42L)-MY3*MY4*sin(s(2))+ ...
       MY3*MZ4*cos(s(2))-MZ3*MZ4*sin(s(2))-s(6)+2*M4*MY4*L3*cos(q42L)- ...
       4*MZ4*L3*M3*sin(q42L)-2*M1*MZ4*L3*sin(q42L)+2*M1*MY4*L3* ...
       cos(q42L)-s(5))/s(1)+1/2*(-MZ4^2*s(3)-MY4^2*s(3)-MY4*MZ3* ...
       cos(s(2))+MZ4*MY1*cos(q32L+q42L)+MZ4*MZ1*sin(q32L+q42L)+MY4* ...
       MY1*sin(q32L+q42L)-MY4*MZ1*cos(q32L+q42L)-MY3*MY4*sin(s(2))+ ...
       MY3*MZ4*cos(s(2))-MZ3*MZ4*sin(s(2))-s(6)-s(5))/s(1))*dq42L+1/2* ...
       (-2*Lb1^2*MZ4^2*s(3)-2*Lb1^2*MY4^2*s(3)-2*Lb1^2*MY3^2*sin(- ...
       q32L+q31L)-2*Lb1^2*MZ3^2*sin(-q32L+q31L)-4*Lb1^2*M4*MZ3*L3* ...
       sin(-q32L+q31L)-2*Lb1^2*MY4*MZ1*cos(q32L+q42L)+2*Lb1^2*MY3*MY1* ...
       sin(q32L)+2*Lb1^2*MZ3*MZ1*sin(q32L)+2*Lb1^2*MZ3*MY1*cos(q32L)- ...
       2*Lb1^2*MY3*MZ1*cos(q32L)+2*Lb1^2*M4*MY1*L3*cos(q32L)+2*Lb1^2* ...
       M4*MZ1*L3*sin(q32L)+2*Lb1^2*MZ4*MY1*cos(q32L+q42L)+2*Lb1^2*MZ4* ...
       MZ1*sin(q32L+q42L)+2*Lb1^2*MY4*MY1*sin(q32L+q42L)-2*Lb1^2*M4* ...
       MZ4*L3*sin(s(4))-2*Lb1^2*L3^2*M4^2*sin(-q32L+q31L)-2*Lb1^2*MZ4* ...
       MZ3*sin(s(4))-2*Lb1^2*MY4*MY3*sin(s(4))+2*Lb1^2*MY4*MZ3* ...
       cos(s(4))-2*Lb1^2*MZ4*MY3*cos(s(4))+2*Lb1^2*M4*MY4*L3* ...
       cos(s(4))-2*Lb1^2*M4*MZ4*L3*sin(s(2))-2*Lb1^2*MY4*MZ3* ...
       cos(s(2))+2*Lb1^2*MY3*MZ4*cos(s(2))-2*Lb1^2*MZ3*MZ4*sin(s(2))- ...
       2*Lb1^2*M4*MY4*L3*cos(s(2))-2*Lb1^2*MY3*MY4* ...
       sin(s(2)))/Lb1^2/s(1)*dq1L;
clear s
s(1) = M1+2*M3+2*M4;
s(2) = -q32L+q31L+q41L;
s(3) = Lb1^2*M4*MY4*L3*cos(-q32L+q31L+q41L);
s(4) = Lb1^2*M4*MZ4*L3*sin(-q32L+q31L+q41L);
s(5) = Lb1^2*MZ4*MY1*cos(q31L+q41L);
s(6) = sin(q31L+q41L-q32L-q42L);
s(7) = Lb1^2*MZ4*MZ1*sin(q31L+q41L);
s(8) = Lb1^2*MZ4*MZ3*sin(-q32L+q31L+q41L);
s(9) = Lb1^2*MY4*MY3*sin(-q32L+q31L+q41L);
s(10) = Lb1^2*MZ4*MY3*cos(-q32L+q31L+q41L);
s(11) = Lb1^2*MY4*MZ1*cos(q31L+q41L);
s(12) = Lb1^2*MY4*MY1*sin(q31L+q41L);
s(13) = Lb1^2*MY4*MZ3*cos(-q32L+q31L+q41L);

C(5,3)=(1/2*(-s(13)+s(12)-s(11)+s(10)+s(9)+s(8)+s(7)+Lb1^2*MY4^2*s(6)+ ...
       Lb1^2*MZ4^2*s(6)+s(5)+s(4)-s(3))/Lb1^2/s(1)+1/2*(-s(13)+s(12)- ...
       s(11)+s(10)+s(9)+s(8)+s(7)+2*Lb1^2*MZ4*MZ3*sin(q41L)+2*Lb1^2* ...
       MZ4*MY3*cos(q41L)-2*M1*Lb1^2*L3*MZ4*sin(q41L)+Lb1^2*MY4^2*s(6)- ...
       2*Lb1^2*MZ3*MY4*cos(q41L)+2*Lb1^2*MY3*MY4*sin(q41L)+Lb1^2* ...
       MZ4^2*s(6)+s(5)+s(4)-s(3)-4*Lb1^2*L3*M3*MZ4*sin(q41L)-2*Lb1^2* ...
       MZ4*L3*M4*sin(q41L)+4*Lb1^2*L3*M3*MY4*cos(q41L)+2*Lb1^2*MY4*L3* ...
       M4*cos(q41L)+2*M1*Lb1^2*L3*MY4*cos(q41L))/Lb1^2/s(1))*dq31L+ ...
       (1/2*(MZ4^2*s(6)+MY4^2*s(6)-MY4*MZ3*cos(s(2))+MY4*MY3* ...
       sin(s(2))+MZ4*MZ3*sin(s(2))+MZ4*MY3*cos(s(2))-M4*MY4*L3* ...
       cos(s(2))+M4*MZ4*L3*sin(s(2)))/s(1)+1/2*(s(3)-s(10)-s(9)-s(8)- ...
       s(4)+s(13)-Lb1^2*MZ4^2*s(6)-Lb1^2*MY4^2*s(6))/Lb1^2/s(1))* ...
       dq32L+(-s(13)+s(12)-s(11)+s(10)+s(9)+s(8)+s(7)+Lb1^2*MZ4*MZ3* ...
       sin(q41L)+Lb1^2*MZ4*MY3*cos(q41L)-M1*Lb1^2*L3*MZ4*sin(q41L)+ ...
       Lb1^2*MY4^2*s(6)-Lb1^2*MZ3*MY4*cos(q41L)+Lb1^2*MY3*MY4* ...
       sin(q41L)+Lb1^2*MZ4^2*s(6)+s(5)+s(4)-s(3)-2*Lb1^2*L3*M3*MZ4* ...
       sin(q41L)-Lb1^2*MZ4*L3*M4*sin(q41L)+2*Lb1^2*L3*M3*MY4* ...
       cos(q41L)+Lb1^2*MY4*L3*M4*cos(q41L)+M1*Lb1^2*L3*MY4* ...
       cos(q41L))/Lb1^2/s(1)*dq41L+(1/2*(-Lb1^2*MY4^2*s(6)-Lb1^2* ...
       MZ4^2*s(6))/Lb1^2/s(1)+1/2*(MZ4^2*s(6)+MY4^2*s(6))/s(1))*dq42L+ ...
       1/2*(-2*s(13)+2*s(12)-2*s(11)+2*s(10)+2*s(9)+2*s(8)+2*s(7)+2* ...
       Lb1^2*MZ4*MZ3*sin(q41L)+2*Lb1^2*MZ4*MY3*cos(q41L)-2*M1*Lb1^2* ...
       L3*MZ4*sin(q41L)+2*Lb1^2*MY4^2*s(6)-2*Lb1^2*MZ3*MY4*cos(q41L)+ ...
       2*Lb1^2*MY3*MY4*sin(q41L)+2*Lb1^2*MZ4^2*s(6)+2*s(5)+2*s(4)-2* ...
       s(3)-4*Lb1^2*L3*M3*MZ4*sin(q41L)-2*Lb1^2*MZ4*L3*M4*sin(q41L)+4* ...
       Lb1^2*L3*M3*MY4*cos(q41L)+2*Lb1^2*MY4*L3*M4*cos(q41L)+2*M1* ...
       Lb1^2*L3*MY4*cos(q41L))/Lb1^2/s(1)*dq1L;
clear s
s(1) = M1+2*M3+2*M4;
s(2) = q31L-q32L-q42L;
s(3) = sin(q31L+q41L-q32L-q42L);
s(4) = M4*MZ4*L3*sin(q31L-q32L-q42L);
s(5) = M4*MY4*L3*cos(q31L-q32L-q42L);

C(5,4)=(1/2*(MY4*MY3*sin(s(2))+MZ4^2*s(3)+MY4^2*s(3)+MZ4*MZ3* ...
       sin(s(2))-MZ4*MY3*cos(s(2))+s(5)+MY4*MZ3*cos(s(2))+s(4))/s(1)+ ...
       1/2*(-Lb1^2*MY4^2*s(3)-Lb1^2*MZ4^2*s(3)-Lb1^2*MY3*MY4* ...
       sin(s(2))+Lb1^2*MY3*MZ4*cos(s(2))-Lb1^2*MY4*MZ3*cos(s(2))- ...
       Lb1^2*MZ3*MZ4*sin(s(2))-Lb1^2*M4*MZ4*L3*sin(s(2))-Lb1^2*M4*MY4* ...
       L3*cos(s(2)))/Lb1^2/s(1))*dq31L+(1/2*(-MY4*MY3*sin(s(2))-MZ4^2* ...
       s(3)-MY4^2*s(3)-MZ4*MZ3*sin(s(2))+MZ4*MY3*cos(s(2))-s(5)-MY4* ...
       MZ3*cos(s(2))+MZ4*MY1*cos(q32L+q42L)-s(4)+MY4*MY1*sin(q32L+ ...
       q42L)+MZ4*MZ1*sin(q32L+q42L)-MY4*MZ1*cos(q32L+q42L))/s(1)+1/2* ...
       (-MY4*MY3*sin(s(2))-MZ4^2*s(3)-MY4^2*s(3)-MZ4*MZ3*sin(s(2))+ ...
       MZ4*MY3*cos(s(2))-2*M4*MZ4*L3*sin(q42L)+2*M1*MY4*L3*cos(q42L)- ...
       2*MZ3*MY4*cos(q42L)+2*MZ3*MZ4*sin(q42L)-s(5)+2*MY3*MZ4* ...
       cos(q42L)-MY4*MZ3*cos(s(2))+MZ4*MY1*cos(q32L+q42L)-s(4)-2*M1* ...
       MZ4*L3*sin(q42L)+MY4*MY1*sin(q32L+q42L)+MZ4*MZ1*sin(q32L+q42L)+ ...
       2*MY3*MY4*sin(q42L)-MY4*MZ1*cos(q32L+q42L)+2*M4*MY4*L3* ...
       cos(q42L)+4*MY4*L3*M3*cos(q42L)-4*MZ4*L3*M3*sin(q42L))/s(1))* ...
       dq32L+(1/2*(-Lb1^2*MY4^2*s(3)-Lb1^2*MZ4^2*s(3))/Lb1^2/s(1)+1/2* ...
       (MZ4^2*s(3)+MY4^2*s(3))/s(1))*dq41L+(-MY4*MY3*sin(s(2))-MZ4^2* ...
       s(3)-MY4^2*s(3)-MZ4*MZ3*sin(s(2))+MZ4*MY3*cos(s(2))-M4*MZ4*L3* ...
       sin(q42L)+M1*MY4*L3*cos(q42L)-MZ3*MY4*cos(q42L)+MZ3*MZ4* ...
       sin(q42L)-s(5)+MY3*MZ4*cos(q42L)-MY4*MZ3*cos(s(2))+MZ4*MY1* ...
       cos(q32L+q42L)-s(4)-M1*MZ4*L3*sin(q42L)+MY4*MY1*sin(q32L+q42L)+ ...
       MZ4*MZ1*sin(q32L+q42L)+MY3*MY4*sin(q42L)-MY4*MZ1*cos(q32L+ ...
       q42L)+M4*MY4*L3*cos(q42L)+2*MY4*L3*M3*cos(q42L)-2*MZ4*L3*M3* ...
       sin(q42L))/s(1)*dq42L+1/2*(-2*Lb1^2*MY4^2*s(3)-2*Lb1^2*MZ4^2* ...
       s(3)+2*Lb1^2*M4*MY4*L3*cos(q42L)+4*Lb1^2*MY4*L3*M3*cos(q42L)+2* ...
       M1*Lb1^2*MY4*L3*cos(q42L)-2*M1*Lb1^2*MZ4*L3*sin(q42L)+2*Lb1^2* ...
       MY3*MY4*sin(q42L)+2*Lb1^2*MZ3*MZ4*sin(q42L)+2*Lb1^2*MY4*MY1* ...
       sin(q32L+q42L)+2*Lb1^2*MZ4*MZ1*sin(q32L+q42L)-2*Lb1^2*MZ3*MY4* ...
       cos(q42L)+2*Lb1^2*MZ4*MY1*cos(q32L+q42L)-2*Lb1^2*MY4*MZ1* ...
       cos(q32L+q42L)+2*Lb1^2*MY3*MZ4*cos(q42L)-2*Lb1^2*M4*MZ4*L3* ...
       sin(q42L)-4*Lb1^2*MZ4*L3*M3*sin(q42L)-2*Lb1^2*MY3*MY4* ...
       sin(s(2))+2*Lb1^2*MY3*MZ4*cos(s(2))-2*Lb1^2*MY4*MZ3*cos(s(2))- ...
       2*Lb1^2*MZ3*MZ4*sin(s(2))-2*Lb1^2*M4*MZ4*L3*sin(s(2))-2*Lb1^2* ...
       M4*MY4*L3*cos(s(2)))/Lb1^2/s(1)*dq1L;
clear s
s(1) = q31L-q32L-q42L;
s(2) = sin(q31L+q41L-q32L-q42L);
s(3) = -q32L+q31L+q41L;

C(5,5)=(-dq42L*M4*MY4*L3*cos(s(1))-dq42L*M4*MZ4*L3*sin(s(1))-dq32L*M4* ...
       MZ4*L3*sin(s(1))-dq32L*M4*MY4*L3*cos(s(1))+dq31L*M4*MY4*L3* ...
       cos(s(1))+dq31L*M4*MZ4*L3*sin(s(1))+dq31L*M4*L3*MY1*cos(q31L)- ...
       dq41L*M4*MY4*L3*cos(s(3))+dq41L*M4*MZ4*L3*sin(s(3))+dq32L*M4* ...
       MY4*L3*cos(s(3))+dq31L*MY4*MY3*sin(s(3))+dq31L*MZ4*MY3* ...
       cos(s(3))-dq32L*MY4*MY3*sin(s(3))-dq32L*MZ4*MY3*cos(s(3))+ ...
       dq41L*MZ4*MZ3*sin(s(3))-dq41L*MY4*MZ3*cos(s(3))+dq41L*MZ4*MY3* ...
       cos(s(3))+dq41L*MY4*MY3*sin(s(3))-dq32L*MZ4*MZ3*sin(s(3))+ ...
       dq32L*MY4*MZ3*cos(s(3))+dq31L*M4*MZ4*L3*sin(s(3))-dq32L*M4*MZ4* ...
       L3*sin(s(3))-dq31L*M4*MY4*L3*cos(s(3))+dq41L*MZ4^2*s(2)-dq42L* ...
       MZ4^2*s(2)-dq32L*MY4^2*s(2)+dq41L*MY4^2*s(2)+dq31L*MY4^2*s(2)+ ...
       dq31L*MZ4^2*s(2)-dq32L*MZ4^2*s(2)-dq42L*MY4^2*s(2)-dq42L*MY4* ...
       MZ3*cos(s(1))+dq31L*MY3*MY4*sin(s(1))+dq31L*MY4*MZ3*cos(s(1))- ...
       dq31L*MY3*MZ4*cos(s(1))-dq32L*MZ3*MZ4*sin(s(1))+dq31L*MZ3*MZ4* ...
       sin(s(1))-dq32L*MY4*MZ3*cos(s(1))+dq32L*MY3*MZ4*cos(s(1))- ...
       dq32L*MY3*MY4*sin(s(1))+dq31L*MZ4*MY1*cos(q31L+q41L)+dq31L*MY1* ...
       MZ3*cos(q31L)+dq31L*MY4*MY1*sin(q31L+q41L)-dq42L*MZ3*MZ4* ...
       sin(s(1))+dq32L*MZ4*MZ1*sin(q32L+q42L)+dq32L*MZ4*MY1*cos(q32L+ ...
       q42L)+dq31L*MY1*MY3*sin(q31L)-dq31L*MY4*MZ1*cos(q31L+q41L)+ ...
       dq31L*M4*L3*MZ1*sin(q31L)+dq42L*MY3*MZ4*cos(s(1))-dq42L*MY3* ...
       MY4*sin(s(1))-dq42L*MZ3*MY4*cos(q42L)-dq32L*MZ3^2*sin(-q32L+ ...
       q31L)+dq31L*MZ3^2*sin(-q32L+q31L)+dq32L*M4*MZ1*L3*sin(q32L)- ...
       dq32L*MY4*MZ1*cos(q32L+q42L)-dq31L*MY3*MZ1*cos(q31L)+dq31L*MZ4* ...
       MZ1*sin(q31L+q41L)+dq32L*MZ3*MY1*cos(q32L)+dq32L*MZ3*MZ1* ...
       sin(q32L)-dq32L*MY3*MZ1*cos(q32L)+dq32L*MY3*MY1*sin(q32L)- ...
       dq32L*L3^2*M4^2*sin(-q32L+q31L)+dq41L*MY3*MY4*sin(q41L)+dq32L* ...
       MY4*MY1*sin(q32L+q42L)+dq42L*M4*MY4*L3*cos(q42L)+dq42L*M1*MY4* ...
       L3*cos(q42L)+dq41L*MZ4*MZ1*sin(q31L+q41L)+dq41L*MZ4*MY1* ...
       cos(q31L+q41L)+dq31L*MZ1*MZ3*sin(q31L)-dq32L*MY3^2*sin(-q32L+ ...
       q31L)+dq32L*M4*MY1*L3*cos(q32L)+dq42L*MY3*MY4*sin(q42L)+dq42L* ...
       MY4*MY1*sin(q32L+q42L)+dq42L*MZ4*MZ1*sin(q32L+q42L)+dq41L*MY4* ...
       L3*M4*cos(q41L)-dq41L*MZ4*L3*M4*sin(q41L)-dq41L*MZ3*MY4* ...
       cos(q41L)+dq42L*MZ3*MZ4*sin(q42L)-dq41L*MY4*MZ1*cos(q31L+q41L)- ...
       dq41L*M1*L3*MZ4*sin(q41L)+dq41L*M1*L3*MY4*cos(q41L)-dq42L*M4* ...
       MZ4*L3*sin(q42L)+dq42L*MZ4*MY1*cos(q32L+q42L)-dq42L*MY4*MZ1* ...
       cos(q32L+q42L)+dq42L*MY3*MZ4*cos(q42L)+dq41L*MZ4*MZ3*sin(q41L)+ ...
       dq41L*MY4*MY1*sin(q31L+q41L)+dq41L*MZ4*MY3*cos(q41L)+2*dq41L* ...
       L3*M3*MY4*cos(q41L)-2*dq42L*MZ4*L3*M3*sin(q42L)+2*dq42L*MY4*L3* ...
       M3*cos(q42L)+dq31L*MY3^2*sin(-q32L+q31L)+2*dq31L*M4*MZ3*L3* ...
       sin(-q32L+q31L)-2*dq32L*M4*MZ3*L3*sin(-q32L+q31L)-2*dq41L*L3* ...
       M3*MZ4*sin(q41L)-dq42L*M1*MZ4*L3*sin(q42L)+dq31L*L3^2*M4^2* ...
       sin(-q32L+q31L)-dq31L*MY4*MZ3*cos(s(3))+dq31L*MZ4*MZ3* ...
       sin(s(3)))/(M1+2*M3+2*M4);
%
%
%
%
G=zeros(7,1);
G(1)=g*(PEwc+PEcc+PEbc)*(-cos(q31L+q1L)*MY3+sin(q31L+q1L)*MZ3+L3* ...
       sin(q31L+q1L)*M4-cos(q31L+q41L+q1L)*MY4+sin(q31L+q41L+q1L)* ...
       MZ4)/(M1+2*M3+2*M4)/Lb1;
G(2)=-g*(PEwc+PEcc+PEbc)*(cos(q32L+q1L)*MY3-sin(q32L+q1L)*MZ3-L3* ...
       sin(q32L+q1L)*M4+cos(q32L+q42L+q1L)*MY4-sin(q32L+q42L+q1L)* ...
       MZ4)/(M1+2*M3+2*M4)/Lb1;
G(3)=g*(-cos(q31L+q41L+q1L)*MY4+sin(q31L+q41L+q1L)*MZ4)*(PEwc+PEcc+ ...
       PEbc)/(M1+2*M3+2*M4)/Lb1;
G(4)=g*(-cos(q32L+q42L+q1L)*MY4+sin(q32L+q42L+q1L)*MZ4)*(PEwc+PEcc+ ...
       PEbc)/(M1+2*M3+2*M4)/Lb1;
G(5)=g*(PEwc+PEcc+PEbc)*(-cos(q1L)*MY1+sin(q1L)*MZ1-cos(q31L+q1L)* ...
       MY3+sin(q31L+q1L)*MZ3-cos(q32L+q1L)*MY3+sin(q32L+q1L)*MZ3+L3* ...
       sin(q31L+q1L)*M4-cos(q31L+q41L+q1L)*MY4+sin(q31L+q41L+q1L)*MZ4+ ...
       L3*sin(q32L+q1L)*M4-cos(q32L+q42L+q1L)*MY4+sin(q32L+q42L+q1L)* ...
       MZ4)/(M1+2*M3+2*M4)/Lb1;
G(6)=0;
G(7)=(Lb1*M1+2*Lb1*M3+2*Lb1*M4+PEbc+PEcc+PEwc)*g/Lb1;
%
%
%
B=zeros(7,4);
B(1,1)=1;
B(2,2)=1;
B(3,3)=1;
B(4,4)=1;
%
%
%
E1=zeros(7,4);
E1(1,1)=(sin(q31L+q1L)*MY3+cos(q31L+q1L)*MZ3+L3*cos(q31L+q1L)*M4+sin(q31L+q41L+q1L)*MY4+cos(q31L+q41L+q1L)*MZ4)/(M1+2*M3+2*M4)-L3*cos(q31L+q1L)-L4*cos(q31L+q41L+q1L);
E1(1,2)=-(cos(q31L+q1L)*MY3-sin(q31L+q1L)*MZ3-L3*sin(q31L+q1L)*M4+cos(q31L+q41L+q1L)*MY4-sin(q31L+q41L+q1L)*MZ4)/(M1+2*M3+2*M4)-L3*sin(q31L+q1L)-L4*sin(q31L+q41L+q1L);
E1(1,3)=(sin(q31L+q1L)*MY3+cos(q31L+q1L)*MZ3+L3*cos(q31L+q1L)*M4+sin(q31L+q41L+q1L)*MY4+cos(q31L+q41L+q1L)*MZ4)/(M1+2*M3+2*M4);
E1(1,4)=-(cos(q31L+q1L)*MY3-sin(q31L+q1L)*MZ3-L3*sin(q31L+q1L)*M4+cos(q31L+q41L+q1L)*MY4-sin(q31L+q41L+q1L)*MZ4)/(M1+2*M3+2*M4);
E1(2,1)=(sin(q32L+q1L)*MY3+cos(q32L+q1L)*MZ3+L3*cos(q32L+q1L)*M4+sin(q32L+q42L+q1L)*MY4+cos(q32L+q42L+q1L)*MZ4)/(M1+2*M3+2*M4);
E1(2,2)=-(cos(q32L+q1L)*MY3-sin(q32L+q1L)*MZ3-L3*sin(q32L+q1L)*M4+cos(q32L+q42L+q1L)*MY4-sin(q32L+q42L+q1L)*MZ4)/(M1+2*M3+2*M4);
E1(2,3)=(sin(q32L+q1L)*MY3+cos(q32L+q1L)*MZ3+L3*cos(q32L+q1L)*M4+sin(q32L+q42L+q1L)*MY4+cos(q32L+q42L+q1L)*MZ4)/(M1+2*M3+2*M4)-L3*cos(q32L+q1L)-L4*cos(q32L+q42L+q1L);
E1(2,4)=-(cos(q32L+q1L)*MY3-sin(q32L+q1L)*MZ3-L3*sin(q32L+q1L)*M4+cos(q32L+q42L+q1L)*MY4-sin(q32L+q42L+q1L)*MZ4)/(M1+2*M3+2*M4)-L3*sin(q32L+q1L)-L4*sin(q32L+q42L+q1L);
E1(3,1)=(sin(q31L+q41L+q1L)*MY4+cos(q31L+q41L+q1L)*MZ4)/(M1+2*M3+2*M4)-L4*cos(q31L+q41L+q1L);
E1(3,2)=-(cos(q31L+q41L+q1L)*MY4-sin(q31L+q41L+q1L)*MZ4)/(M1+2*M3+2*M4)-L4*sin(q31L+q41L+q1L);
E1(3,3)=(sin(q31L+q41L+q1L)*MY4+cos(q31L+q41L+q1L)*MZ4)/(M1+2*M3+2*M4);
E1(3,4)=-(cos(q31L+q41L+q1L)*MY4-sin(q31L+q41L+q1L)*MZ4)/(M1+2*M3+2*M4);
E1(4,1)=(sin(q32L+q42L+q1L)*MY4+cos(q32L+q42L+q1L)*MZ4)/(M1+2*M3+2*M4);
E1(4,2)=-(cos(q32L+q42L+q1L)*MY4-sin(q32L+q42L+q1L)*MZ4)/(M1+2*M3+2*M4);
E1(4,3)=(sin(q32L+q42L+q1L)*MY4+cos(q32L+q42L+q1L)*MZ4)/(M1+2*M3+2*M4)-L4*cos(q32L+q42L+q1L);
E1(4,4)=-(cos(q32L+q42L+q1L)*MY4-sin(q32L+q42L+q1L)*MZ4)/(M1+2*M3+2*M4)-L4*sin(q32L+q42L+q1L);
E1(5,1)=(sin(q1L)*MY1+cos(q1L)*MZ1+sin(q31L+q1L)*MY3+cos(q31L+q1L)*MZ3+sin(q32L+q1L)*MY3+cos(q32L+q1L)*MZ3+L3*cos(q31L+q1L)*M4+sin(q31L+q41L+q1L)*MY4+cos(q31L+q41L+q1L)*MZ4+L3*cos(q32L+q1L)*M4+sin(q32L+q42L+q1L)*MY4+cos(q32L+q42L+q1L)*MZ4)/(M1+2*M3+2*M4)-L3*cos(q31L+q1L)-L4*cos(q31L+q41L+q1L);
E1(5,2)=-(cos(q1L)*MY1-sin(q1L)*MZ1+cos(q31L+q1L)*MY3-sin(q31L+q1L)*MZ3+cos(q32L+q1L)*MY3-sin(q32L+q1L)*MZ3-L3*sin(q31L+q1L)*M4+cos(q31L+q41L+q1L)*MY4-sin(q31L+q41L+q1L)*MZ4-L3*sin(q32L+q1L)*M4+cos(q32L+q42L+q1L)*MY4-sin(q32L+q42L+q1L)*MZ4)/(M1+2*M3+2*M4)-L3*sin(q31L+q1L)-L4*sin(q31L+q41L+q1L);
E1(5,3)=(sin(q1L)*MY1+cos(q1L)*MZ1+sin(q31L+q1L)*MY3+cos(q31L+q1L)*MZ3+sin(q32L+q1L)*MY3+cos(q32L+q1L)*MZ3+L3*cos(q31L+q1L)*M4+sin(q31L+q41L+q1L)*MY4+cos(q31L+q41L+q1L)*MZ4+L3*cos(q32L+q1L)*M4+sin(q32L+q42L+q1L)*MY4+cos(q32L+q42L+q1L)*MZ4)/(M1+2*M3+2*M4)-L3*cos(q32L+q1L)-L4*cos(q32L+q42L+q1L);
E1(5,4)=-(cos(q1L)*MY1-sin(q1L)*MZ1+cos(q31L+q1L)*MY3-sin(q31L+q1L)*MZ3+cos(q32L+q1L)*MY3-sin(q32L+q1L)*MZ3-L3*sin(q31L+q1L)*M4+cos(q31L+q41L+q1L)*MY4-sin(q31L+q41L+q1L)*MZ4-L3*sin(q32L+q1L)*M4+cos(q32L+q42L+q1L)*MY4-sin(q32L+q42L+q1L)*MZ4)/(M1+2*M3+2*M4)-L3*sin(q32L+q1L)-L4*sin(q32L+q42L+q1L);
E1(6,1)=1;
E1(6,3)=1;
E1(7,2)=-(-M1-2*M3-2*M4)/(M1+2*M3+2*M4);
E1(7,4)=-(-M1-2*M3-2*M4)/(M1+2*M3+2*M4);
%
%
%
EFV=zeros(7,1);
EFV(1)=FV1*dq31L;
EFV(2)=FV2*dq32L;
EFV(3)=FV3*dq41L;
EFV(4)=FV4*dq42L;
%
%
%
EFS=zeros(7,1);
EFS(1)=2*FS1/pi*atan(5*dq31L);
EFS(2)=2*FS2/pi*atan(5*dq32L);
EFS(3)=2*FS3/pi*atan(5*dq41L);
EFS(4)=2*FS4/pi*atan(5*dq42L);
