function [D,C,G,B,EFV,EFS] = dyn_mod_lap_red(q,dq)
% DYN_MOD_LAP_RED
%   [D,C,G,B,EFV,EFS] = DYN_MOD_LAP_RED(Q,DQ)  is the kneed biped 
%    walking model.

%Eric Westervelt
%04-Mar-2003 10:28:48

modelP;

q31L=q(1); q32L=q(2); q41L=q(3); q42L=q(4); q1L=q(5);
dq31L=dq(1); dq32L=dq(2); dq41L=dq(3); dq42L=dq(4); dq1L= dq(5);

% D matrix
D=zeros(5);
D(1,1)=(-2*MZ3*L4*Lb1^2*cos(q41L)+XX3*Lb1^2-2*MZ4*L4*Lb1^2+2*M4*L4^2* ...
       Lb1^2+M1*L4^2*Lb1^2+2*M3*L3^2*Lb1^2+2*MY3*L4*Lb1^2*sin(q41L)+IA3* ...
       Lb1^2+M1*L3^2*Lb1^2-2*MZ3*L3*Lb1^2+M4*L3^2*Lb1^2+4*XXb*L3*L4+4* ...
       XXc*L3*L4+2*XXc*L3^2+2*XXc*L4^2+4*M3*L3*L4*Lb1^2*cos(q41L)+4*XXw* ...
       L3*L4+2*XXw*L4^2+XX4*Lb1^2+2*M3*L4^2*Lb1^2+2*XXw*L3^2+2*XXb*L4^2+ ...
       2*XXb*L3^2+2*M4*L3*L4*Lb1^2*cos(q41L)+2*M1*L3*L4*Lb1^2* ...
       cos(q41L))/Lb1^2;
D(1,2)=-MZ4*L3*cos(q32L+q42L-q31L)-MZ4*L4*cos(q32L+q42L-q31L-q41L)-MY4* ...
       L4*sin(q32L+q42L-q31L-q41L)-MY4*L3*sin(q32L+q42L-q31L)-MY3*L4* ...
       sin(q32L-q31L-q41L)-MZ3*L4*cos(q32L-q31L-q41L)-MY3*L3*sin(q32L- ...
       q31L)-M4*L3^2*cos(q32L-q31L)-MZ3*L3*cos(q32L-q31L)-M4*L4*L3* ...
       cos(q32L-q31L-q41L);
D(1,3)=(2*XXw*L3^2+M4*L3*L4*Lb1^2*cos(q41L)+4*XXc*L3*L4+2*M3*L3*L4* ...
       Lb1^2*cos(q41L)+4*XXb*L3*L4+2*M4*L4^2*Lb1^2-2*MZ4*L4*Lb1^2+2*M3* ...
       L4^2*Lb1^2+2*XXw*L4^2-MZ3*L4*Lb1^2*cos(q41L)+M1*L3*L4*Lb1^2* ...
       cos(q41L)+MY3*L4*Lb1^2*sin(q41L)+M1*L4^2*Lb1^2+4*XXw*L3*L4+2*XXc* ...
       L4^2+2*XXb*L4^2+XX4*Lb1^2+2*XXb*L3^2+2*XXc*L3^2)/Lb1^2;
D(1,4)=-MZ4*L4*cos(q32L+q42L-q31L-q41L)-MZ4*L3*cos(q32L+q42L-q31L)-MY4* ...
       L3*sin(q32L+q42L-q31L)-MY4*L4*sin(q32L+q42L-q31L-q41L);
D(1,5)=(-2*MZ3*L4*Lb1^2*cos(q41L)+XX3*Lb1^2-MY4*L4*Lb1^2*sin(q32L+q42L- ...
       q31L-q41L)-MY4*L3*Lb1^2*sin(q32L+q42L-q31L)-2*MZ4*L4*Lb1^2+2*M4* ...
       L4^2*Lb1^2-MZ3*L3*Lb1^2*cos(q32L-q31L)-MZ4*L4*Lb1^2*cos(q32L+ ...
       q42L-q31L-q41L)-MZ3*L4*Lb1^2*cos(q32L-q31L-q41L)+M1*L4^2*Lb1^2+2* ...
       M3*L3^2*Lb1^2+2*MY3*L4*Lb1^2*sin(q41L)+M1*L3^2*Lb1^2-2*MZ3*L3* ...
       Lb1^2+M4*L3^2*Lb1^2+2*XXb*L3*L4+2*XXc*L3*L4+2*XXc*L4^2+4*M3*L3* ...
       L4*Lb1^2*cos(q41L)+2*XXw*L3*L4+2*XXw*L4^2+XX4*Lb1^2+2*M3*L4^2* ...
       Lb1^2+2*XXb*L4^2+2*M4*L3*L4*Lb1^2*cos(q41L)+2*M1*L3*L4*Lb1^2* ...
       cos(q41L)+MY1*L3*Lb1^2*sin(q31L)-M4*L4*L3*Lb1^2*cos(q32L-q31L- ...
       q41L)-MY3*L3*Lb1^2*sin(q32L-q31L)-MZ4*L3*Lb1^2*cos(q32L+q42L- ...
       q31L)-MY3*L4*Lb1^2*sin(q32L-q31L-q41L)-M4*L3^2*Lb1^2*cos(q32L- ...
       q31L)+MY1*L4*Lb1^2*sin(q31L+q41L)-MZ1*L3*Lb1^2*cos(q31L)-MZ1*L4* ...
       Lb1^2*cos(q31L+q41L))/Lb1^2;
D(2,1)=-MZ4*L3*cos(q32L+q42L-q31L)-MZ4*L4*cos(q32L+q42L-q31L-q41L)-MY4* ...
       L4*sin(q32L+q42L-q31L-q41L)-MY4*L3*sin(q32L+q42L-q31L)-MY3*L4* ...
       sin(q32L-q31L-q41L)-MZ3*L4*cos(q32L-q31L-q41L)-MY3*L3*sin(q32L- ...
       q31L)-M4*L3^2*cos(q32L-q31L)-MZ3*L3*cos(q32L-q31L)-M4*L4*L3* ...
       cos(q32L-q31L-q41L);
D(2,2)=2*MY4*L3*sin(q42L)+2*MZ4*L3*cos(q42L)+XX4+XX3+M4*L3^2+IA3;
D(2,3)=-L4*(MZ3*cos(q32L-q31L-q41L)+MY4*sin(q32L+q42L-q31L-q41L)+MZ4* ...
       cos(q32L+q42L-q31L-q41L)+MY3*sin(q32L-q31L-q41L)+M4*L3*cos(q32L- ...
       q31L-q41L));
D(2,4)=MZ4*L3*cos(q42L)+MY4*L3*sin(q42L)+XX4;
D(2,5)=-MZ4*L3*cos(q32L+q42L-q31L)-MY4*L4*sin(q32L+q42L-q31L-q41L)+2* ...
       MY4*L3*sin(q42L)+2*MZ4*L3*cos(q42L)-MY4*L3*sin(q32L+q42L-q31L)- ...
       MZ4*L4*cos(q32L+q42L-q31L-q41L)-MZ3*L3*cos(q32L-q31L)-MY3*L4* ...
       sin(q32L-q31L-q41L)-MZ3*L4*cos(q32L-q31L-q41L)-MY3*L3*sin(q32L- ...
       q31L)-M4*L3^2*cos(q32L-q31L)+XX3+M4*L3^2+XX4-M4*L4*L3*cos(q32L- ...
       q31L-q41L);
D(3,1)=(2*XXw*L3^2+M4*L3*L4*Lb1^2*cos(q41L)+4*XXc*L3*L4+2*M3*L3*L4* ...
       Lb1^2*cos(q41L)+4*XXb*L3*L4+2*M4*L4^2*Lb1^2-2*MZ4*L4*Lb1^2+2*M3* ...
       L4^2*Lb1^2+2*XXw*L4^2-MZ3*L4*Lb1^2*cos(q41L)+M1*L3*L4*Lb1^2* ...
       cos(q41L)+MY3*L4*Lb1^2*sin(q41L)+M1*L4^2*Lb1^2+4*XXw*L3*L4+2*XXc* ...
       L4^2+2*XXb*L4^2+XX4*Lb1^2+2*XXb*L3^2+2*XXc*L3^2)/Lb1^2;
D(3,2)=-L4*(MZ3*cos(q32L-q31L-q41L)+MY4*sin(q32L+q42L-q31L-q41L)+MZ4* ...
       cos(q32L+q42L-q31L-q41L)+MY3*sin(q32L-q31L-q41L)+M4*L3*cos(q32L- ...
       q31L-q41L));
D(3,3)=(2*XXw*L3^2+IA4*Lb1^2+4*XXc*L3*L4+4*XXb*L3*L4+2*M4*L4^2*Lb1^2-2* ...
       MZ4*L4*Lb1^2+2*M3*L4^2*Lb1^2+2*XXw*L4^2+M1*L4^2*Lb1^2+4*XXw*L3* ...
       L4+2*XXc*L4^2+2*XXb*L4^2+XX4*Lb1^2+2*XXb*L3^2+2*XXc*L3^2)/Lb1^2;
D(3,4)=-L4*(MY4*sin(q32L+q42L-q31L-q41L)+MZ4*cos(q32L+q42L-q31L-q41L));
D(3,5)=(-2*MZ4*L4*Lb1^2+2*XXw*L3*L4+2*M4*L4^2*Lb1^2+2*M3*L4^2*Lb1^2+2* ...
       XXb*L3*L4-MZ3*L4*Lb1^2*cos(q41L)-MY3*L4*Lb1^2*sin(q32L-q31L- ...
       q41L)+M4*L3*L4*Lb1^2*cos(q41L)-MZ1*L4*Lb1^2*cos(q31L+q41L)-MZ3* ...
       L4*Lb1^2*cos(q32L-q31L-q41L)-MY4*L4*Lb1^2*sin(q32L+q42L-q31L- ...
       q41L)-MZ4*L4*Lb1^2*cos(q32L+q42L-q31L-q41L)-M4*L4*L3*Lb1^2* ...
       cos(q32L-q31L-q41L)+M1*L4^2*Lb1^2+MY1*L4*Lb1^2*sin(q31L+q41L)+2* ...
       M3*L3*L4*Lb1^2*cos(q41L)+2*XXc*L3*L4+2*XXc*L4^2+XX4*Lb1^2+2*XXw* ...
       L4^2+2*XXb*L4^2+M1*L3*L4*Lb1^2*cos(q41L)+MY3*L4*Lb1^2* ...
       sin(q41L))/Lb1^2;
D(4,1)=-MZ4*L4*cos(q32L+q42L-q31L-q41L)-MZ4*L3*cos(q32L+q42L-q31L)-MY4* ...
       L3*sin(q32L+q42L-q31L)-MY4*L4*sin(q32L+q42L-q31L-q41L);
D(4,2)=MZ4*L3*cos(q42L)+MY4*L3*sin(q42L)+XX4;
D(4,3)=-L4*(MY4*sin(q32L+q42L-q31L-q41L)+MZ4*cos(q32L+q42L-q31L-q41L));
D(4,4)=IA4+XX4;
D(4,5)=MY4*L3*sin(q42L)-MZ4*L4*cos(q32L+q42L-q31L-q41L)-MZ4*L3*cos(q32L+ ...
       q42L-q31L)-MY4*L4*sin(q32L+q42L-q31L-q41L)+MZ4*L3*cos(q42L)-MY4* ...
       L3*sin(q32L+q42L-q31L)+XX4;
D(5,1)=(-2*MZ3*L4*Lb1^2*cos(q41L)+XX3*Lb1^2-MY4*L4*Lb1^2*sin(q32L+q42L- ...
       q31L-q41L)-MY4*L3*Lb1^2*sin(q32L+q42L-q31L)-2*MZ4*L4*Lb1^2+2*M4* ...
       L4^2*Lb1^2-MZ3*L3*Lb1^2*cos(q32L-q31L)-MZ4*L4*Lb1^2*cos(q32L+ ...
       q42L-q31L-q41L)-MZ3*L4*Lb1^2*cos(q32L-q31L-q41L)+M1*L4^2*Lb1^2+2* ...
       M3*L3^2*Lb1^2+2*MY3*L4*Lb1^2*sin(q41L)+M1*L3^2*Lb1^2-2*MZ3*L3* ...
       Lb1^2+M4*L3^2*Lb1^2+2*XXb*L3*L4+2*XXc*L3*L4+2*XXc*L4^2+4*M3*L3* ...
       L4*Lb1^2*cos(q41L)+2*XXw*L3*L4+2*XXw*L4^2+XX4*Lb1^2+2*M3*L4^2* ...
       Lb1^2+2*XXb*L4^2+2*M4*L3*L4*Lb1^2*cos(q41L)+2*M1*L3*L4*Lb1^2* ...
       cos(q41L)+MY1*L3*Lb1^2*sin(q31L)-M4*L4*L3*Lb1^2*cos(q32L-q31L- ...
       q41L)-MY3*L3*Lb1^2*sin(q32L-q31L)-MZ4*L3*Lb1^2*cos(q32L+q42L- ...
       q31L)-MY3*L4*Lb1^2*sin(q32L-q31L-q41L)-M4*L3^2*Lb1^2*cos(q32L- ...
       q31L)+MY1*L4*Lb1^2*sin(q31L+q41L)-MZ1*L3*Lb1^2*cos(q31L)-MZ1*L4* ...
       Lb1^2*cos(q31L+q41L))/Lb1^2;
D(5,2)=-MZ4*L3*cos(q32L+q42L-q31L)-MY4*L4*sin(q32L+q42L-q31L-q41L)+2* ...
       MY4*L3*sin(q42L)+2*MZ4*L3*cos(q42L)-MY4*L3*sin(q32L+q42L-q31L)- ...
       MZ4*L4*cos(q32L+q42L-q31L-q41L)-MZ3*L3*cos(q32L-q31L)-MY3*L4* ...
       sin(q32L-q31L-q41L)-MZ3*L4*cos(q32L-q31L-q41L)-MY3*L3*sin(q32L- ...
       q31L)-M4*L3^2*cos(q32L-q31L)+XX3+M4*L3^2+XX4-M4*L4*L3*cos(q32L- ...
       q31L-q41L);
D(5,3)=(-2*MZ4*L4*Lb1^2+2*XXw*L3*L4+2*M4*L4^2*Lb1^2+2*M3*L4^2*Lb1^2+2* ...
       XXb*L3*L4-MZ3*L4*Lb1^2*cos(q41L)-MY3*L4*Lb1^2*sin(q32L-q31L- ...
       q41L)+M4*L3*L4*Lb1^2*cos(q41L)-MZ1*L4*Lb1^2*cos(q31L+q41L)-MZ3* ...
       L4*Lb1^2*cos(q32L-q31L-q41L)-MY4*L4*Lb1^2*sin(q32L+q42L-q31L- ...
       q41L)-MZ4*L4*Lb1^2*cos(q32L+q42L-q31L-q41L)-M4*L4*L3*Lb1^2* ...
       cos(q32L-q31L-q41L)+M1*L4^2*Lb1^2+MY1*L4*Lb1^2*sin(q31L+q41L)+2* ...
       M3*L3*L4*Lb1^2*cos(q41L)+2*XXc*L3*L4+2*XXc*L4^2+XX4*Lb1^2+2*XXw* ...
       L4^2+2*XXb*L4^2+M1*L3*L4*Lb1^2*cos(q41L)+MY3*L4*Lb1^2* ...
       sin(q41L))/Lb1^2;
D(5,4)=MY4*L3*sin(q42L)-MZ4*L4*cos(q32L+q42L-q31L-q41L)-MZ4*L3*cos(q32L+ ...
       q42L-q31L)-MY4*L4*sin(q32L+q42L-q31L-q41L)+MZ4*L3*cos(q42L)-MY4* ...
       L3*sin(q32L+q42L-q31L)+XX4;
D(5,5)=(-2*MZ3*L4*Lb1^2*cos(q41L)+2*XX3*Lb1^2-2*MY4*L4*Lb1^2*sin(q32L+ ...
       q42L-q31L-q41L)-2*MY4*L3*Lb1^2*sin(q32L+q42L-q31L)-2*MZ4*L4* ...
       Lb1^2+2*M4*L4^2*Lb1^2-2*MZ3*L3*Lb1^2*cos(q32L-q31L)-2*MZ4*L4* ...
       Lb1^2*cos(q32L+q42L-q31L-q41L)-2*MZ3*L4*Lb1^2*cos(q32L-q31L- ...
       q41L)+M1*L4^2*Lb1^2+2*M3*L3^2*Lb1^2+2*MY3*L4*Lb1^2*sin(q41L)+M1* ...
       L3^2*Lb1^2-2*MZ3*L3*Lb1^2+2*M4*L3^2*Lb1^2+2*XXc*L4^2+4*M3*L3*L4* ...
       Lb1^2*cos(q41L)+2*XXw*L4^2+2*XX4*Lb1^2+2*M3*L4^2*Lb1^2+2*XXb* ...
       L4^2+2*M4*L3*L4*Lb1^2*cos(q41L)+2*M1*L3*L4*Lb1^2*cos(q41L)+2*MY1* ...
       L3*Lb1^2*sin(q31L)-2*M4*L4*L3*Lb1^2*cos(q32L-q31L-q41L)-2*MY3*L3* ...
       Lb1^2*sin(q32L-q31L)-2*MZ4*L3*Lb1^2*cos(q32L+q42L-q31L)-2*MY3*L4* ...
       Lb1^2*sin(q32L-q31L-q41L)-2*M4*L3^2*Lb1^2*cos(q32L-q31L)+2*MY1* ...
       L4*Lb1^2*sin(q31L+q41L)-2*MZ1*L3*Lb1^2*cos(q31L)-2*MZ1*L4*Lb1^2* ...
       cos(q31L+q41L)+2*MY4*L3*Lb1^2*sin(q42L)+2*MZ4*L3*Lb1^2*cos(q42L)+ ...
       XX1*Lb1^2)/Lb1^2;

% C matrix
C=zeros(5);
C(1,1)=-L4*(-MZ3*sin(q41L)-MY3*cos(q41L)+2*M3*L3*sin(q41L)+M4*L3* ...
       sin(q41L)+M1*L3*sin(q41L))*dq41L;
C(1,2)=dq32L*MZ4*L3*sin(q32L+q42L-q31L)+dq32L*MZ4*L4*sin(q32L+q42L-q31L- ...
       q41L)-dq32L*MY4*L4*cos(q32L+q42L-q31L-q41L)-dq32L*MY4*L3* ...
       cos(q32L+q42L-q31L)-dq32L*MY3*L4*cos(q32L-q31L-q41L)+dq32L*MZ3* ...
       L4*sin(q32L-q31L-q41L)-dq32L*MY3*L3*cos(q32L-q31L)+dq32L*M4*L3^2* ...
       sin(q32L-q31L)+dq32L*MZ3*L3*sin(q32L-q31L)+dq32L*M4*L4*L3* ...
       sin(q32L-q31L-q41L)+dq42L*MZ4*L3*sin(q32L+q42L-q31L)+dq42L*MZ4* ...
       L4*sin(q32L+q42L-q31L-q41L)-dq42L*MY4*L4*cos(q32L+q42L-q31L- ...
       q41L)-dq42L*MY4*L3*cos(q32L+q42L-q31L)+dq1L*MZ4*L3*sin(q32L+q42L- ...
       q31L)+dq1L*MZ4*L4*sin(q32L+q42L-q31L-q41L)-dq1L*MY4*L4*cos(q32L+ ...
       q42L-q31L-q41L)-dq1L*MY4*L3*cos(q32L+q42L-q31L)-dq1L*MY3*L4* ...
       cos(q32L-q31L-q41L)+dq1L*MZ3*L4*sin(q32L-q31L-q41L)-dq1L*MY3*L3* ...
       cos(q32L-q31L)+dq1L*M4*L3^2*sin(q32L-q31L)+dq1L*MZ3*L3*sin(q32L- ...
       q31L)+dq1L*M4*L4*L3*sin(q32L-q31L-q41L);
C(1,3)=-L4*(-MZ3*sin(q41L)-MY3*cos(q41L)+2*M3*L3*sin(q41L)+M4*L3* ...
       sin(q41L)+M1*L3*sin(q41L))*(dq31L+dq41L+dq1L);
C(1,4)=(MZ4*L3*sin(q32L+q42L-q31L)+MZ4*L4*sin(q32L+q42L-q31L-q41L)-MY4* ...
       L4*cos(q32L+q42L-q31L-q41L)-MY4*L3*cos(q32L+q42L-q31L))*(dq32L+ ...
       dq42L+dq1L);
C(1,5)=dq1L*MZ3*L4*sin(q32L-q31L-q41L)-dq1L*MY3*L3*cos(q32L-q31L)-dq1L* ...
       MY3*L4*cos(q32L-q31L-q41L)+dq1L*M4*L3^2*sin(q32L-q31L)-L4*dq41L* ...
       M4*L3*sin(q41L)-dq1L*MZ1*L4*sin(q31L+q41L)-L4*dq41L*M1*L3* ...
       sin(q41L)-dq1L*MZ1*L3*sin(q31L)-dq1L*MY1*L3*cos(q31L)-dq1L*MY1* ...
       L4*cos(q31L+q41L)+L4*dq41L*MZ3*sin(q41L)+L4*dq41L*MY3*cos(q41L)- ...
       2*L4*dq41L*M3*L3*sin(q41L)+dq1L*MZ3*L3*sin(q32L-q31L)+dq1L*M4*L4* ...
       L3*sin(q32L-q31L-q41L)-dq32L*MY4*L4*cos(q32L+q42L-q31L-q41L)- ...
       dq32L*MY4*L3*cos(q32L+q42L-q31L)+dq32L*MZ3*L3*sin(q32L-q31L)+ ...
       dq32L*MZ4*L4*sin(q32L+q42L-q31L-q41L)+dq32L*MZ3*L4*sin(q32L-q31L- ...
       q41L)-dq32L*MY3*L3*cos(q32L-q31L)+dq32L*MZ4*L3*sin(q32L+q42L- ...
       q31L)-dq32L*MY3*L4*cos(q32L-q31L-q41L)+dq32L*M4*L3^2*sin(q32L- ...
       q31L)+dq42L*MZ4*L3*sin(q32L+q42L-q31L)-dq42L*MY4*L4*cos(q32L+ ...
       q42L-q31L-q41L)-dq42L*MY4*L3*cos(q32L+q42L-q31L)+dq32L*M4*L4*L3* ...
       sin(q32L-q31L-q41L)+dq42L*MZ4*L4*sin(q32L+q42L-q31L-q41L)-dq1L* ...
       MY4*L3*cos(q32L+q42L-q31L)+dq1L*MZ4*L3*sin(q32L+q42L-q31L)-dq1L* ...
       MY4*L4*cos(q32L+q42L-q31L-q41L)+dq1L*MZ4*L4*sin(q32L+q42L-q31L- ...
       q41L);
C(2,1)=-dq1L*MZ3*L4*sin(q32L-q31L-q41L)+dq1L*MY3*L3*cos(q32L-q31L)+dq1L* ...
       MY3*L4*cos(q32L-q31L-q41L)-dq1L*M4*L3^2*sin(q32L-q31L)-dq31L*MZ3* ...
       L3*sin(q32L-q31L)-dq31L*MZ3*L4*sin(q32L-q31L-q41L)+dq31L*MY3*L3* ...
       cos(q32L-q31L)+dq31L*MY3*L4*cos(q32L-q31L-q41L)-dq31L*M4*L3^2* ...
       sin(q32L-q31L)+L4*dq41L*MY3*cos(q32L-q31L-q41L)-L4*dq41L*MZ3* ...
       sin(q32L-q31L-q41L)-dq1L*MZ3*L3*sin(q32L-q31L)-L4*dq41L*M4*L3* ...
       sin(q32L-q31L-q41L)-dq1L*M4*L4*L3*sin(q32L-q31L-q41L)-dq31L*M4* ...
       L4*L3*sin(q32L-q31L-q41L)-dq31L*MZ4*L4*sin(q32L+q42L-q31L-q41L)+ ...
       dq31L*MY4*L4*cos(q32L+q42L-q31L-q41L)-dq31L*MZ4*L3*sin(q32L+q42L- ...
       q31L)+dq31L*MY4*L3*cos(q32L+q42L-q31L)-L4*dq41L*MZ4*sin(q32L+ ...
       q42L-q31L-q41L)+L4*dq41L*MY4*cos(q32L+q42L-q31L-q41L)+dq1L*MY4* ...
       L3*cos(q32L+q42L-q31L)-dq1L*MZ4*L3*sin(q32L+q42L-q31L)+dq1L*MY4* ...
       L4*cos(q32L+q42L-q31L-q41L)-dq1L*MZ4*L4*sin(q32L+q42L-q31L-q41L);
C(2,2)=-L3*(-MY4*cos(q42L)+MZ4*sin(q42L))*dq42L;
C(2,3)=L4*(-MZ3*sin(q32L-q31L-q41L)+MY4*cos(q32L+q42L-q31L-q41L)-MZ4* ...
       sin(q32L+q42L-q31L-q41L)+MY3*cos(q32L-q31L-q41L)-M4*L3*sin(q32L- ...
       q31L-q41L))*(dq31L+dq41L+dq1L);
C(2,4)=-L3*(dq32L+dq42L+dq1L)*(-MY4*cos(q42L)+MZ4*sin(q42L));
C(2,5)=-dq1L*MZ3*L4*sin(q32L-q31L-q41L)+dq1L*MY3*L3*cos(q32L-q31L)+dq1L* ...
       MY3*L4*cos(q32L-q31L-q41L)-dq1L*M4*L3^2*sin(q32L-q31L)-dq31L*MZ3* ...
       L3*sin(q32L-q31L)-dq31L*MZ3*L4*sin(q32L-q31L-q41L)+dq31L*MY3*L3* ...
       cos(q32L-q31L)+dq31L*MY3*L4*cos(q32L-q31L-q41L)-dq31L*M4*L3^2* ...
       sin(q32L-q31L)+L4*dq41L*MY3*cos(q32L-q31L-q41L)-L4*dq41L*MZ3* ...
       sin(q32L-q31L-q41L)-dq1L*MZ3*L3*sin(q32L-q31L)-L4*dq41L*M4*L3* ...
       sin(q32L-q31L-q41L)-dq1L*M4*L4*L3*sin(q32L-q31L-q41L)-dq31L*M4* ...
       L4*L3*sin(q32L-q31L-q41L)+dq42L*MY4*L3*cos(q42L)-dq42L*MZ4*L3* ...
       sin(q42L)-dq31L*MZ4*L4*sin(q32L+q42L-q31L-q41L)+dq31L*MY4*L4* ...
       cos(q32L+q42L-q31L-q41L)-dq31L*MZ4*L3*sin(q32L+q42L-q31L)+dq31L* ...
       MY4*L3*cos(q32L+q42L-q31L)-L4*dq41L*MZ4*sin(q32L+q42L-q31L-q41L)+ ...
       L4*dq41L*MY4*cos(q32L+q42L-q31L-q41L)+dq1L*MY4*L3*cos(q32L+q42L- ...
       q31L)-dq1L*MZ4*L3*sin(q32L+q42L-q31L)+dq1L*MY4*L4*cos(q32L+q42L- ...
       q31L-q41L)-dq1L*MZ4*L4*sin(q32L+q42L-q31L-q41L);
C(3,1)=L4*(-MZ3*sin(q41L)-MY3*cos(q41L)+2*M3*L3*sin(q41L)+M4*L3* ...
       sin(q41L)+M1*L3*sin(q41L))*(dq31L+dq1L);
C(3,2)=-L4*(dq32L*MY3*cos(q32L-q31L-q41L)-dq32L*MZ3*sin(q32L-q31L-q41L)+ ...
       dq32L*MY4*cos(q32L+q42L-q31L-q41L)-dq32L*MZ4*sin(q32L+q42L-q31L- ...
       q41L)-dq32L*M4*L3*sin(q32L-q31L-q41L)+dq42L*MY4*cos(q32L+q42L- ...
       q31L-q41L)-dq42L*MZ4*sin(q32L+q42L-q31L-q41L)+dq1L*MY3*cos(q32L- ...
       q31L-q41L)-dq1L*MZ3*sin(q32L-q31L-q41L)+dq1L*MY4*cos(q32L+q42L- ...
       q31L-q41L)-dq1L*MZ4*sin(q32L+q42L-q31L-q41L)-dq1L*M4*L3*sin(q32L- ...
       q31L-q41L));
C(3,4)=L4*(-MY4*cos(q32L+q42L-q31L-q41L)+MZ4*sin(q32L+q42L-q31L-q41L))* ...
       (dq32L+dq42L+dq1L);
C(3,5)=-L4*(dq31L*MZ3*sin(q41L)+dq31L*MY3*cos(q41L)-2*dq31L*M3*L3* ...
       sin(q41L)-dq31L*M4*L3*sin(q41L)-dq31L*M1*L3*sin(q41L)+dq32L*MY3* ...
       cos(q32L-q31L-q41L)-dq32L*MZ3*sin(q32L-q31L-q41L)+dq32L*MY4* ...
       cos(q32L+q42L-q31L-q41L)-dq32L*MZ4*sin(q32L+q42L-q31L-q41L)- ...
       dq32L*M4*L3*sin(q32L-q31L-q41L)+dq42L*MY4*cos(q32L+q42L-q31L- ...
       q41L)-dq42L*MZ4*sin(q32L+q42L-q31L-q41L)+dq1L*MZ3*sin(q41L)+dq1L* ...
       MY3*cos(q41L)-dq1L*MZ4*sin(q32L+q42L-q31L-q41L)+dq1L*MY4* ...
       cos(q32L+q42L-q31L-q41L)-dq1L*MZ3*sin(q32L-q31L-q41L)+dq1L*MZ1* ...
       sin(q31L+q41L)-dq1L*M1*L3*sin(q41L)-2*dq1L*M3*L3*sin(q41L)-dq1L* ...
       M4*L3*sin(q41L)+dq1L*MY3*cos(q32L-q31L-q41L)-dq1L*M4*L3*sin(q32L- ...
       q31L-q41L)+dq1L*MY1*cos(q31L+q41L));
C(4,1)=-dq31L*MZ4*L4*sin(q32L+q42L-q31L-q41L)+dq31L*MY4*L4*cos(q32L+ ...
       q42L-q31L-q41L)-dq31L*MZ4*L3*sin(q32L+q42L-q31L)+dq31L*MY4*L3* ...
       cos(q32L+q42L-q31L)+L4*dq41L*MY4*cos(q32L+q42L-q31L-q41L)-L4* ...
       dq41L*MZ4*sin(q32L+q42L-q31L-q41L)-dq1L*MZ4*L4*sin(q32L+q42L- ...
       q31L-q41L)+dq1L*MY4*L4*cos(q32L+q42L-q31L-q41L)-dq1L*MZ4*L3* ...
       sin(q32L+q42L-q31L)+dq1L*MY4*L3*cos(q32L+q42L-q31L);
C(4,2)=L3*(dq1L+dq32L)*(-MY4*cos(q42L)+MZ4*sin(q42L));
C(4,3)=-L4*(-MY4*cos(q32L+q42L-q31L-q41L)+MZ4*sin(q32L+q42L-q31L-q41L))* ...
       (dq31L+dq41L+dq1L);
C(4,5)=-dq31L*MZ4*L4*sin(q32L+q42L-q31L-q41L)+dq31L*MY4*L4*cos(q32L+ ...
       q42L-q31L-q41L)-dq31L*MZ4*L3*sin(q32L+q42L-q31L)+dq31L*MY4*L3* ...
       cos(q32L+q42L-q31L)-dq32L*MY4*L3*cos(q42L)+dq32L*MZ4*L3* ...
       sin(q42L)-L4*dq41L*MZ4*sin(q32L+q42L-q31L-q41L)+L4*dq41L*MY4* ...
       cos(q32L+q42L-q31L-q41L)+dq1L*MY4*L3*cos(q32L+q42L-q31L)-dq1L* ...
       MZ4*L3*sin(q32L+q42L-q31L)-dq1L*MY4*L3*cos(q42L)+dq1L*MZ4*L3* ...
       sin(q42L)+dq1L*MY4*L4*cos(q32L+q42L-q31L-q41L)-dq1L*MZ4*L4* ...
       sin(q32L+q42L-q31L-q41L);
C(5,1)=-dq1L*MZ3*L4*sin(q32L-q31L-q41L)+dq1L*MY3*L3*cos(q32L-q31L)+dq1L* ...
       MY3*L4*cos(q32L-q31L-q41L)-dq1L*M4*L3^2*sin(q32L-q31L)-dq31L*MZ3* ...
       L3*sin(q32L-q31L)-dq31L*MZ3*L4*sin(q32L-q31L-q41L)+dq31L*MY3*L3* ...
       cos(q32L-q31L)+dq31L*MY3*L4*cos(q32L-q31L-q41L)-L4*dq41L*M4*L3* ...
       sin(q41L)+dq1L*MZ1*L4*sin(q31L+q41L)-dq31L*M4*L3^2*sin(q32L- ...
       q31L)+L4*dq41L*MY3*cos(q32L-q31L-q41L)-L4*dq41L*MZ3*sin(q32L- ...
       q31L-q41L)-L4*dq41L*M1*L3*sin(q41L)+dq31L*MZ1*L4*sin(q31L+q41L)+ ...
       dq31L*MY1*L4*cos(q31L+q41L)+dq1L*MZ1*L3*sin(q31L)+dq1L*MY1*L3* ...
       cos(q31L)+dq1L*MY1*L4*cos(q31L+q41L)+L4*dq41L*MZ3*sin(q41L)+L4* ...
       dq41L*MZ1*sin(q31L+q41L)+L4*dq41L*MY1*cos(q31L+q41L)+L4*dq41L* ...
       MY3*cos(q41L)+dq31L*MZ1*L3*sin(q31L)+dq31L*MY1*L3*cos(q31L)-2*L4* ...
       dq41L*M3*L3*sin(q41L)-dq1L*MZ3*L3*sin(q32L-q31L)-L4*dq41L*M4*L3* ...
       sin(q32L-q31L-q41L)-dq1L*M4*L4*L3*sin(q32L-q31L-q41L)-dq31L*M4* ...
       L4*L3*sin(q32L-q31L-q41L)-dq31L*MZ4*L4*sin(q32L+q42L-q31L-q41L)+ ...
       dq31L*MY4*L4*cos(q32L+q42L-q31L-q41L)-dq31L*MZ4*L3*sin(q32L+q42L- ...
       q31L)+dq31L*MY4*L3*cos(q32L+q42L-q31L)-L4*dq41L*MZ4*sin(q32L+ ...
       q42L-q31L-q41L)+L4*dq41L*MY4*cos(q32L+q42L-q31L-q41L)+dq1L*MY4* ...
       L3*cos(q32L+q42L-q31L)-dq1L*MZ4*L3*sin(q32L+q42L-q31L)+dq1L*MY4* ...
       L4*cos(q32L+q42L-q31L-q41L)-dq1L*MZ4*L4*sin(q32L+q42L-q31L-q41L);
C(5,2)=dq1L*MZ3*L4*sin(q32L-q31L-q41L)-dq1L*MY3*L3*cos(q32L-q31L)-dq1L* ...
       MY3*L4*cos(q32L-q31L-q41L)+dq1L*M4*L3^2*sin(q32L-q31L)+dq1L*MZ3* ...
       L3*sin(q32L-q31L)+dq1L*M4*L4*L3*sin(q32L-q31L-q41L)-dq32L*MY4*L4* ...
       cos(q32L+q42L-q31L-q41L)-dq32L*MY4*L3*cos(q32L+q42L-q31L)+dq32L* ...
       MZ3*L3*sin(q32L-q31L)+dq32L*MZ4*L4*sin(q32L+q42L-q31L-q41L)+ ...
       dq32L*MZ3*L4*sin(q32L-q31L-q41L)-dq32L*MY3*L3*cos(q32L-q31L)+ ...
       dq32L*MZ4*L3*sin(q32L+q42L-q31L)-dq32L*MY3*L4*cos(q32L-q31L- ...
       q41L)+dq32L*M4*L3^2*sin(q32L-q31L)+dq42L*MZ4*L3*sin(q32L+q42L- ...
       q31L)-dq42L*MY4*L4*cos(q32L+q42L-q31L-q41L)-dq42L*MY4*L3* ...
       cos(q32L+q42L-q31L)+dq32L*M4*L4*L3*sin(q32L-q31L-q41L)+dq42L*MZ4* ...
       L4*sin(q32L+q42L-q31L-q41L)+dq42L*MY4*L3*cos(q42L)-dq42L*MZ4*L3* ...
       sin(q42L)-dq1L*MY4*L3*cos(q32L+q42L-q31L)+dq1L*MZ4*L3*sin(q32L+ ...
       q42L-q31L)-dq1L*MY4*L4*cos(q32L+q42L-q31L-q41L)+dq1L*MZ4*L4* ...
       sin(q32L+q42L-q31L-q41L);
C(5,3)=L4*(MZ3*sin(q41L)+MY3*cos(q41L)-MZ4*sin(q32L+q42L-q31L-q41L)+MY4* ...
       cos(q32L+q42L-q31L-q41L)-MZ3*sin(q32L-q31L-q41L)+MZ1*sin(q31L+ ...
       q41L)-M1*L3*sin(q41L)-2*M3*L3*sin(q41L)-M4*L3*sin(q41L)+MY3* ...
       cos(q32L-q31L-q41L)-M4*L3*sin(q32L-q31L-q41L)+MY1*cos(q31L+ ...
       q41L))*(dq31L+dq41L+dq1L);
C(5,4)=-(-MZ4*L3*sin(q32L+q42L-q31L)+MY4*L4*cos(q32L+q42L-q31L-q41L)- ...
       MY4*L3*cos(q42L)+MZ4*L3*sin(q42L)+MY4*L3*cos(q32L+q42L-q31L)-MZ4* ...
       L4*sin(q32L+q42L-q31L-q41L))*(dq32L+dq42L+dq1L);
C(5,5)=-dq31L*MZ3*L3*sin(q32L-q31L)-dq31L*MZ3*L4*sin(q32L-q31L-q41L)+ ...
       dq31L*MY3*L3*cos(q32L-q31L)+dq31L*MY3*L4*cos(q32L-q31L-q41L)-L4* ...
       dq41L*M4*L3*sin(q41L)-dq31L*M4*L3^2*sin(q32L-q31L)+L4*dq41L*MY3* ...
       cos(q32L-q31L-q41L)-L4*dq41L*MZ3*sin(q32L-q31L-q41L)-L4*dq41L*M1* ...
       L3*sin(q41L)+dq31L*MZ1*L4*sin(q31L+q41L)+dq31L*MY1*L4*cos(q31L+ ...
       q41L)+L4*dq41L*MZ3*sin(q41L)+L4*dq41L*MZ1*sin(q31L+q41L)+L4* ...
       dq41L*MY1*cos(q31L+q41L)+L4*dq41L*MY3*cos(q41L)+dq31L*MZ1*L3* ...
       sin(q31L)+dq31L*MY1*L3*cos(q31L)-2*L4*dq41L*M3*L3*sin(q41L)-L4* ...
       dq41L*M4*L3*sin(q32L-q31L-q41L)-dq31L*M4*L4*L3*sin(q32L-q31L- ...
       q41L)-dq32L*MY4*L4*cos(q32L+q42L-q31L-q41L)-dq32L*MY4*L3* ...
       cos(q32L+q42L-q31L)+dq32L*MZ3*L3*sin(q32L-q31L)+dq32L*MZ4*L4* ...
       sin(q32L+q42L-q31L-q41L)+dq32L*MZ3*L4*sin(q32L-q31L-q41L)-dq32L* ...
       MY3*L3*cos(q32L-q31L)+dq32L*MZ4*L3*sin(q32L+q42L-q31L)-dq32L*MY3* ...
       L4*cos(q32L-q31L-q41L)+dq32L*M4*L3^2*sin(q32L-q31L)+dq42L*MZ4*L3* ...
       sin(q32L+q42L-q31L)-dq42L*MY4*L4*cos(q32L+q42L-q31L-q41L)-dq42L* ...
       MY4*L3*cos(q32L+q42L-q31L)+dq32L*M4*L4*L3*sin(q32L-q31L-q41L)+ ...
       dq42L*MZ4*L4*sin(q32L+q42L-q31L-q41L)+dq42L*MY4*L3*cos(q42L)- ...
       dq42L*MZ4*L3*sin(q42L)-dq31L*MZ4*L4*sin(q32L+q42L-q31L-q41L)+ ...
       dq31L*MY4*L4*cos(q32L+q42L-q31L-q41L)-dq31L*MZ4*L3*sin(q32L+q42L- ...
       q31L)+dq31L*MY4*L3*cos(q32L+q42L-q31L)-L4*dq41L*MZ4*sin(q32L+ ...
       q42L-q31L-q41L)+L4*dq41L*MY4*cos(q32L+q42L-q31L-q41L);

% G matrix
G=zeros(5,1);
G(1)=g*(2*Lb1*L4*sin(q31L+q41L+q1L)*M3+Lb1*L3*sin(q31L+q1L)*M1+Lb1*L4* ...
     sin(q31L+q41L+q1L)*M1+Lb1*L3*sin(q31L+q1L)*M4+2*Lb1*L4*sin(q31L+ ...
     q41L+q1L)*M4+Lb1*cos(q31L+q1L)*MY3+Lb1*cos(q31L+q41L+q1L)*MY4- ...
     Lb1*sin(q31L+q1L)*MZ3-Lb1*sin(q31L+q41L+q1L)*MZ4+PEwc*L4* ...
     sin(q31L+q41L+q1L)+PEcc*L4*sin(q31L+q41L+q1L)+PEcc*L3*sin(q31L+ ...
     q1L)+PEbc*L3*sin(q31L+q1L)+PEbc*L4*sin(q31L+q41L+q1L)+PEwc*L3* ...
     sin(q31L+q1L)+2*Lb1*L3*sin(q31L+q1L)*M3)/Lb1;
G(2)=g*(cos(q32L+q1L)*MY3-sin(q32L+q1L)*MZ3-L3*sin(q32L+q1L)*M4+ ...
     cos(q32L+q42L+q1L)*MY4-sin(q32L+q42L+q1L)*MZ4);
G(3)=g*(2*Lb1*L4*sin(q31L+q41L+q1L)*M3+Lb1*L4*sin(q31L+q41L+q1L)*M1+2* ...
     Lb1*L4*sin(q31L+q41L+q1L)*M4+Lb1*cos(q31L+q41L+q1L)*MY4-Lb1* ...
     sin(q31L+q41L+q1L)*MZ4+PEwc*L4*sin(q31L+q41L+q1L)+PEcc*L4* ...
     sin(q31L+q41L+q1L)+PEbc*L4*sin(q31L+q41L+q1L))/Lb1;
G(4)=g*(cos(q32L+q42L+q1L)*MY4-sin(q32L+q42L+q1L)*MZ4);
G(5)=g*(-Lb1*L3*sin(q32L+q1L)*M4+2*Lb1*L4*sin(q31L+q41L+q1L)*M3+Lb1* ...
     L3*sin(q31L+q1L)*M1+Lb1*L4*sin(q31L+q41L+q1L)*M1+Lb1*L3*sin(q31L+ ...
     q1L)*M4+2*Lb1*L4*sin(q31L+q41L+q1L)*M4+Lb1*cos(q32L+q1L)*MY3+Lb1* ...
     cos(q31L+q1L)*MY3+Lb1*cos(q32L+q42L+q1L)*MY4+Lb1*cos(q31L+q41L+ ...
     q1L)*MY4-Lb1*sin(q31L+q1L)*MZ3-Lb1*sin(q31L+q41L+q1L)*MZ4+Lb1* ...
     cos(q1L)*MY1+PEwc*L4*sin(q31L+q41L+q1L)-Lb1*sin(q32L+q1L)*MZ3+ ...
     PEcc*L4*sin(q31L+q41L+q1L)+PEcc*L3*sin(q31L+q1L)-Lb1*sin(q32L+ ...
     q42L+q1L)*MZ4+PEbc*L3*sin(q31L+q1L)+PEbc*L4*sin(q31L+q41L+q1L)- ...
     Lb1*sin(q1L)*MZ1+PEwc*L3*sin(q31L+q1L)+2*Lb1*L3*sin(q31L+q1L)* ...
     M3)/Lb1;

% B matrix
B=zeros(5,4);
B(1,1)=1;
B(2,2)=1;
B(3,3)=1;
B(4,4)=1;

% EFV matrix
EFV=zeros(5,1);
EFV(1)=FV1*dq31L;
EFV(2)=FV2*dq32L;
EFV(3)=FV3*dq41L;
EFV(4)=FV4*dq42L;

% EFS matrix
EFS=zeros(5,1);
EFS(1)=2*FS1/pi*atan(5*dq31L);
EFS(2)=2*FS2/pi*atan(5*dq32L);
EFS(3)=2*FS3/pi*atan(5*dq41L);
EFS(4)=2*FS4/pi*atan(5*dq42L);
