function [x0] = sigma(z2)
% SIGMA
%   [X0] = SIGMA(Z2)  Maps horizontal velocity of hips just before 
%    impact to state of the system just before impact.

%Eric Westervelt
%04-Mar-2003 15:42:16

modelP;

[a,b,m] = controlParameters;

a0=a(1); a1=a(2); a2=a(3); a3=a(4); a4=a(5); a5=a(6); a6=a(7); 
b0=a(8); b1=a(9); b2=a(10); b3=a(11); b4=a(12); b5=a(13); b6=a(14); 
c0=a(15); c1=a(16); c2=a(17); c3=a(18); c4=a(19); c5=a(20); c6=a(21); 
d0=a(22); d1=a(23); d2=a(24); d3=a(25); d4=a(26); d5=a(27); d6=a(28); 

hd1 = a6;
hd2 = b6;
hd3 = c6;
hd4 = d6;

jac_hd1 = 6*(-a5+a6)/m;
jac_hd2 = 6*(-b5+b6)/m;
jac_hd3 = -6*(c5-c6)/m;
jac_hd4 = -6*(d5-d6)/m;

q(1) = hd1;
q(2) = hd2;
q(3) = hd3;
q(4) = hd4;
q(5) = -hd1-1/2*hd3-b-m;
dq(1) = 2*jac_hd1/(-4*M3*L3^2*Lb1^2-4*M3*L4^2*Lb1^2+2*jac_hd3*XXc*L4^2-2* ...
        jac_hd1*XX1*Lb1^2-2*jac_hd1*XX4*Lb1^2-8*M3*L3*L4*Lb1^2*cos(hd3)+ ...
        2*jac_hd2*Lb1^2*XX3+4*MZ1*L3*Lb1^2*cos(hd1)-2*jac_hd1*XX3*Lb1^2+ ...
        4*MZ3*L4*Lb1^2*cos(hd3)+4*MZ1*L4*Lb1^2*cos(hd1+hd3)-jac_hd3*XX1* ...
        Lb1^2+4*M4*L3^2*Lb1^2*cos(-hd2+hd1)+4*MZ3*L3*Lb1^2+2*jac_hd4* ...
        Lb1^2*XX4+4*MZ4*L3*Lb1^2*cos(-hd2-hd4+hd1)-4*MY3*L4*Lb1^2*sin(- ...
        hd2+hd1+hd3)-4*MY4*L4*Lb1^2*sin(-hd2-hd4+hd1+hd3)+4*MZ4*L4*Lb1^2- ...
        2*M1*L4^2*Lb1^2+4*MZ3*L3*Lb1^2*cos(-hd2+hd1)-4*MY4*L3*Lb1^2* ...
        sin(hd4)-4*MY4*L3*Lb1^2*sin(-hd2-hd4+hd1)-4*M1*L3*L4*Lb1^2* ...
        cos(hd3)-4*MY1*L3*Lb1^2*sin(hd1)-4*MY3*L3*Lb1^2*sin(-hd2+hd1)-4* ...
        M4*L3*L4*Lb1^2*cos(hd3)+4*M4*L3*L4*Lb1^2*cos(-hd2+hd1+hd3)-4*MZ4* ...
        L3*Lb1^2*cos(hd4)+4*MZ4*L4*Lb1^2*cos(-hd2-hd4+hd1+hd3)+2*jac_hd4* ...
        Lb1^2*MY4*L3*sin(hd4)-2*jac_hd4*Lb1^2*MZ4*L4*cos(-hd2-hd4+hd1+ ...
        hd3)-2*jac_hd4*Lb1^2*MZ4*L3*cos(-hd2-hd4+hd1)+2*jac_hd4*Lb1^2* ...
        MY4*L4*sin(-hd2-hd4+hd1+hd3)+2*jac_hd4*Lb1^2*MZ4*L3*cos(hd4)+2* ...
        jac_hd4*Lb1^2*MY4*L3*sin(-hd2-hd4+hd1)+4*MZ3*L4*Lb1^2*cos(-hd2+ ...
        hd1+hd3)-2*jac_hd3*MZ4*L3*Lb1^2*cos(hd4)+2*jac_hd3*MZ1*L3*Lb1^2* ...
        cos(hd1)+2*jac_hd3*M4*L3^2*Lb1^2*cos(-hd2+hd1)+2*jac_hd3*MZ4*L3* ...
        Lb1^2*cos(-hd2-hd4+hd1)+2*jac_hd3*MZ3*L3*Lb1^2*cos(-hd2+hd1)-2* ...
        jac_hd3*MY4*L3*Lb1^2*sin(hd4)-2*jac_hd3*MY4*L3*Lb1^2*sin(-hd2- ...
        hd4+hd1)-2*jac_hd3*MY1*L3*Lb1^2*sin(hd1)-2*jac_hd3*MY3*L3*Lb1^2* ...
        sin(-hd2+hd1)+2*jac_hd2*Lb1^2*XX4-2*jac_hd3*M3*L3^2*Lb1^2+2* ...
        jac_hd3*M3*L4^2*Lb1^2+2*jac_hd3*MZ3*L3*Lb1^2-2*jac_hd3*MZ4*L4* ...
        Lb1^2+jac_hd3*M1*L4^2*Lb1^2-jac_hd3*M1*L3^2*Lb1^2-2*jac_hd3*M4* ...
        L3^2*Lb1^2+2*jac_hd3*M4*L4^2*Lb1^2+4*jac_hd3*XXw*L3*L4+4*jac_hd3* ...
        XXb*L3*L4+4*jac_hd3*XXc*L3*L4-2*XX1*Lb1^2-2*jac_hd3*XX3*Lb1^2+2* ...
        jac_hd3*XXw*L4^2+2*jac_hd3*XXb*L4^2-4*MY1*L4*Lb1^2*sin(hd1+hd3)- ...
        2*jac_hd2*Lb1^2*MZ4*L3*cos(-hd2-hd4+hd1)+2*jac_hd2*Lb1^2*MY4*L4* ...
        sin(-hd2-hd4+hd1+hd3)+4*jac_hd2*Lb1^2*MY4*L3*sin(hd4)+4*jac_hd2* ...
        Lb1^2*MZ4*L3*cos(hd4)+2*jac_hd2*Lb1^2*MY4*L3*sin(-hd2-hd4+hd1)-2* ...
        jac_hd2*Lb1^2*MZ4*L4*cos(-hd2-hd4+hd1+hd3)-2*jac_hd2*Lb1^2*MZ3* ...
        L3*cos(-hd2+hd1)+2*jac_hd2*Lb1^2*MY3*L4*sin(-hd2+hd1+hd3)-2* ...
        jac_hd2*Lb1^2*MZ3*L4*cos(-hd2+hd1+hd3)+2*jac_hd2*Lb1^2*MY3*L3* ...
        sin(-hd2+hd1)-2*jac_hd2*Lb1^2*M4*L3^2*cos(-hd2+hd1)-2*jac_hd2* ...
        Lb1^2*M4*L3*L4*cos(-hd2+hd1+hd3)+2*jac_hd2*Lb1^2*M4*L3^2-4*MY3* ...
        L4*Lb1^2*sin(hd3)-2*jac_hd1*M4*L3^2*Lb1^2+4*jac_hd1*XXw*L3*L4+4* ...
        jac_hd1*XXb*L3*L4+4*jac_hd1*XXc*L3*L4+2*jac_hd1*MZ3*L3*Lb1^2* ...
        cos(-hd2+hd1)-4*jac_hd1*MY4*L3*Lb1^2*sin(hd4)-2*jac_hd1*MY4*L3* ...
        Lb1^2*sin(-hd2-hd4+hd1)-2*jac_hd1*MY1*L3*Lb1^2*sin(hd1)+2* ...
        jac_hd1*M4*L3*L4*Lb1^2*cos(-hd2+hd1+hd3)-4*XX4*Lb1^2-4*XX3*Lb1^2- ...
        2*M1*L3^2*Lb1^2-4*M4*L3^2*Lb1^2-4*M4*L4^2*Lb1^2-4*XXc*L4^2-4*XXw* ...
        L4^2-4*XXb*L4^2-2*jac_hd1*MY3*L3*Lb1^2*sin(-hd2+hd1)-4*jac_hd1* ...
        MZ4*L3*Lb1^2*cos(hd4)+2*jac_hd1*MZ4*L4*Lb1^2*cos(-hd2-hd4+hd1+ ...
        hd3)+2*jac_hd1*MZ3*L4*Lb1^2*cos(-hd2+hd1+hd3)-2*jac_hd1*MY1*L4* ...
        Lb1^2*sin(hd1+hd3)+2*jac_hd1*MZ1*L3*Lb1^2*cos(hd1)+2*jac_hd1*MZ1* ...
        L4*Lb1^2*cos(hd1+hd3)+2*jac_hd1*M4*L3^2*Lb1^2*cos(-hd2+hd1)+2* ...
        jac_hd1*MZ4*L3*Lb1^2*cos(-hd2-hd4+hd1)-2*jac_hd1*MY3*L4*Lb1^2* ...
        sin(-hd2+hd1+hd3)-2*jac_hd1*MY4*L4*Lb1^2*sin(-hd2-hd4+hd1+hd3))* ...
        Lb1^2*z2;
dq(2) = 2*jac_hd2/(-4*M3*L3^2*Lb1^2-4*M3*L4^2*Lb1^2+2*jac_hd3*XXc*L4^2-2* ...
        jac_hd1*XX1*Lb1^2-2*jac_hd1*XX4*Lb1^2-8*M3*L3*L4*Lb1^2*cos(hd3)+ ...
        2*jac_hd2*Lb1^2*XX3+4*MZ1*L3*Lb1^2*cos(hd1)-2*jac_hd1*XX3*Lb1^2+ ...
        4*MZ3*L4*Lb1^2*cos(hd3)+4*MZ1*L4*Lb1^2*cos(hd1+hd3)-jac_hd3*XX1* ...
        Lb1^2+4*M4*L3^2*Lb1^2*cos(-hd2+hd1)+4*MZ3*L3*Lb1^2+2*jac_hd4* ...
        Lb1^2*XX4+4*MZ4*L3*Lb1^2*cos(-hd2-hd4+hd1)-4*MY3*L4*Lb1^2*sin(- ...
        hd2+hd1+hd3)-4*MY4*L4*Lb1^2*sin(-hd2-hd4+hd1+hd3)+4*MZ4*L4*Lb1^2- ...
        2*M1*L4^2*Lb1^2+4*MZ3*L3*Lb1^2*cos(-hd2+hd1)-4*MY4*L3*Lb1^2* ...
        sin(hd4)-4*MY4*L3*Lb1^2*sin(-hd2-hd4+hd1)-4*M1*L3*L4*Lb1^2* ...
        cos(hd3)-4*MY1*L3*Lb1^2*sin(hd1)-4*MY3*L3*Lb1^2*sin(-hd2+hd1)-4* ...
        M4*L3*L4*Lb1^2*cos(hd3)+4*M4*L3*L4*Lb1^2*cos(-hd2+hd1+hd3)-4*MZ4* ...
        L3*Lb1^2*cos(hd4)+4*MZ4*L4*Lb1^2*cos(-hd2-hd4+hd1+hd3)+2*jac_hd4* ...
        Lb1^2*MY4*L3*sin(hd4)-2*jac_hd4*Lb1^2*MZ4*L4*cos(-hd2-hd4+hd1+ ...
        hd3)-2*jac_hd4*Lb1^2*MZ4*L3*cos(-hd2-hd4+hd1)+2*jac_hd4*Lb1^2* ...
        MY4*L4*sin(-hd2-hd4+hd1+hd3)+2*jac_hd4*Lb1^2*MZ4*L3*cos(hd4)+2* ...
        jac_hd4*Lb1^2*MY4*L3*sin(-hd2-hd4+hd1)+4*MZ3*L4*Lb1^2*cos(-hd2+ ...
        hd1+hd3)-2*jac_hd3*MZ4*L3*Lb1^2*cos(hd4)+2*jac_hd3*MZ1*L3*Lb1^2* ...
        cos(hd1)+2*jac_hd3*M4*L3^2*Lb1^2*cos(-hd2+hd1)+2*jac_hd3*MZ4*L3* ...
        Lb1^2*cos(-hd2-hd4+hd1)+2*jac_hd3*MZ3*L3*Lb1^2*cos(-hd2+hd1)-2* ...
        jac_hd3*MY4*L3*Lb1^2*sin(hd4)-2*jac_hd3*MY4*L3*Lb1^2*sin(-hd2- ...
        hd4+hd1)-2*jac_hd3*MY1*L3*Lb1^2*sin(hd1)-2*jac_hd3*MY3*L3*Lb1^2* ...
        sin(-hd2+hd1)+2*jac_hd2*Lb1^2*XX4-2*jac_hd3*M3*L3^2*Lb1^2+2* ...
        jac_hd3*M3*L4^2*Lb1^2+2*jac_hd3*MZ3*L3*Lb1^2-2*jac_hd3*MZ4*L4* ...
        Lb1^2+jac_hd3*M1*L4^2*Lb1^2-jac_hd3*M1*L3^2*Lb1^2-2*jac_hd3*M4* ...
        L3^2*Lb1^2+2*jac_hd3*M4*L4^2*Lb1^2+4*jac_hd3*XXw*L3*L4+4*jac_hd3* ...
        XXb*L3*L4+4*jac_hd3*XXc*L3*L4-2*XX1*Lb1^2-2*jac_hd3*XX3*Lb1^2+2* ...
        jac_hd3*XXw*L4^2+2*jac_hd3*XXb*L4^2-4*MY1*L4*Lb1^2*sin(hd1+hd3)- ...
        2*jac_hd2*Lb1^2*MZ4*L3*cos(-hd2-hd4+hd1)+2*jac_hd2*Lb1^2*MY4*L4* ...
        sin(-hd2-hd4+hd1+hd3)+4*jac_hd2*Lb1^2*MY4*L3*sin(hd4)+4*jac_hd2* ...
        Lb1^2*MZ4*L3*cos(hd4)+2*jac_hd2*Lb1^2*MY4*L3*sin(-hd2-hd4+hd1)-2* ...
        jac_hd2*Lb1^2*MZ4*L4*cos(-hd2-hd4+hd1+hd3)-2*jac_hd2*Lb1^2*MZ3* ...
        L3*cos(-hd2+hd1)+2*jac_hd2*Lb1^2*MY3*L4*sin(-hd2+hd1+hd3)-2* ...
        jac_hd2*Lb1^2*MZ3*L4*cos(-hd2+hd1+hd3)+2*jac_hd2*Lb1^2*MY3*L3* ...
        sin(-hd2+hd1)-2*jac_hd2*Lb1^2*M4*L3^2*cos(-hd2+hd1)-2*jac_hd2* ...
        Lb1^2*M4*L3*L4*cos(-hd2+hd1+hd3)+2*jac_hd2*Lb1^2*M4*L3^2-4*MY3* ...
        L4*Lb1^2*sin(hd3)-2*jac_hd1*M4*L3^2*Lb1^2+4*jac_hd1*XXw*L3*L4+4* ...
        jac_hd1*XXb*L3*L4+4*jac_hd1*XXc*L3*L4+2*jac_hd1*MZ3*L3*Lb1^2* ...
        cos(-hd2+hd1)-4*jac_hd1*MY4*L3*Lb1^2*sin(hd4)-2*jac_hd1*MY4*L3* ...
        Lb1^2*sin(-hd2-hd4+hd1)-2*jac_hd1*MY1*L3*Lb1^2*sin(hd1)+2* ...
        jac_hd1*M4*L3*L4*Lb1^2*cos(-hd2+hd1+hd3)-4*XX4*Lb1^2-4*XX3*Lb1^2- ...
        2*M1*L3^2*Lb1^2-4*M4*L3^2*Lb1^2-4*M4*L4^2*Lb1^2-4*XXc*L4^2-4*XXw* ...
        L4^2-4*XXb*L4^2-2*jac_hd1*MY3*L3*Lb1^2*sin(-hd2+hd1)-4*jac_hd1* ...
        MZ4*L3*Lb1^2*cos(hd4)+2*jac_hd1*MZ4*L4*Lb1^2*cos(-hd2-hd4+hd1+ ...
        hd3)+2*jac_hd1*MZ3*L4*Lb1^2*cos(-hd2+hd1+hd3)-2*jac_hd1*MY1*L4* ...
        Lb1^2*sin(hd1+hd3)+2*jac_hd1*MZ1*L3*Lb1^2*cos(hd1)+2*jac_hd1*MZ1* ...
        L4*Lb1^2*cos(hd1+hd3)+2*jac_hd1*M4*L3^2*Lb1^2*cos(-hd2+hd1)+2* ...
        jac_hd1*MZ4*L3*Lb1^2*cos(-hd2-hd4+hd1)-2*jac_hd1*MY3*L4*Lb1^2* ...
        sin(-hd2+hd1+hd3)-2*jac_hd1*MY4*L4*Lb1^2*sin(-hd2-hd4+hd1+hd3))* ...
        Lb1^2*z2;
dq(3) = 2*jac_hd3/(-4*M3*L3^2*Lb1^2-4*M3*L4^2*Lb1^2+2*jac_hd3*XXc*L4^2-2* ...
        jac_hd1*XX1*Lb1^2-2*jac_hd1*XX4*Lb1^2-8*M3*L3*L4*Lb1^2*cos(hd3)+ ...
        2*jac_hd2*Lb1^2*XX3+4*MZ1*L3*Lb1^2*cos(hd1)-2*jac_hd1*XX3*Lb1^2+ ...
        4*MZ3*L4*Lb1^2*cos(hd3)+4*MZ1*L4*Lb1^2*cos(hd1+hd3)-jac_hd3*XX1* ...
        Lb1^2+4*M4*L3^2*Lb1^2*cos(-hd2+hd1)+4*MZ3*L3*Lb1^2+2*jac_hd4* ...
        Lb1^2*XX4+4*MZ4*L3*Lb1^2*cos(-hd2-hd4+hd1)-4*MY3*L4*Lb1^2*sin(- ...
        hd2+hd1+hd3)-4*MY4*L4*Lb1^2*sin(-hd2-hd4+hd1+hd3)+4*MZ4*L4*Lb1^2- ...
        2*M1*L4^2*Lb1^2+4*MZ3*L3*Lb1^2*cos(-hd2+hd1)-4*MY4*L3*Lb1^2* ...
        sin(hd4)-4*MY4*L3*Lb1^2*sin(-hd2-hd4+hd1)-4*M1*L3*L4*Lb1^2* ...
        cos(hd3)-4*MY1*L3*Lb1^2*sin(hd1)-4*MY3*L3*Lb1^2*sin(-hd2+hd1)-4* ...
        M4*L3*L4*Lb1^2*cos(hd3)+4*M4*L3*L4*Lb1^2*cos(-hd2+hd1+hd3)-4*MZ4* ...
        L3*Lb1^2*cos(hd4)+4*MZ4*L4*Lb1^2*cos(-hd2-hd4+hd1+hd3)+2*jac_hd4* ...
        Lb1^2*MY4*L3*sin(hd4)-2*jac_hd4*Lb1^2*MZ4*L4*cos(-hd2-hd4+hd1+ ...
        hd3)-2*jac_hd4*Lb1^2*MZ4*L3*cos(-hd2-hd4+hd1)+2*jac_hd4*Lb1^2* ...
        MY4*L4*sin(-hd2-hd4+hd1+hd3)+2*jac_hd4*Lb1^2*MZ4*L3*cos(hd4)+2* ...
        jac_hd4*Lb1^2*MY4*L3*sin(-hd2-hd4+hd1)+4*MZ3*L4*Lb1^2*cos(-hd2+ ...
        hd1+hd3)-2*jac_hd3*MZ4*L3*Lb1^2*cos(hd4)+2*jac_hd3*MZ1*L3*Lb1^2* ...
        cos(hd1)+2*jac_hd3*M4*L3^2*Lb1^2*cos(-hd2+hd1)+2*jac_hd3*MZ4*L3* ...
        Lb1^2*cos(-hd2-hd4+hd1)+2*jac_hd3*MZ3*L3*Lb1^2*cos(-hd2+hd1)-2* ...
        jac_hd3*MY4*L3*Lb1^2*sin(hd4)-2*jac_hd3*MY4*L3*Lb1^2*sin(-hd2- ...
        hd4+hd1)-2*jac_hd3*MY1*L3*Lb1^2*sin(hd1)-2*jac_hd3*MY3*L3*Lb1^2* ...
        sin(-hd2+hd1)+2*jac_hd2*Lb1^2*XX4-2*jac_hd3*M3*L3^2*Lb1^2+2* ...
        jac_hd3*M3*L4^2*Lb1^2+2*jac_hd3*MZ3*L3*Lb1^2-2*jac_hd3*MZ4*L4* ...
        Lb1^2+jac_hd3*M1*L4^2*Lb1^2-jac_hd3*M1*L3^2*Lb1^2-2*jac_hd3*M4* ...
        L3^2*Lb1^2+2*jac_hd3*M4*L4^2*Lb1^2+4*jac_hd3*XXw*L3*L4+4*jac_hd3* ...
        XXb*L3*L4+4*jac_hd3*XXc*L3*L4-2*XX1*Lb1^2-2*jac_hd3*XX3*Lb1^2+2* ...
        jac_hd3*XXw*L4^2+2*jac_hd3*XXb*L4^2-4*MY1*L4*Lb1^2*sin(hd1+hd3)- ...
        2*jac_hd2*Lb1^2*MZ4*L3*cos(-hd2-hd4+hd1)+2*jac_hd2*Lb1^2*MY4*L4* ...
        sin(-hd2-hd4+hd1+hd3)+4*jac_hd2*Lb1^2*MY4*L3*sin(hd4)+4*jac_hd2* ...
        Lb1^2*MZ4*L3*cos(hd4)+2*jac_hd2*Lb1^2*MY4*L3*sin(-hd2-hd4+hd1)-2* ...
        jac_hd2*Lb1^2*MZ4*L4*cos(-hd2-hd4+hd1+hd3)-2*jac_hd2*Lb1^2*MZ3* ...
        L3*cos(-hd2+hd1)+2*jac_hd2*Lb1^2*MY3*L4*sin(-hd2+hd1+hd3)-2* ...
        jac_hd2*Lb1^2*MZ3*L4*cos(-hd2+hd1+hd3)+2*jac_hd2*Lb1^2*MY3*L3* ...
        sin(-hd2+hd1)-2*jac_hd2*Lb1^2*M4*L3^2*cos(-hd2+hd1)-2*jac_hd2* ...
        Lb1^2*M4*L3*L4*cos(-hd2+hd1+hd3)+2*jac_hd2*Lb1^2*M4*L3^2-4*MY3* ...
        L4*Lb1^2*sin(hd3)-2*jac_hd1*M4*L3^2*Lb1^2+4*jac_hd1*XXw*L3*L4+4* ...
        jac_hd1*XXb*L3*L4+4*jac_hd1*XXc*L3*L4+2*jac_hd1*MZ3*L3*Lb1^2* ...
        cos(-hd2+hd1)-4*jac_hd1*MY4*L3*Lb1^2*sin(hd4)-2*jac_hd1*MY4*L3* ...
        Lb1^2*sin(-hd2-hd4+hd1)-2*jac_hd1*MY1*L3*Lb1^2*sin(hd1)+2* ...
        jac_hd1*M4*L3*L4*Lb1^2*cos(-hd2+hd1+hd3)-4*XX4*Lb1^2-4*XX3*Lb1^2- ...
        2*M1*L3^2*Lb1^2-4*M4*L3^2*Lb1^2-4*M4*L4^2*Lb1^2-4*XXc*L4^2-4*XXw* ...
        L4^2-4*XXb*L4^2-2*jac_hd1*MY3*L3*Lb1^2*sin(-hd2+hd1)-4*jac_hd1* ...
        MZ4*L3*Lb1^2*cos(hd4)+2*jac_hd1*MZ4*L4*Lb1^2*cos(-hd2-hd4+hd1+ ...
        hd3)+2*jac_hd1*MZ3*L4*Lb1^2*cos(-hd2+hd1+hd3)-2*jac_hd1*MY1*L4* ...
        Lb1^2*sin(hd1+hd3)+2*jac_hd1*MZ1*L3*Lb1^2*cos(hd1)+2*jac_hd1*MZ1* ...
        L4*Lb1^2*cos(hd1+hd3)+2*jac_hd1*M4*L3^2*Lb1^2*cos(-hd2+hd1)+2* ...
        jac_hd1*MZ4*L3*Lb1^2*cos(-hd2-hd4+hd1)-2*jac_hd1*MY3*L4*Lb1^2* ...
        sin(-hd2+hd1+hd3)-2*jac_hd1*MY4*L4*Lb1^2*sin(-hd2-hd4+hd1+hd3))* ...
        Lb1^2*z2;
dq(4) = 2*jac_hd4/(-4*M3*L3^2*Lb1^2-4*M3*L4^2*Lb1^2+2*jac_hd3*XXc*L4^2-2* ...
        jac_hd1*XX1*Lb1^2-2*jac_hd1*XX4*Lb1^2-8*M3*L3*L4*Lb1^2*cos(hd3)+ ...
        2*jac_hd2*Lb1^2*XX3+4*MZ1*L3*Lb1^2*cos(hd1)-2*jac_hd1*XX3*Lb1^2+ ...
        4*MZ3*L4*Lb1^2*cos(hd3)+4*MZ1*L4*Lb1^2*cos(hd1+hd3)-jac_hd3*XX1* ...
        Lb1^2+4*M4*L3^2*Lb1^2*cos(-hd2+hd1)+4*MZ3*L3*Lb1^2+2*jac_hd4* ...
        Lb1^2*XX4+4*MZ4*L3*Lb1^2*cos(-hd2-hd4+hd1)-4*MY3*L4*Lb1^2*sin(- ...
        hd2+hd1+hd3)-4*MY4*L4*Lb1^2*sin(-hd2-hd4+hd1+hd3)+4*MZ4*L4*Lb1^2- ...
        2*M1*L4^2*Lb1^2+4*MZ3*L3*Lb1^2*cos(-hd2+hd1)-4*MY4*L3*Lb1^2* ...
        sin(hd4)-4*MY4*L3*Lb1^2*sin(-hd2-hd4+hd1)-4*M1*L3*L4*Lb1^2* ...
        cos(hd3)-4*MY1*L3*Lb1^2*sin(hd1)-4*MY3*L3*Lb1^2*sin(-hd2+hd1)-4* ...
        M4*L3*L4*Lb1^2*cos(hd3)+4*M4*L3*L4*Lb1^2*cos(-hd2+hd1+hd3)-4*MZ4* ...
        L3*Lb1^2*cos(hd4)+4*MZ4*L4*Lb1^2*cos(-hd2-hd4+hd1+hd3)+2*jac_hd4* ...
        Lb1^2*MY4*L3*sin(hd4)-2*jac_hd4*Lb1^2*MZ4*L4*cos(-hd2-hd4+hd1+ ...
        hd3)-2*jac_hd4*Lb1^2*MZ4*L3*cos(-hd2-hd4+hd1)+2*jac_hd4*Lb1^2* ...
        MY4*L4*sin(-hd2-hd4+hd1+hd3)+2*jac_hd4*Lb1^2*MZ4*L3*cos(hd4)+2* ...
        jac_hd4*Lb1^2*MY4*L3*sin(-hd2-hd4+hd1)+4*MZ3*L4*Lb1^2*cos(-hd2+ ...
        hd1+hd3)-2*jac_hd3*MZ4*L3*Lb1^2*cos(hd4)+2*jac_hd3*MZ1*L3*Lb1^2* ...
        cos(hd1)+2*jac_hd3*M4*L3^2*Lb1^2*cos(-hd2+hd1)+2*jac_hd3*MZ4*L3* ...
        Lb1^2*cos(-hd2-hd4+hd1)+2*jac_hd3*MZ3*L3*Lb1^2*cos(-hd2+hd1)-2* ...
        jac_hd3*MY4*L3*Lb1^2*sin(hd4)-2*jac_hd3*MY4*L3*Lb1^2*sin(-hd2- ...
        hd4+hd1)-2*jac_hd3*MY1*L3*Lb1^2*sin(hd1)-2*jac_hd3*MY3*L3*Lb1^2* ...
        sin(-hd2+hd1)+2*jac_hd2*Lb1^2*XX4-2*jac_hd3*M3*L3^2*Lb1^2+2* ...
        jac_hd3*M3*L4^2*Lb1^2+2*jac_hd3*MZ3*L3*Lb1^2-2*jac_hd3*MZ4*L4* ...
        Lb1^2+jac_hd3*M1*L4^2*Lb1^2-jac_hd3*M1*L3^2*Lb1^2-2*jac_hd3*M4* ...
        L3^2*Lb1^2+2*jac_hd3*M4*L4^2*Lb1^2+4*jac_hd3*XXw*L3*L4+4*jac_hd3* ...
        XXb*L3*L4+4*jac_hd3*XXc*L3*L4-2*XX1*Lb1^2-2*jac_hd3*XX3*Lb1^2+2* ...
        jac_hd3*XXw*L4^2+2*jac_hd3*XXb*L4^2-4*MY1*L4*Lb1^2*sin(hd1+hd3)- ...
        2*jac_hd2*Lb1^2*MZ4*L3*cos(-hd2-hd4+hd1)+2*jac_hd2*Lb1^2*MY4*L4* ...
        sin(-hd2-hd4+hd1+hd3)+4*jac_hd2*Lb1^2*MY4*L3*sin(hd4)+4*jac_hd2* ...
        Lb1^2*MZ4*L3*cos(hd4)+2*jac_hd2*Lb1^2*MY4*L3*sin(-hd2-hd4+hd1)-2* ...
        jac_hd2*Lb1^2*MZ4*L4*cos(-hd2-hd4+hd1+hd3)-2*jac_hd2*Lb1^2*MZ3* ...
        L3*cos(-hd2+hd1)+2*jac_hd2*Lb1^2*MY3*L4*sin(-hd2+hd1+hd3)-2* ...
        jac_hd2*Lb1^2*MZ3*L4*cos(-hd2+hd1+hd3)+2*jac_hd2*Lb1^2*MY3*L3* ...
        sin(-hd2+hd1)-2*jac_hd2*Lb1^2*M4*L3^2*cos(-hd2+hd1)-2*jac_hd2* ...
        Lb1^2*M4*L3*L4*cos(-hd2+hd1+hd3)+2*jac_hd2*Lb1^2*M4*L3^2-4*MY3* ...
        L4*Lb1^2*sin(hd3)-2*jac_hd1*M4*L3^2*Lb1^2+4*jac_hd1*XXw*L3*L4+4* ...
        jac_hd1*XXb*L3*L4+4*jac_hd1*XXc*L3*L4+2*jac_hd1*MZ3*L3*Lb1^2* ...
        cos(-hd2+hd1)-4*jac_hd1*MY4*L3*Lb1^2*sin(hd4)-2*jac_hd1*MY4*L3* ...
        Lb1^2*sin(-hd2-hd4+hd1)-2*jac_hd1*MY1*L3*Lb1^2*sin(hd1)+2* ...
        jac_hd1*M4*L3*L4*Lb1^2*cos(-hd2+hd1+hd3)-4*XX4*Lb1^2-4*XX3*Lb1^2- ...
        2*M1*L3^2*Lb1^2-4*M4*L3^2*Lb1^2-4*M4*L4^2*Lb1^2-4*XXc*L4^2-4*XXw* ...
        L4^2-4*XXb*L4^2-2*jac_hd1*MY3*L3*Lb1^2*sin(-hd2+hd1)-4*jac_hd1* ...
        MZ4*L3*Lb1^2*cos(hd4)+2*jac_hd1*MZ4*L4*Lb1^2*cos(-hd2-hd4+hd1+ ...
        hd3)+2*jac_hd1*MZ3*L4*Lb1^2*cos(-hd2+hd1+hd3)-2*jac_hd1*MY1*L4* ...
        Lb1^2*sin(hd1+hd3)+2*jac_hd1*MZ1*L3*Lb1^2*cos(hd1)+2*jac_hd1*MZ1* ...
        L4*Lb1^2*cos(hd1+hd3)+2*jac_hd1*M4*L3^2*Lb1^2*cos(-hd2+hd1)+2* ...
        jac_hd1*MZ4*L3*Lb1^2*cos(-hd2-hd4+hd1)-2*jac_hd1*MY3*L4*Lb1^2* ...
        sin(-hd2+hd1+hd3)-2*jac_hd1*MY4*L4*Lb1^2*sin(-hd2-hd4+hd1+hd3))* ...
        Lb1^2*z2;
dq(5) = -(jac_hd3+2*jac_hd1+2)*Lb1^2/(-4*M3*L3^2*Lb1^2-4*M3*L4^2*Lb1^2+2* ...
        jac_hd3*XXc*L4^2-2*jac_hd1*XX1*Lb1^2-2*jac_hd1*XX4*Lb1^2-8*M3*L3* ...
        L4*Lb1^2*cos(hd3)+2*jac_hd2*Lb1^2*XX3+4*MZ1*L3*Lb1^2*cos(hd1)-2* ...
        jac_hd1*XX3*Lb1^2+4*MZ3*L4*Lb1^2*cos(hd3)+4*MZ1*L4*Lb1^2*cos(hd1+ ...
        hd3)-jac_hd3*XX1*Lb1^2+4*M4*L3^2*Lb1^2*cos(-hd2+hd1)+4*MZ3*L3* ...
        Lb1^2+2*jac_hd4*Lb1^2*XX4+4*MZ4*L3*Lb1^2*cos(-hd2-hd4+hd1)-4*MY3* ...
        L4*Lb1^2*sin(-hd2+hd1+hd3)-4*MY4*L4*Lb1^2*sin(-hd2-hd4+hd1+hd3)+ ...
        4*MZ4*L4*Lb1^2-2*M1*L4^2*Lb1^2+4*MZ3*L3*Lb1^2*cos(-hd2+hd1)-4* ...
        MY4*L3*Lb1^2*sin(hd4)-4*MY4*L3*Lb1^2*sin(-hd2-hd4+hd1)-4*M1*L3* ...
        L4*Lb1^2*cos(hd3)-4*MY1*L3*Lb1^2*sin(hd1)-4*MY3*L3*Lb1^2*sin(- ...
        hd2+hd1)-4*M4*L3*L4*Lb1^2*cos(hd3)+4*M4*L3*L4*Lb1^2*cos(-hd2+hd1+ ...
        hd3)-4*MZ4*L3*Lb1^2*cos(hd4)+4*MZ4*L4*Lb1^2*cos(-hd2-hd4+hd1+ ...
        hd3)+2*jac_hd4*Lb1^2*MY4*L3*sin(hd4)-2*jac_hd4*Lb1^2*MZ4*L4*cos(- ...
        hd2-hd4+hd1+hd3)-2*jac_hd4*Lb1^2*MZ4*L3*cos(-hd2-hd4+hd1)+2* ...
        jac_hd4*Lb1^2*MY4*L4*sin(-hd2-hd4+hd1+hd3)+2*jac_hd4*Lb1^2*MZ4* ...
        L3*cos(hd4)+2*jac_hd4*Lb1^2*MY4*L3*sin(-hd2-hd4+hd1)+4*MZ3*L4* ...
        Lb1^2*cos(-hd2+hd1+hd3)-2*jac_hd3*MZ4*L3*Lb1^2*cos(hd4)+2* ...
        jac_hd3*MZ1*L3*Lb1^2*cos(hd1)+2*jac_hd3*M4*L3^2*Lb1^2*cos(-hd2+ ...
        hd1)+2*jac_hd3*MZ4*L3*Lb1^2*cos(-hd2-hd4+hd1)+2*jac_hd3*MZ3*L3* ...
        Lb1^2*cos(-hd2+hd1)-2*jac_hd3*MY4*L3*Lb1^2*sin(hd4)-2*jac_hd3* ...
        MY4*L3*Lb1^2*sin(-hd2-hd4+hd1)-2*jac_hd3*MY1*L3*Lb1^2*sin(hd1)-2* ...
        jac_hd3*MY3*L3*Lb1^2*sin(-hd2+hd1)+2*jac_hd2*Lb1^2*XX4-2*jac_hd3* ...
        M3*L3^2*Lb1^2+2*jac_hd3*M3*L4^2*Lb1^2+2*jac_hd3*MZ3*L3*Lb1^2-2* ...
        jac_hd3*MZ4*L4*Lb1^2+jac_hd3*M1*L4^2*Lb1^2-jac_hd3*M1*L3^2*Lb1^2- ...
        2*jac_hd3*M4*L3^2*Lb1^2+2*jac_hd3*M4*L4^2*Lb1^2+4*jac_hd3*XXw*L3* ...
        L4+4*jac_hd3*XXb*L3*L4+4*jac_hd3*XXc*L3*L4-2*XX1*Lb1^2-2*jac_hd3* ...
        XX3*Lb1^2+2*jac_hd3*XXw*L4^2+2*jac_hd3*XXb*L4^2-4*MY1*L4*Lb1^2* ...
        sin(hd1+hd3)-2*jac_hd2*Lb1^2*MZ4*L3*cos(-hd2-hd4+hd1)+2*jac_hd2* ...
        Lb1^2*MY4*L4*sin(-hd2-hd4+hd1+hd3)+4*jac_hd2*Lb1^2*MY4*L3* ...
        sin(hd4)+4*jac_hd2*Lb1^2*MZ4*L3*cos(hd4)+2*jac_hd2*Lb1^2*MY4*L3* ...
        sin(-hd2-hd4+hd1)-2*jac_hd2*Lb1^2*MZ4*L4*cos(-hd2-hd4+hd1+hd3)-2* ...
        jac_hd2*Lb1^2*MZ3*L3*cos(-hd2+hd1)+2*jac_hd2*Lb1^2*MY3*L4*sin(- ...
        hd2+hd1+hd3)-2*jac_hd2*Lb1^2*MZ3*L4*cos(-hd2+hd1+hd3)+2*jac_hd2* ...
        Lb1^2*MY3*L3*sin(-hd2+hd1)-2*jac_hd2*Lb1^2*M4*L3^2*cos(-hd2+hd1)- ...
        2*jac_hd2*Lb1^2*M4*L3*L4*cos(-hd2+hd1+hd3)+2*jac_hd2*Lb1^2*M4* ...
        L3^2-4*MY3*L4*Lb1^2*sin(hd3)-2*jac_hd1*M4*L3^2*Lb1^2+4*jac_hd1* ...
        XXw*L3*L4+4*jac_hd1*XXb*L3*L4+4*jac_hd1*XXc*L3*L4+2*jac_hd1*MZ3* ...
        L3*Lb1^2*cos(-hd2+hd1)-4*jac_hd1*MY4*L3*Lb1^2*sin(hd4)-2*jac_hd1* ...
        MY4*L3*Lb1^2*sin(-hd2-hd4+hd1)-2*jac_hd1*MY1*L3*Lb1^2*sin(hd1)+2* ...
        jac_hd1*M4*L3*L4*Lb1^2*cos(-hd2+hd1+hd3)-4*XX4*Lb1^2-4*XX3*Lb1^2- ...
        2*M1*L3^2*Lb1^2-4*M4*L3^2*Lb1^2-4*M4*L4^2*Lb1^2-4*XXc*L4^2-4*XXw* ...
        L4^2-4*XXb*L4^2-2*jac_hd1*MY3*L3*Lb1^2*sin(-hd2+hd1)-4*jac_hd1* ...
        MZ4*L3*Lb1^2*cos(hd4)+2*jac_hd1*MZ4*L4*Lb1^2*cos(-hd2-hd4+hd1+ ...
        hd3)+2*jac_hd1*MZ3*L4*Lb1^2*cos(-hd2+hd1+hd3)-2*jac_hd1*MY1*L4* ...
        Lb1^2*sin(hd1+hd3)+2*jac_hd1*MZ1*L3*Lb1^2*cos(hd1)+2*jac_hd1*MZ1* ...
        L4*Lb1^2*cos(hd1+hd3)+2*jac_hd1*M4*L3^2*Lb1^2*cos(-hd2+hd1)+2* ...
        jac_hd1*MZ4*L3*Lb1^2*cos(-hd2-hd4+hd1)-2*jac_hd1*MY3*L4*Lb1^2* ...
        sin(-hd2+hd1+hd3)-2*jac_hd1*MY4*L4*Lb1^2*sin(-hd2-hd4+hd1+hd3))* ...
        z2;

x0 = [q(1:5)'; dq(1:5)'];