function [f_tan,f_norm] = stance_force(x,ddq)
% STANCE_FORCE
%   [F_TAN,F_NORM] = STANCE_FORCE(X,DDQ)  

%Eric Westervelt
%04-Mar-2003 10:38:59

modelP;

% tangential force
f_tan = (2*M3*L4*cos(x(1)+x(3)+x(5))+2*M3*L3*cos(x(1)+x(5))+2*M4*L4* ...
        cos(x(1)+x(3)+x(5))+M1*L3*cos(x(1)+x(5))+M4*L3*cos(x(1)+x(5))+M1* ...
        L4*cos(x(1)+x(3)+x(5))-MZ4*cos(x(1)+x(3)+x(5))-MY4*sin(x(1)+x(3)+ ...
        x(5))-MY3*sin(x(1)+x(5))-MZ3*cos(x(1)+x(5)))*ddq(1)+(-M4*L3* ...
        cos(x(2)+x(5))-MZ3*cos(x(2)+x(5))-MY3*sin(x(2)+x(5))-MZ4* ...
        cos(x(2)+x(4)+x(5))-MY4*sin(x(2)+x(4)+x(5)))*ddq(2)+(-MY4* ...
        sin(x(1)+x(3)+x(5))-MZ4*cos(x(1)+x(3)+x(5))+M1*L4*cos(x(1)+x(3)+ ...
        x(5))+2*M3*L4*cos(x(1)+x(3)+x(5))+2*M4*L4*cos(x(1)+x(3)+x(5)))* ...
        ddq(3)+(-MZ4*cos(x(2)+x(4)+x(5))-MY4*sin(x(2)+x(4)+x(5)))*ddq(4)+ ...
        (-MY1*sin(x(5))-MY3*sin(x(1)+x(5))-MY3*sin(x(2)+x(5))-MY4* ...
        sin(x(2)+x(4)+x(5))-MZ4*cos(x(1)+x(3)+x(5))-MY4*sin(x(1)+x(3)+ ...
        x(5))-MZ3*cos(x(1)+x(5))-MZ4*cos(x(2)+x(4)+x(5))-MZ3*cos(x(2)+ ...
        x(5))-MZ1*cos(x(5))+M1*L4*cos(x(1)+x(3)+x(5))+M4*L3*cos(x(1)+ ...
        x(5))-M4*L3*cos(x(2)+x(5))+2*M3*L4*cos(x(1)+x(3)+x(5))+2*M4*L4* ...
        cos(x(1)+x(3)+x(5))+2*M3*L3*cos(x(1)+x(5))+M1*L3*cos(x(1)+x(5)))* ...
        ddq(5)+(-2*x(6)*M4*L4*sin(x(1)+x(3)+x(5))-2*x(8)*M4*L4*sin(x(1)+ ...
        x(3)+x(5))-2*x(6)*M3*L3*sin(x(1)+x(5))-2*x(6)*M3*L4*sin(x(1)+ ...
        x(3)+x(5))-2*x(8)*M3*L4*sin(x(1)+x(3)+x(5))-2*x(10)*M4*L4* ...
        sin(x(1)+x(3)+x(5))-2*x(10)*M3*L4*sin(x(1)+x(3)+x(5))-2*x(10)*M3* ...
        L3*sin(x(1)+x(5))-x(10)*M1*L4*sin(x(1)+x(3)+x(5))-x(10)*M1*L3* ...
        sin(x(1)+x(5))-x(6)*M4*L3*sin(x(1)+x(5))-x(10)*M4*L3*sin(x(1)+ ...
        x(5))-x(6)*M1*L4*sin(x(1)+x(3)+x(5))-x(6)*M1*L3*sin(x(1)+x(5))+ ...
        x(6)*MZ3*sin(x(1)+x(5))-x(6)*MY4*cos(x(1)+x(3)+x(5))-x(8)*MY4* ...
        cos(x(1)+x(3)+x(5))-x(8)*M1*L4*sin(x(1)+x(3)+x(5))+x(10)*MZ4* ...
        sin(x(1)+x(3)+x(5))+x(10)*MZ3*sin(x(1)+x(5))+x(6)*MZ4*sin(x(1)+ ...
        x(3)+x(5))-x(6)*MY3*cos(x(1)+x(5))-x(10)*MY3*cos(x(1)+x(5))+x(8)* ...
        MZ4*sin(x(1)+x(3)+x(5))-x(10)*MY4*cos(x(1)+x(3)+x(5)))*x(6)+ ...
        (x(7)*M4*L3*sin(x(2)+x(5))+x(7)*MZ4*sin(x(2)+x(4)+x(5))-x(7)*MY4* ...
        cos(x(2)+x(4)+x(5))+x(7)*MZ3*sin(x(2)+x(5))-x(7)*MY3*cos(x(2)+ ...
        x(5))+x(9)*MZ4*sin(x(2)+x(4)+x(5))-x(9)*MY4*cos(x(2)+x(4)+x(5))+ ...
        x(10)*M4*L3*sin(x(2)+x(5))+x(10)*MZ4*sin(x(2)+x(4)+x(5))-x(10)* ...
        MY4*cos(x(2)+x(4)+x(5))+x(10)*MZ3*sin(x(2)+x(5))-x(10)*MY3* ...
        cos(x(2)+x(5)))*x(7)-(x(6)+x(8)+x(10))*(MY4*cos(x(1)+x(3)+x(5))- ...
        MZ4*sin(x(1)+x(3)+x(5))+M1*L4*sin(x(1)+x(3)+x(5))+2*M3*L4* ...
        sin(x(1)+x(3)+x(5))+2*M4*L4*sin(x(1)+x(3)+x(5)))*x(8)+(x(7)+x(9)+ ...
        x(10))*(MZ4*sin(x(2)+x(4)+x(5))-MY4*cos(x(2)+x(4)+x(5)))*x(9)+(- ...
        2*x(6)*M4*L4*sin(x(1)+x(3)+x(5))-2*x(8)*M4*L4*sin(x(1)+x(3)+ ...
        x(5))+x(7)*M4*L3*sin(x(2)+x(5))-2*x(6)*M3*L3*sin(x(1)+x(5))-2* ...
        x(6)*M3*L4*sin(x(1)+x(3)+x(5))-2*x(8)*M3*L4*sin(x(1)+x(3)+x(5))- ...
        2*x(10)*M4*L4*sin(x(1)+x(3)+x(5))-2*x(10)*M3*L4*sin(x(1)+x(3)+ ...
        x(5))-2*x(10)*M3*L3*sin(x(1)+x(5))-x(10)*M1*L4*sin(x(1)+x(3)+ ...
        x(5))-x(10)*M1*L3*sin(x(1)+x(5))-x(6)*M4*L3*sin(x(1)+x(5))-x(10)* ...
        M4*L3*sin(x(1)+x(5))-x(6)*M1*L4*sin(x(1)+x(3)+x(5))-x(6)*M1*L3* ...
        sin(x(1)+x(5))+x(6)*MZ3*sin(x(1)+x(5))-x(6)*MY4*cos(x(1)+x(3)+ ...
        x(5))-x(8)*MY4*cos(x(1)+x(3)+x(5))+x(10)*MZ4*sin(x(2)+x(4)+x(5))- ...
        x(10)*MY4*cos(x(2)+x(4)+x(5))+x(10)*MZ3*sin(x(2)+x(5))-x(10)*MY3* ...
        cos(x(2)+x(5))+x(9)*MZ4*sin(x(2)+x(4)+x(5))-x(9)*MY4*cos(x(2)+ ...
        x(4)+x(5))+x(10)*M4*L3*sin(x(2)+x(5))-x(7)*MY3*cos(x(2)+x(5))+ ...
        x(7)*MZ4*sin(x(2)+x(4)+x(5))-x(7)*MY4*cos(x(2)+x(4)+x(5))+x(7)* ...
        MZ3*sin(x(2)+x(5))-x(8)*M1*L4*sin(x(1)+x(3)+x(5))+x(10)*MZ4* ...
        sin(x(1)+x(3)+x(5))+x(10)*MZ3*sin(x(1)+x(5))+x(6)*MZ4*sin(x(1)+ ...
        x(3)+x(5))-x(6)*MY3*cos(x(1)+x(5))-x(10)*MY3*cos(x(1)+x(5))+x(8)* ...
        MZ4*sin(x(1)+x(3)+x(5))-x(10)*MY4*cos(x(1)+x(3)+x(5))-x(10)*MY1* ...
        cos(x(5))+x(10)*MZ1*sin(x(5)))*x(10);

% normal force
f_norm = (MY4*cos(x(1)+x(3)+x(5))+MY3*cos(x(1)+x(5))-MZ3*sin(x(1)+x(5))- ...
         MZ4*sin(x(1)+x(3)+x(5))+M4*L3*sin(x(1)+x(5))+2*M3*L4*sin(x(1)+ ...
         x(3)+x(5))+2*M4*L4*sin(x(1)+x(3)+x(5))+M1*L4*sin(x(1)+x(3)+x(5))+ ...
         M1*L3*sin(x(1)+x(5))+2*M3*L3*sin(x(1)+x(5)))*ddq(1)+(-M4*L3* ...
         sin(x(2)+x(5))-MZ3*sin(x(2)+x(5))+MY3*cos(x(2)+x(5))-MZ4* ...
         sin(x(2)+x(4)+x(5))+MY4*cos(x(2)+x(4)+x(5)))*ddq(2)+(MY4* ...
         cos(x(1)+x(3)+x(5))-MZ4*sin(x(1)+x(3)+x(5))+M1*L4*sin(x(1)+x(3)+ ...
         x(5))+2*M3*L4*sin(x(1)+x(3)+x(5))+2*M4*L4*sin(x(1)+x(3)+x(5)))* ...
         ddq(3)+(-MZ4*sin(x(2)+x(4)+x(5))+MY4*cos(x(2)+x(4)+x(5)))*ddq(4)+ ...
         (MY1*cos(x(5))+MY3*cos(x(1)+x(5))+MY3*cos(x(2)+x(5))+MY4* ...
         cos(x(2)+x(4)+x(5))-MZ4*sin(x(1)+x(3)+x(5))+MY4*cos(x(1)+x(3)+ ...
         x(5))-MZ3*sin(x(1)+x(5))-MZ4*sin(x(2)+x(4)+x(5))-MZ3*sin(x(2)+ ...
         x(5))-MZ1*sin(x(5))+M1*L4*sin(x(1)+x(3)+x(5))+M4*L3*sin(x(1)+ ...
         x(5))-M4*L3*sin(x(2)+x(5))+2*M3*L4*sin(x(1)+x(3)+x(5))+2*M4*L4* ...
         sin(x(1)+x(3)+x(5))+2*M3*L3*sin(x(1)+x(5))+M1*L3*sin(x(1)+x(5)))* ...
         ddq(5)+(x(6)*M1*L4*cos(x(1)+x(3)+x(5))+x(10)*M1*L3*cos(x(1)+ ...
         x(5))+x(10)*M4*L3*cos(x(1)+x(5))+x(10)*M1*L4*cos(x(1)+x(3)+x(5))+ ...
         x(8)*M1*L4*cos(x(1)+x(3)+x(5))+x(6)*M4*L3*cos(x(1)+x(5))+x(6)*M1* ...
         L3*cos(x(1)+x(5))+2*x(8)*M3*L4*cos(x(1)+x(3)+x(5))+2*x(6)*M4*L4* ...
         cos(x(1)+x(3)+x(5))+2*x(6)*M3*L3*cos(x(1)+x(5))+2*x(10)*M3*L4* ...
         cos(x(1)+x(3)+x(5))+2*x(10)*M4*L4*cos(x(1)+x(3)+x(5))+2*x(8)*M4* ...
         L4*cos(x(1)+x(3)+x(5))+2*x(10)*M3*L3*cos(x(1)+x(5))+2*x(6)*M3*L4* ...
         cos(x(1)+x(3)+x(5))-x(10)*MY4*sin(x(1)+x(3)+x(5))-x(6)*MZ3* ...
         cos(x(1)+x(5))-x(8)*MY4*sin(x(1)+x(3)+x(5))-x(6)*MZ4*cos(x(1)+ ...
         x(3)+x(5))-x(6)*MY4*sin(x(1)+x(3)+x(5))-x(10)*MZ4*cos(x(1)+x(3)+ ...
         x(5))-x(10)*MZ3*cos(x(1)+x(5))-x(6)*MY3*sin(x(1)+x(5))-x(10)*MY3* ...
         sin(x(1)+x(5))-x(8)*MZ4*cos(x(1)+x(3)+x(5)))*x(6)+(-x(7)*M4*L3* ...
         cos(x(2)+x(5))-x(7)*MZ3*cos(x(2)+x(5))-x(7)*MY3*sin(x(2)+x(5))- ...
         x(7)*MZ4*cos(x(2)+x(4)+x(5))-x(7)*MY4*sin(x(2)+x(4)+x(5))-x(9)* ...
         MZ4*cos(x(2)+x(4)+x(5))-x(9)*MY4*sin(x(2)+x(4)+x(5))-x(10)*M4*L3* ...
         cos(x(2)+x(5))-x(10)*MZ3*cos(x(2)+x(5))-x(10)*MY3*sin(x(2)+x(5))- ...
         x(10)*MZ4*cos(x(2)+x(4)+x(5))-x(10)*MY4*sin(x(2)+x(4)+x(5)))* ...
         x(7)-(x(6)+x(8)+x(10))*(-M1*L4*cos(x(1)+x(3)+x(5))-2*M3*L4* ...
         cos(x(1)+x(3)+x(5))+MY4*sin(x(1)+x(3)+x(5))+MZ4*cos(x(1)+x(3)+ ...
         x(5))-2*M4*L4*cos(x(1)+x(3)+x(5)))*x(8)-(x(7)+x(9)+x(10))*(MZ4* ...
         cos(x(2)+x(4)+x(5))+MY4*sin(x(2)+x(4)+x(5)))*x(9)+(-x(7)*M4*L3* ...
         cos(x(2)+x(5))+x(6)*M1*L4*cos(x(1)+x(3)+x(5))+x(10)*M1*L3* ...
         cos(x(1)+x(5))+x(10)*M4*L3*cos(x(1)+x(5))+x(10)*M1*L4*cos(x(1)+ ...
         x(3)+x(5))+x(8)*M1*L4*cos(x(1)+x(3)+x(5))+x(6)*M4*L3*cos(x(1)+ ...
         x(5))+x(6)*M1*L3*cos(x(1)+x(5))+2*x(8)*M3*L4*cos(x(1)+x(3)+x(5))+ ...
         2*x(6)*M4*L4*cos(x(1)+x(3)+x(5))+2*x(6)*M3*L3*cos(x(1)+x(5))+2* ...
         x(10)*M3*L4*cos(x(1)+x(3)+x(5))+2*x(10)*M4*L4*cos(x(1)+x(3)+ ...
         x(5))+2*x(8)*M4*L4*cos(x(1)+x(3)+x(5))+2*x(10)*M3*L3*cos(x(1)+ ...
         x(5))+2*x(6)*M3*L4*cos(x(1)+x(3)+x(5))-x(10)*MY4*sin(x(1)+x(3)+ ...
         x(5))-x(6)*MZ3*cos(x(1)+x(5))-x(8)*MY4*sin(x(1)+x(3)+x(5))-x(6)* ...
         MZ4*cos(x(1)+x(3)+x(5))-x(6)*MY4*sin(x(1)+x(3)+x(5))-x(10)*MZ4* ...
         cos(x(1)+x(3)+x(5))-x(10)*MZ3*cos(x(1)+x(5))-x(6)*MY3*sin(x(1)+ ...
         x(5))-x(9)*MY4*sin(x(2)+x(4)+x(5))-x(10)*MZ3*cos(x(2)+x(5))- ...
         x(10)*MY3*sin(x(2)+x(5))-x(10)*MZ4*cos(x(2)+x(4)+x(5))-x(10)*MY4* ...
         sin(x(2)+x(4)+x(5))-x(9)*MZ4*cos(x(2)+x(4)+x(5))-x(10)*M4*L3* ...
         cos(x(2)+x(5))-x(10)*MY3*sin(x(1)+x(5))-x(8)*MZ4*cos(x(1)+x(3)+ ...
         x(5))-x(7)*MZ3*cos(x(2)+x(5))-x(7)*MY3*sin(x(2)+x(5))-x(7)*MZ4* ...
         cos(x(2)+x(4)+x(5))-x(7)*MY4*sin(x(2)+x(4)+x(5))-x(10)*MZ1* ...
         cos(x(5))-x(10)*MY1*sin(x(5)))*x(10)+g*(2*M3*Lb1+2*M4*Lb1+PEbc+ ...
         PEcc+M1*Lb1+PEwc)/Lb1;