function [z] = zd_project(x)
% ZD_PROJECT
%   [Z] = ZD_PROJECT(X)  Project to the zero dynamics manifold.

%Eric Westervelt
%04-Mar-2003 10:37:36

modelP;

[nn,mm] = size(x);
if (nn > 1 & mm == 10)
  q31L=x(:,1); q32L=x(:,2); q41L=x(:,3); q42L=x(:,4); q1L=x(:,5);
  dq31L=x(:,6); dq32L=x(:,7); dq41L=x(:,8); dq42L=x(:,9); dq1L=x(:,10);
else
  q31L=x(1); q32L=x(2); q41L=x(3); q42L=x(4); q1L=x(5);
  dq31L=x(6); dq32L=x(7); dq41L=x(8); dq42L=x(9); dq1L=x(10);
end

% theta (in absolute coordinates)
z1 = -1./2.*q41L-q31L-q1L;

% gamma (in absolute coordinates)
z2 = (2.*M3.*L4.^2.*Lb1.^2+2.*XXb.*L4.^2-2.*MZ3.*L4.*Lb1.^2.* ...
       cos(q41L)+2.*MY3.*L4.*Lb1.^2.*sin(q41L)-MZ3.*L4.*Lb1.^2.* ...
       cos(q32L-q31L-q41L)-MZ3.*L3.*Lb1.^2.*cos(q32L-q31L)-MY4.*L4.* ...
       Lb1.^2.*sin(q32L+q42L-q31L-q41L)-MY4.*L3.*Lb1.^2.*sin(q32L+q42L- ...
       q31L)-M4.*L4.*L3.*Lb1.^2.*cos(q32L-q31L-q41L)-MZ4.*L3.*Lb1.^2.* ...
       cos(q32L+q42L-q31L)+MY1.*L3.*Lb1.^2.*sin(q31L)-MZ4.*L4.*Lb1.^2.* ...
       cos(q32L+q42L-q31L-q41L)-MZ1.*L3.*Lb1.^2.*cos(q31L)-MZ1.*L4.* ...
       Lb1.^2.*cos(q31L+q41L)-MY3.*L4.*Lb1.^2.*sin(q32L-q31L-q41L)-M4.* ...
       L3.^2.*Lb1.^2.*cos(q32L-q31L)+MY1.*L4.*Lb1.^2.*sin(q31L+q41L)- ...
       MY3.*L3.*Lb1.^2.*sin(q32L-q31L)+2.*M4.*L3.*L4.*Lb1.^2.*cos(q41L)+ ...
       4.*M3.*L3.*L4.*Lb1.^2.*cos(q41L)+2.*M1.*L3.*L4.*Lb1.^2.* ...
       cos(q41L)+2.*M4.*L4.^2.*Lb1.^2-2.*MZ4.*L4.*Lb1.^2+2.*M3.*L3.^2.* ...
       Lb1.^2+2.*XXc.*L4.^2-2.*MZ3.*L3.*Lb1.^2+XX4.*Lb1.^2+XX3.*Lb1.^2+ ...
       M1.*L3.^2.*Lb1.^2+M4.*L3.^2.*Lb1.^2+M1.*L4.^2.*Lb1.^2+2.*XXw.* ...
       L4.^2+2.*XXb.*L3.*L4+2.*XXw.*L3.*L4+2.*XXc.*L3.*L4)./Lb1.^2.* ...
       dq31L+(-MZ4.*L3.*cos(q32L+q42L-q31L)-MY4.*L4.*sin(q32L+q42L-q31L- ...
       q41L)+2.*MY4.*L3.*sin(q42L)+2.*MZ4.*L3.*cos(q42L)-MY4.*L3.* ...
       sin(q32L+q42L-q31L)-MZ4.*L4.*cos(q32L+q42L-q31L-q41L)-MZ3.*L3.* ...
       cos(q32L-q31L)-MY3.*L4.*sin(q32L-q31L-q41L)-MZ3.*L4.*cos(q32L- ...
       q31L-q41L)-MY3.*L3.*sin(q32L-q31L)-M4.*L3.^2.*cos(q32L-q31L)+XX3+ ...
       M4.*L3.^2+XX4-M4.*L4.*L3.*cos(q32L-q31L-q41L)).*dq32L+(-2.*MZ4.* ...
       L4.*Lb1.^2+2.*XXw.*L3.*L4+2.*M4.*L4.^2.*Lb1.^2+2.*M3.*L4.^2.* ...
       Lb1.^2+2.*XXb.*L3.*L4-MZ3.*L4.*Lb1.^2.*cos(q41L)-MY3.*L4.* ...
       Lb1.^2.*sin(q32L-q31L-q41L)+M4.*L3.*L4.*Lb1.^2.*cos(q41L)-MZ1.* ...
       L4.*Lb1.^2.*cos(q31L+q41L)-MZ3.*L4.*Lb1.^2.*cos(q32L-q31L-q41L)- ...
       MY4.*L4.*Lb1.^2.*sin(q32L+q42L-q31L-q41L)-MZ4.*L4.*Lb1.^2.* ...
       cos(q32L+q42L-q31L-q41L)-M4.*L4.*L3.*Lb1.^2.*cos(q32L-q31L-q41L)+ ...
       M1.*L4.^2.*Lb1.^2+MY1.*L4.*Lb1.^2.*sin(q31L+q41L)+2.*M3.*L3.*L4.* ...
       Lb1.^2.*cos(q41L)+2.*XXc.*L3.*L4+2.*XXc.*L4.^2+XX4.*Lb1.^2+2.* ...
       XXw.*L4.^2+2.*XXb.*L4.^2+M1.*L3.*L4.*Lb1.^2.*cos(q41L)+MY3.*L4.* ...
       Lb1.^2.*sin(q41L))./Lb1.^2.*dq41L+(MY4.*L3.*sin(q42L)-MZ4.*L4.* ...
       cos(q32L+q42L-q31L-q41L)-MZ4.*L3.*cos(q32L+q42L-q31L)-MY4.*L4.* ...
       sin(q32L+q42L-q31L-q41L)+MZ4.*L3.*cos(q42L)-MY4.*L3.*sin(q32L+ ...
       q42L-q31L)+XX4).*dq42L+(2.*M3.*L4.^2.*Lb1.^2+2.*XXb.*L4.^2-2.* ...
       MZ3.*L4.*Lb1.^2.*cos(q41L)+2.*MY3.*L4.*Lb1.^2.*sin(q41L)-2.*MZ3.* ...
       L4.*Lb1.^2.*cos(q32L-q31L-q41L)-2.*MZ3.*L3.*Lb1.^2.*cos(q32L- ...
       q31L)-2.*MY4.*L4.*Lb1.^2.*sin(q32L+q42L-q31L-q41L)-2.*MY4.*L3.* ...
       Lb1.^2.*sin(q32L+q42L-q31L)-2.*M4.*L4.*L3.*Lb1.^2.*cos(q32L-q31L- ...
       q41L)-2.*MZ4.*L3.*Lb1.^2.*cos(q32L+q42L-q31L)+2.*MY1.*L3.* ...
       Lb1.^2.*sin(q31L)-2.*MZ4.*L4.*Lb1.^2.*cos(q32L+q42L-q31L-q41L)- ...
       2.*MZ1.*L3.*Lb1.^2.*cos(q31L)-2.*MZ1.*L4.*Lb1.^2.*cos(q31L+q41L)- ...
       2.*MY3.*L4.*Lb1.^2.*sin(q32L-q31L-q41L)-2.*M4.*L3.^2.*Lb1.^2.* ...
       cos(q32L-q31L)+2.*MY1.*L4.*Lb1.^2.*sin(q31L+q41L)-2.*MY3.*L3.* ...
       Lb1.^2.*sin(q32L-q31L)+2.*M4.*L3.*L4.*Lb1.^2.*cos(q41L)+4.*M3.* ...
       L3.*L4.*Lb1.^2.*cos(q41L)+2.*M1.*L3.*L4.*Lb1.^2.*cos(q41L)+2.* ...
       MY4.*L3.*Lb1.^2.*sin(q42L)+2.*MZ4.*L3.*Lb1.^2.*cos(q42L)+2.*M4.* ...
       L4.^2.*Lb1.^2-2.*MZ4.*L4.*Lb1.^2+2.*M3.*L3.^2.*Lb1.^2+2.*XXc.* ...
       L4.^2-2.*MZ3.*L3.*Lb1.^2+2.*XX4.*Lb1.^2+2.*XX3.*Lb1.^2+M1.* ...
       L3.^2.*Lb1.^2+2.*M4.*L3.^2.*Lb1.^2+M1.*L4.^2.*Lb1.^2+2.*XXw.* ...
       L4.^2+XX1.*Lb1.^2)./Lb1.^2.*dq1L;

z = [z1 z2];
