function [x] = zd_s_lift(z)
% ZD_S_LIFT
%   [X] = ZD_S_LIFT(Z)  Lifts the zero dynamics to the full state of 
%    the system.

%Eric Westervelt
%04-Mar-2003 15:42:15

modelP;

[a,b,m] = controlParameters;

a0=a(1); a1=a(2); a2=a(3); a3=a(4); a4=a(5); a5=a(6); a6=a(7); 
b0=a(8); b1=a(9); b2=a(10); b3=a(11); b4=a(12); b5=a(13); b6=a(14); 
c0=a(15); c1=a(16); c2=a(17); c3=a(18); c4=a(19); c5=a(20); c6=a(21); 
d0=a(22); d1=a(23); d2=a(24); d3=a(25); d4=a(26); d5=a(27); d6=a(28); 

[nn,mm] = size(z);
if (nn > 1 & mm == 2)
  z1 = z(:,1); z2 = z(:,2);
else
  z1 = z(1); z2 = z(2);
end

hd1 = a0.*(1-(z1-b)./m).^6+6.*a1.*(z1-b)./m.*(1-(z1-b)./m).^5+15.*a2.* ...
      (z1-b).^2./m.^2.*(1-(z1-b)./m).^4+20.*a3.*(z1-b).^3./m.^3.*(1- ...
      (z1-b)./m).^3+15.*a4.*(z1-b).^4./m.^4.*(1-(z1-b)./m).^2+6.*a5.* ...
      (z1-b).^5./m.^5.*(1-(z1-b)./m)+a6.*(z1-b).^6./m.^6;
hd2 = b0.*(1-(z1-b)./m).^6+6.*b1.*(z1-b)./m.*(1-(z1-b)./m).^5+15.*b2.* ...
      (z1-b).^2./m.^2.*(1-(z1-b)./m).^4+20.*b3.*(z1-b).^3./m.^3.*(1- ...
      (z1-b)./m).^3+15.*b4.*(z1-b).^4./m.^4.*(1-(z1-b)./m).^2+6.*b5.* ...
      (z1-b).^5./m.^5.*(1-(z1-b)./m)+b6.*(z1-b).^6./m.^6;
hd3 = c0.*(1-(z1-b)./m).^6+6.*c1.*(z1-b)./m.*(1-(z1-b)./m).^5+15.*c2.* ...
      (z1-b).^2./m.^2.*(1-(z1-b)./m).^4+20.*c3.*(z1-b).^3./m.^3.*(1- ...
      (z1-b)./m).^3+15.*c4.*(z1-b).^4./m.^4.*(1-(z1-b)./m).^2+6.*c5.* ...
      (z1-b).^5./m.^5.*(1-(z1-b)./m)+c6.*(z1-b).^6./m.^6;
hd4 = d0.*(1-(z1-b)./m).^6+6.*d1.*(z1-b)./m.*(1-(z1-b)./m).^5+15.*d2.* ...
      (z1-b).^2./m.^2.*(1-(z1-b)./m).^4+20.*d3.*(z1-b).^3./m.^3.*(1- ...
      (z1-b)./m).^3+15.*d4.*(z1-b).^4./m.^4.*(1-(z1-b)./m).^2+6.*d5.* ...
      (z1-b).^5./m.^5.*(1-(z1-b)./m)+d6.*(z1-b).^6./m.^6;

jac_hd1 = -6.*a0.*(1-(z1-b)./m).^5./m+6.*a1./m.*(1-(z1-b)./m).^5-30.*a1.* ...
          (z1-b)./m.^2.*(1-(z1-b)./m).^4+30.*a2.*(z1-b)./m.^2.*(1-(z1- ...
          b)./m).^4-60.*a2.*(z1-b).^2./m.^3.*(1-(z1-b)./m).^3+60.*a3.*(z1- ...
          b).^2./m.^3.*(1-(z1-b)./m).^3-60.*a3.*(z1-b).^3./m.^4.*(1-(z1- ...
          b)./m).^2+60.*a4.*(z1-b).^3./m.^4.*(1-(z1-b)./m).^2-30.*a4.*(z1- ...
          b).^4./m.^5.*(1-(z1-b)./m)+30.*a5.*(z1-b).^4./m.^5.*(1-(z1- ...
          b)./m)-6.*a5.*(z1-b).^5./m.^6+6.*a6.*(z1-b).^5./m.^6;
jac_hd2 = -6.*b0.*(1-(z1-b)./m).^5./m+6.*b1./m.*(1-(z1-b)./m).^5-30.*b1.* ...
          (z1-b)./m.^2.*(1-(z1-b)./m).^4+30.*b2.*(z1-b)./m.^2.*(1-(z1- ...
          b)./m).^4-60.*b2.*(z1-b).^2./m.^3.*(1-(z1-b)./m).^3+60.*b3.*(z1- ...
          b).^2./m.^3.*(1-(z1-b)./m).^3-60.*b3.*(z1-b).^3./m.^4.*(1-(z1- ...
          b)./m).^2+60.*b4.*(z1-b).^3./m.^4.*(1-(z1-b)./m).^2-30.*b4.*(z1- ...
          b).^4./m.^5.*(1-(z1-b)./m)+30.*b5.*(z1-b).^4./m.^5.*(1-(z1- ...
          b)./m)-6.*b5.*(z1-b).^5./m.^6+6.*b6.*(z1-b).^5./m.^6;
jac_hd3 = -6.*c0.*(1-(z1-b)./m).^5./m+6.*c1./m.*(1-(z1-b)./m).^5-30.*c1.* ...
          (z1-b)./m.^2.*(1-(z1-b)./m).^4+30.*c2.*(z1-b)./m.^2.*(1-(z1- ...
          b)./m).^4-60.*c2.*(z1-b).^2./m.^3.*(1-(z1-b)./m).^3+60.*c3.*(z1- ...
          b).^2./m.^3.*(1-(z1-b)./m).^3-60.*c3.*(z1-b).^3./m.^4.*(1-(z1- ...
          b)./m).^2+60.*c4.*(z1-b).^3./m.^4.*(1-(z1-b)./m).^2-30.*c4.*(z1- ...
          b).^4./m.^5.*(1-(z1-b)./m)+30.*c5.*(z1-b).^4./m.^5.*(1-(z1- ...
          b)./m)-6.*c5.*(z1-b).^5./m.^6+6.*c6.*(z1-b).^5./m.^6;
jac_hd4 = -6.*d0.*(1-(z1-b)./m).^5./m+6.*d1./m.*(1-(z1-b)./m).^5-30.*d1.* ...
          (z1-b)./m.^2.*(1-(z1-b)./m).^4+30.*d2.*(z1-b)./m.^2.*(1-(z1- ...
          b)./m).^4-60.*d2.*(z1-b).^2./m.^3.*(1-(z1-b)./m).^3+60.*d3.*(z1- ...
          b).^2./m.^3.*(1-(z1-b)./m).^3-60.*d3.*(z1-b).^3./m.^4.*(1-(z1- ...
          b)./m).^2+60.*d4.*(z1-b).^3./m.^4.*(1-(z1-b)./m).^2-30.*d4.*(z1- ...
          b).^4./m.^5.*(1-(z1-b)./m)+30.*d5.*(z1-b).^4./m.^5.*(1-(z1- ...
          b)./m)-6.*d5.*(z1-b).^5./m.^6+6.*d6.*(z1-b).^5./m.^6;

q31L = hd1;

q32L = hd2;

q41L = hd3;

q42L = hd4;

q1L = -hd1-1./2.*hd3-z1;

dq31L = 2.*jac_hd1./(-4.*M3.*L3.^2.*Lb1.^2-4.*M3.*L4.^2.*Lb1.^2+2.* ...
       jac_hd3.*XXc.*L4.^2-2.*jac_hd1.*XX1.*Lb1.^2-2.*jac_hd1.*XX4.* ...
       Lb1.^2-8.*M3.*L3.*L4.*Lb1.^2.*cos(hd3)+2.*jac_hd2.*Lb1.^2.*XX3+ ...
       4.*MZ1.*L3.*Lb1.^2.*cos(hd1)-2.*jac_hd1.*XX3.*Lb1.^2+4.*MZ3.*L4.* ...
       Lb1.^2.*cos(hd3)+4.*MZ1.*L4.*Lb1.^2.*cos(hd1+hd3)-jac_hd3.*XX1.* ...
       Lb1.^2+4.*M4.*L3.^2.*Lb1.^2.*cos(-hd2+hd1)+4.*MZ3.*L3.*Lb1.^2+2.* ...
       jac_hd4.*Lb1.^2.*XX4+4.*MZ4.*L3.*Lb1.^2.*cos(-hd2-hd4+hd1)-4.* ...
       MY3.*L4.*Lb1.^2.*sin(-hd2+hd1+hd3)-4.*MY4.*L4.*Lb1.^2.*sin(-hd2- ...
       hd4+hd1+hd3)+4.*MZ4.*L4.*Lb1.^2-2.*M1.*L4.^2.*Lb1.^2+4.*MZ3.*L3.* ...
       Lb1.^2.*cos(-hd2+hd1)-4.*MY4.*L3.*Lb1.^2.*sin(hd4)-4.*MY4.*L3.* ...
       Lb1.^2.*sin(-hd2-hd4+hd1)-4.*M1.*L3.*L4.*Lb1.^2.*cos(hd3)-4.* ...
       MY1.*L3.*Lb1.^2.*sin(hd1)-4.*MY3.*L3.*Lb1.^2.*sin(-hd2+hd1)-4.* ...
       M4.*L3.*L4.*Lb1.^2.*cos(hd3)+4.*M4.*L3.*L4.*Lb1.^2.*cos(-hd2+hd1+ ...
       hd3)-4.*MZ4.*L3.*Lb1.^2.*cos(hd4)+4.*MZ4.*L4.*Lb1.^2.*cos(-hd2- ...
       hd4+hd1+hd3)+2.*jac_hd4.*Lb1.^2.*MY4.*L3.*sin(hd4)-2.*jac_hd4.* ...
       Lb1.^2.*MZ4.*L4.*cos(-hd2-hd4+hd1+hd3)-2.*jac_hd4.*Lb1.^2.*MZ4.* ...
       L3.*cos(-hd2-hd4+hd1)+2.*jac_hd4.*Lb1.^2.*MY4.*L4.*sin(-hd2-hd4+ ...
       hd1+hd3)+2.*jac_hd4.*Lb1.^2.*MZ4.*L3.*cos(hd4)+2.*jac_hd4.* ...
       Lb1.^2.*MY4.*L3.*sin(-hd2-hd4+hd1)+4.*MZ3.*L4.*Lb1.^2.*cos(-hd2+ ...
       hd1+hd3)-2.*jac_hd3.*MZ4.*L3.*Lb1.^2.*cos(hd4)+2.*jac_hd3.*MZ1.* ...
       L3.*Lb1.^2.*cos(hd1)+2.*jac_hd3.*M4.*L3.^2.*Lb1.^2.*cos(-hd2+ ...
       hd1)+2.*jac_hd3.*MZ4.*L3.*Lb1.^2.*cos(-hd2-hd4+hd1)+2.*jac_hd3.* ...
       MZ3.*L3.*Lb1.^2.*cos(-hd2+hd1)-2.*jac_hd3.*MY4.*L3.*Lb1.^2.* ...
       sin(hd4)-2.*jac_hd3.*MY4.*L3.*Lb1.^2.*sin(-hd2-hd4+hd1)-2.* ...
       jac_hd3.*MY1.*L3.*Lb1.^2.*sin(hd1)-2.*jac_hd3.*MY3.*L3.*Lb1.^2.* ...
       sin(-hd2+hd1)+2.*jac_hd2.*Lb1.^2.*XX4-2.*jac_hd3.*M3.*L3.^2.* ...
       Lb1.^2+2.*jac_hd3.*M3.*L4.^2.*Lb1.^2+2.*jac_hd3.*MZ3.*L3.*Lb1.^2- ...
       2.*jac_hd3.*MZ4.*L4.*Lb1.^2+jac_hd3.*M1.*L4.^2.*Lb1.^2-jac_hd3.* ...
       M1.*L3.^2.*Lb1.^2-2.*jac_hd3.*M4.*L3.^2.*Lb1.^2+2.*jac_hd3.*M4.* ...
       L4.^2.*Lb1.^2+4.*jac_hd3.*XXw.*L3.*L4+4.*jac_hd3.*XXb.*L3.*L4+4.* ...
       jac_hd3.*XXc.*L3.*L4-2.*XX1.*Lb1.^2-2.*jac_hd3.*XX3.*Lb1.^2+2.* ...
       jac_hd3.*XXw.*L4.^2+2.*jac_hd3.*XXb.*L4.^2-4.*MY1.*L4.*Lb1.^2.* ...
       sin(hd1+hd3)-2.*jac_hd2.*Lb1.^2.*MZ4.*L3.*cos(-hd2-hd4+hd1)+2.* ...
       jac_hd2.*Lb1.^2.*MY4.*L4.*sin(-hd2-hd4+hd1+hd3)+4.*jac_hd2.* ...
       Lb1.^2.*MY4.*L3.*sin(hd4)+4.*jac_hd2.*Lb1.^2.*MZ4.*L3.*cos(hd4)+ ...
       2.*jac_hd2.*Lb1.^2.*MY4.*L3.*sin(-hd2-hd4+hd1)-2.*jac_hd2.* ...
       Lb1.^2.*MZ4.*L4.*cos(-hd2-hd4+hd1+hd3)-2.*jac_hd2.*Lb1.^2.*MZ3.* ...
       L3.*cos(-hd2+hd1)+2.*jac_hd2.*Lb1.^2.*MY3.*L4.*sin(-hd2+hd1+hd3)- ...
       2.*jac_hd2.*Lb1.^2.*MZ3.*L4.*cos(-hd2+hd1+hd3)+2.*jac_hd2.* ...
       Lb1.^2.*MY3.*L3.*sin(-hd2+hd1)-2.*jac_hd2.*Lb1.^2.*M4.*L3.^2.* ...
       cos(-hd2+hd1)-2.*jac_hd2.*Lb1.^2.*M4.*L3.*L4.*cos(-hd2+hd1+hd3)+ ...
       2.*jac_hd2.*Lb1.^2.*M4.*L3.^2-4.*MY3.*L4.*Lb1.^2.*sin(hd3)-2.* ...
       jac_hd1.*M4.*L3.^2.*Lb1.^2+4.*jac_hd1.*XXw.*L3.*L4+4.*jac_hd1.* ...
       XXb.*L3.*L4+4.*jac_hd1.*XXc.*L3.*L4+2.*jac_hd1.*MZ3.*L3.*Lb1.^2.* ...
       cos(-hd2+hd1)-4.*jac_hd1.*MY4.*L3.*Lb1.^2.*sin(hd4)-2.*jac_hd1.* ...
       MY4.*L3.*Lb1.^2.*sin(-hd2-hd4+hd1)-2.*jac_hd1.*MY1.*L3.*Lb1.^2.* ...
       sin(hd1)+2.*jac_hd1.*M4.*L3.*L4.*Lb1.^2.*cos(-hd2+hd1+hd3)-4.* ...
       XX4.*Lb1.^2-4.*XX3.*Lb1.^2-2.*M1.*L3.^2.*Lb1.^2-4.*M4.*L3.^2.* ...
       Lb1.^2-4.*M4.*L4.^2.*Lb1.^2-4.*XXc.*L4.^2-4.*XXw.*L4.^2-4.*XXb.* ...
       L4.^2-2.*jac_hd1.*MY3.*L3.*Lb1.^2.*sin(-hd2+hd1)-4.*jac_hd1.* ...
       MZ4.*L3.*Lb1.^2.*cos(hd4)+2.*jac_hd1.*MZ4.*L4.*Lb1.^2.*cos(-hd2- ...
       hd4+hd1+hd3)+2.*jac_hd1.*MZ3.*L4.*Lb1.^2.*cos(-hd2+hd1+hd3)-2.* ...
       jac_hd1.*MY1.*L4.*Lb1.^2.*sin(hd1+hd3)+2.*jac_hd1.*MZ1.*L3.* ...
       Lb1.^2.*cos(hd1)+2.*jac_hd1.*MZ1.*L4.*Lb1.^2.*cos(hd1+hd3)+2.* ...
       jac_hd1.*M4.*L3.^2.*Lb1.^2.*cos(-hd2+hd1)+2.*jac_hd1.*MZ4.*L3.* ...
       Lb1.^2.*cos(-hd2-hd4+hd1)-2.*jac_hd1.*MY3.*L4.*Lb1.^2.*sin(-hd2+ ...
       hd1+hd3)-2.*jac_hd1.*MY4.*L4.*Lb1.^2.*sin(-hd2-hd4+hd1+hd3)).* ...
       Lb1.^2.*z2;

dq32L = 2.*jac_hd2./(-4.*M3.*L3.^2.*Lb1.^2-4.*M3.*L4.^2.*Lb1.^2+2.* ...
       jac_hd3.*XXc.*L4.^2-2.*jac_hd1.*XX1.*Lb1.^2-2.*jac_hd1.*XX4.* ...
       Lb1.^2-8.*M3.*L3.*L4.*Lb1.^2.*cos(hd3)+2.*jac_hd2.*Lb1.^2.*XX3+ ...
       4.*MZ1.*L3.*Lb1.^2.*cos(hd1)-2.*jac_hd1.*XX3.*Lb1.^2+4.*MZ3.*L4.* ...
       Lb1.^2.*cos(hd3)+4.*MZ1.*L4.*Lb1.^2.*cos(hd1+hd3)-jac_hd3.*XX1.* ...
       Lb1.^2+4.*M4.*L3.^2.*Lb1.^2.*cos(-hd2+hd1)+4.*MZ3.*L3.*Lb1.^2+2.* ...
       jac_hd4.*Lb1.^2.*XX4+4.*MZ4.*L3.*Lb1.^2.*cos(-hd2-hd4+hd1)-4.* ...
       MY3.*L4.*Lb1.^2.*sin(-hd2+hd1+hd3)-4.*MY4.*L4.*Lb1.^2.*sin(-hd2- ...
       hd4+hd1+hd3)+4.*MZ4.*L4.*Lb1.^2-2.*M1.*L4.^2.*Lb1.^2+4.*MZ3.*L3.* ...
       Lb1.^2.*cos(-hd2+hd1)-4.*MY4.*L3.*Lb1.^2.*sin(hd4)-4.*MY4.*L3.* ...
       Lb1.^2.*sin(-hd2-hd4+hd1)-4.*M1.*L3.*L4.*Lb1.^2.*cos(hd3)-4.* ...
       MY1.*L3.*Lb1.^2.*sin(hd1)-4.*MY3.*L3.*Lb1.^2.*sin(-hd2+hd1)-4.* ...
       M4.*L3.*L4.*Lb1.^2.*cos(hd3)+4.*M4.*L3.*L4.*Lb1.^2.*cos(-hd2+hd1+ ...
       hd3)-4.*MZ4.*L3.*Lb1.^2.*cos(hd4)+4.*MZ4.*L4.*Lb1.^2.*cos(-hd2- ...
       hd4+hd1+hd3)+2.*jac_hd4.*Lb1.^2.*MY4.*L3.*sin(hd4)-2.*jac_hd4.* ...
       Lb1.^2.*MZ4.*L4.*cos(-hd2-hd4+hd1+hd3)-2.*jac_hd4.*Lb1.^2.*MZ4.* ...
       L3.*cos(-hd2-hd4+hd1)+2.*jac_hd4.*Lb1.^2.*MY4.*L4.*sin(-hd2-hd4+ ...
       hd1+hd3)+2.*jac_hd4.*Lb1.^2.*MZ4.*L3.*cos(hd4)+2.*jac_hd4.* ...
       Lb1.^2.*MY4.*L3.*sin(-hd2-hd4+hd1)+4.*MZ3.*L4.*Lb1.^2.*cos(-hd2+ ...
       hd1+hd3)-2.*jac_hd3.*MZ4.*L3.*Lb1.^2.*cos(hd4)+2.*jac_hd3.*MZ1.* ...
       L3.*Lb1.^2.*cos(hd1)+2.*jac_hd3.*M4.*L3.^2.*Lb1.^2.*cos(-hd2+ ...
       hd1)+2.*jac_hd3.*MZ4.*L3.*Lb1.^2.*cos(-hd2-hd4+hd1)+2.*jac_hd3.* ...
       MZ3.*L3.*Lb1.^2.*cos(-hd2+hd1)-2.*jac_hd3.*MY4.*L3.*Lb1.^2.* ...
       sin(hd4)-2.*jac_hd3.*MY4.*L3.*Lb1.^2.*sin(-hd2-hd4+hd1)-2.* ...
       jac_hd3.*MY1.*L3.*Lb1.^2.*sin(hd1)-2.*jac_hd3.*MY3.*L3.*Lb1.^2.* ...
       sin(-hd2+hd1)+2.*jac_hd2.*Lb1.^2.*XX4-2.*jac_hd3.*M3.*L3.^2.* ...
       Lb1.^2+2.*jac_hd3.*M3.*L4.^2.*Lb1.^2+2.*jac_hd3.*MZ3.*L3.*Lb1.^2- ...
       2.*jac_hd3.*MZ4.*L4.*Lb1.^2+jac_hd3.*M1.*L4.^2.*Lb1.^2-jac_hd3.* ...
       M1.*L3.^2.*Lb1.^2-2.*jac_hd3.*M4.*L3.^2.*Lb1.^2+2.*jac_hd3.*M4.* ...
       L4.^2.*Lb1.^2+4.*jac_hd3.*XXw.*L3.*L4+4.*jac_hd3.*XXb.*L3.*L4+4.* ...
       jac_hd3.*XXc.*L3.*L4-2.*XX1.*Lb1.^2-2.*jac_hd3.*XX3.*Lb1.^2+2.* ...
       jac_hd3.*XXw.*L4.^2+2.*jac_hd3.*XXb.*L4.^2-4.*MY1.*L4.*Lb1.^2.* ...
       sin(hd1+hd3)-2.*jac_hd2.*Lb1.^2.*MZ4.*L3.*cos(-hd2-hd4+hd1)+2.* ...
       jac_hd2.*Lb1.^2.*MY4.*L4.*sin(-hd2-hd4+hd1+hd3)+4.*jac_hd2.* ...
       Lb1.^2.*MY4.*L3.*sin(hd4)+4.*jac_hd2.*Lb1.^2.*MZ4.*L3.*cos(hd4)+ ...
       2.*jac_hd2.*Lb1.^2.*MY4.*L3.*sin(-hd2-hd4+hd1)-2.*jac_hd2.* ...
       Lb1.^2.*MZ4.*L4.*cos(-hd2-hd4+hd1+hd3)-2.*jac_hd2.*Lb1.^2.*MZ3.* ...
       L3.*cos(-hd2+hd1)+2.*jac_hd2.*Lb1.^2.*MY3.*L4.*sin(-hd2+hd1+hd3)- ...
       2.*jac_hd2.*Lb1.^2.*MZ3.*L4.*cos(-hd2+hd1+hd3)+2.*jac_hd2.* ...
       Lb1.^2.*MY3.*L3.*sin(-hd2+hd1)-2.*jac_hd2.*Lb1.^2.*M4.*L3.^2.* ...
       cos(-hd2+hd1)-2.*jac_hd2.*Lb1.^2.*M4.*L3.*L4.*cos(-hd2+hd1+hd3)+ ...
       2.*jac_hd2.*Lb1.^2.*M4.*L3.^2-4.*MY3.*L4.*Lb1.^2.*sin(hd3)-2.* ...
       jac_hd1.*M4.*L3.^2.*Lb1.^2+4.*jac_hd1.*XXw.*L3.*L4+4.*jac_hd1.* ...
       XXb.*L3.*L4+4.*jac_hd1.*XXc.*L3.*L4+2.*jac_hd1.*MZ3.*L3.*Lb1.^2.* ...
       cos(-hd2+hd1)-4.*jac_hd1.*MY4.*L3.*Lb1.^2.*sin(hd4)-2.*jac_hd1.* ...
       MY4.*L3.*Lb1.^2.*sin(-hd2-hd4+hd1)-2.*jac_hd1.*MY1.*L3.*Lb1.^2.* ...
       sin(hd1)+2.*jac_hd1.*M4.*L3.*L4.*Lb1.^2.*cos(-hd2+hd1+hd3)-4.* ...
       XX4.*Lb1.^2-4.*XX3.*Lb1.^2-2.*M1.*L3.^2.*Lb1.^2-4.*M4.*L3.^2.* ...
       Lb1.^2-4.*M4.*L4.^2.*Lb1.^2-4.*XXc.*L4.^2-4.*XXw.*L4.^2-4.*XXb.* ...
       L4.^2-2.*jac_hd1.*MY3.*L3.*Lb1.^2.*sin(-hd2+hd1)-4.*jac_hd1.* ...
       MZ4.*L3.*Lb1.^2.*cos(hd4)+2.*jac_hd1.*MZ4.*L4.*Lb1.^2.*cos(-hd2- ...
       hd4+hd1+hd3)+2.*jac_hd1.*MZ3.*L4.*Lb1.^2.*cos(-hd2+hd1+hd3)-2.* ...
       jac_hd1.*MY1.*L4.*Lb1.^2.*sin(hd1+hd3)+2.*jac_hd1.*MZ1.*L3.* ...
       Lb1.^2.*cos(hd1)+2.*jac_hd1.*MZ1.*L4.*Lb1.^2.*cos(hd1+hd3)+2.* ...
       jac_hd1.*M4.*L3.^2.*Lb1.^2.*cos(-hd2+hd1)+2.*jac_hd1.*MZ4.*L3.* ...
       Lb1.^2.*cos(-hd2-hd4+hd1)-2.*jac_hd1.*MY3.*L4.*Lb1.^2.*sin(-hd2+ ...
       hd1+hd3)-2.*jac_hd1.*MY4.*L4.*Lb1.^2.*sin(-hd2-hd4+hd1+hd3)).* ...
       Lb1.^2.*z2;

dq41L = 2.*jac_hd3./(-4.*M3.*L3.^2.*Lb1.^2-4.*M3.*L4.^2.*Lb1.^2+2.* ...
       jac_hd3.*XXc.*L4.^2-2.*jac_hd1.*XX1.*Lb1.^2-2.*jac_hd1.*XX4.* ...
       Lb1.^2-8.*M3.*L3.*L4.*Lb1.^2.*cos(hd3)+2.*jac_hd2.*Lb1.^2.*XX3+ ...
       4.*MZ1.*L3.*Lb1.^2.*cos(hd1)-2.*jac_hd1.*XX3.*Lb1.^2+4.*MZ3.*L4.* ...
       Lb1.^2.*cos(hd3)+4.*MZ1.*L4.*Lb1.^2.*cos(hd1+hd3)-jac_hd3.*XX1.* ...
       Lb1.^2+4.*M4.*L3.^2.*Lb1.^2.*cos(-hd2+hd1)+4.*MZ3.*L3.*Lb1.^2+2.* ...
       jac_hd4.*Lb1.^2.*XX4+4.*MZ4.*L3.*Lb1.^2.*cos(-hd2-hd4+hd1)-4.* ...
       MY3.*L4.*Lb1.^2.*sin(-hd2+hd1+hd3)-4.*MY4.*L4.*Lb1.^2.*sin(-hd2- ...
       hd4+hd1+hd3)+4.*MZ4.*L4.*Lb1.^2-2.*M1.*L4.^2.*Lb1.^2+4.*MZ3.*L3.* ...
       Lb1.^2.*cos(-hd2+hd1)-4.*MY4.*L3.*Lb1.^2.*sin(hd4)-4.*MY4.*L3.* ...
       Lb1.^2.*sin(-hd2-hd4+hd1)-4.*M1.*L3.*L4.*Lb1.^2.*cos(hd3)-4.* ...
       MY1.*L3.*Lb1.^2.*sin(hd1)-4.*MY3.*L3.*Lb1.^2.*sin(-hd2+hd1)-4.* ...
       M4.*L3.*L4.*Lb1.^2.*cos(hd3)+4.*M4.*L3.*L4.*Lb1.^2.*cos(-hd2+hd1+ ...
       hd3)-4.*MZ4.*L3.*Lb1.^2.*cos(hd4)+4.*MZ4.*L4.*Lb1.^2.*cos(-hd2- ...
       hd4+hd1+hd3)+2.*jac_hd4.*Lb1.^2.*MY4.*L3.*sin(hd4)-2.*jac_hd4.* ...
       Lb1.^2.*MZ4.*L4.*cos(-hd2-hd4+hd1+hd3)-2.*jac_hd4.*Lb1.^2.*MZ4.* ...
       L3.*cos(-hd2-hd4+hd1)+2.*jac_hd4.*Lb1.^2.*MY4.*L4.*sin(-hd2-hd4+ ...
       hd1+hd3)+2.*jac_hd4.*Lb1.^2.*MZ4.*L3.*cos(hd4)+2.*jac_hd4.* ...
       Lb1.^2.*MY4.*L3.*sin(-hd2-hd4+hd1)+4.*MZ3.*L4.*Lb1.^2.*cos(-hd2+ ...
       hd1+hd3)-2.*jac_hd3.*MZ4.*L3.*Lb1.^2.*cos(hd4)+2.*jac_hd3.*MZ1.* ...
       L3.*Lb1.^2.*cos(hd1)+2.*jac_hd3.*M4.*L3.^2.*Lb1.^2.*cos(-hd2+ ...
       hd1)+2.*jac_hd3.*MZ4.*L3.*Lb1.^2.*cos(-hd2-hd4+hd1)+2.*jac_hd3.* ...
       MZ3.*L3.*Lb1.^2.*cos(-hd2+hd1)-2.*jac_hd3.*MY4.*L3.*Lb1.^2.* ...
       sin(hd4)-2.*jac_hd3.*MY4.*L3.*Lb1.^2.*sin(-hd2-hd4+hd1)-2.* ...
       jac_hd3.*MY1.*L3.*Lb1.^2.*sin(hd1)-2.*jac_hd3.*MY3.*L3.*Lb1.^2.* ...
       sin(-hd2+hd1)+2.*jac_hd2.*Lb1.^2.*XX4-2.*jac_hd3.*M3.*L3.^2.* ...
       Lb1.^2+2.*jac_hd3.*M3.*L4.^2.*Lb1.^2+2.*jac_hd3.*MZ3.*L3.*Lb1.^2- ...
       2.*jac_hd3.*MZ4.*L4.*Lb1.^2+jac_hd3.*M1.*L4.^2.*Lb1.^2-jac_hd3.* ...
       M1.*L3.^2.*Lb1.^2-2.*jac_hd3.*M4.*L3.^2.*Lb1.^2+2.*jac_hd3.*M4.* ...
       L4.^2.*Lb1.^2+4.*jac_hd3.*XXw.*L3.*L4+4.*jac_hd3.*XXb.*L3.*L4+4.* ...
       jac_hd3.*XXc.*L3.*L4-2.*XX1.*Lb1.^2-2.*jac_hd3.*XX3.*Lb1.^2+2.* ...
       jac_hd3.*XXw.*L4.^2+2.*jac_hd3.*XXb.*L4.^2-4.*MY1.*L4.*Lb1.^2.* ...
       sin(hd1+hd3)-2.*jac_hd2.*Lb1.^2.*MZ4.*L3.*cos(-hd2-hd4+hd1)+2.* ...
       jac_hd2.*Lb1.^2.*MY4.*L4.*sin(-hd2-hd4+hd1+hd3)+4.*jac_hd2.* ...
       Lb1.^2.*MY4.*L3.*sin(hd4)+4.*jac_hd2.*Lb1.^2.*MZ4.*L3.*cos(hd4)+ ...
       2.*jac_hd2.*Lb1.^2.*MY4.*L3.*sin(-hd2-hd4+hd1)-2.*jac_hd2.* ...
       Lb1.^2.*MZ4.*L4.*cos(-hd2-hd4+hd1+hd3)-2.*jac_hd2.*Lb1.^2.*MZ3.* ...
       L3.*cos(-hd2+hd1)+2.*jac_hd2.*Lb1.^2.*MY3.*L4.*sin(-hd2+hd1+hd3)- ...
       2.*jac_hd2.*Lb1.^2.*MZ3.*L4.*cos(-hd2+hd1+hd3)+2.*jac_hd2.* ...
       Lb1.^2.*MY3.*L3.*sin(-hd2+hd1)-2.*jac_hd2.*Lb1.^2.*M4.*L3.^2.* ...
       cos(-hd2+hd1)-2.*jac_hd2.*Lb1.^2.*M4.*L3.*L4.*cos(-hd2+hd1+hd3)+ ...
       2.*jac_hd2.*Lb1.^2.*M4.*L3.^2-4.*MY3.*L4.*Lb1.^2.*sin(hd3)-2.* ...
       jac_hd1.*M4.*L3.^2.*Lb1.^2+4.*jac_hd1.*XXw.*L3.*L4+4.*jac_hd1.* ...
       XXb.*L3.*L4+4.*jac_hd1.*XXc.*L3.*L4+2.*jac_hd1.*MZ3.*L3.*Lb1.^2.* ...
       cos(-hd2+hd1)-4.*jac_hd1.*MY4.*L3.*Lb1.^2.*sin(hd4)-2.*jac_hd1.* ...
       MY4.*L3.*Lb1.^2.*sin(-hd2-hd4+hd1)-2.*jac_hd1.*MY1.*L3.*Lb1.^2.* ...
       sin(hd1)+2.*jac_hd1.*M4.*L3.*L4.*Lb1.^2.*cos(-hd2+hd1+hd3)-4.* ...
       XX4.*Lb1.^2-4.*XX3.*Lb1.^2-2.*M1.*L3.^2.*Lb1.^2-4.*M4.*L3.^2.* ...
       Lb1.^2-4.*M4.*L4.^2.*Lb1.^2-4.*XXc.*L4.^2-4.*XXw.*L4.^2-4.*XXb.* ...
       L4.^2-2.*jac_hd1.*MY3.*L3.*Lb1.^2.*sin(-hd2+hd1)-4.*jac_hd1.* ...
       MZ4.*L3.*Lb1.^2.*cos(hd4)+2.*jac_hd1.*MZ4.*L4.*Lb1.^2.*cos(-hd2- ...
       hd4+hd1+hd3)+2.*jac_hd1.*MZ3.*L4.*Lb1.^2.*cos(-hd2+hd1+hd3)-2.* ...
       jac_hd1.*MY1.*L4.*Lb1.^2.*sin(hd1+hd3)+2.*jac_hd1.*MZ1.*L3.* ...
       Lb1.^2.*cos(hd1)+2.*jac_hd1.*MZ1.*L4.*Lb1.^2.*cos(hd1+hd3)+2.* ...
       jac_hd1.*M4.*L3.^2.*Lb1.^2.*cos(-hd2+hd1)+2.*jac_hd1.*MZ4.*L3.* ...
       Lb1.^2.*cos(-hd2-hd4+hd1)-2.*jac_hd1.*MY3.*L4.*Lb1.^2.*sin(-hd2+ ...
       hd1+hd3)-2.*jac_hd1.*MY4.*L4.*Lb1.^2.*sin(-hd2-hd4+hd1+hd3)).* ...
       Lb1.^2.*z2;

dq42L = 2.*jac_hd4./(-4.*M3.*L3.^2.*Lb1.^2-4.*M3.*L4.^2.*Lb1.^2+2.* ...
       jac_hd3.*XXc.*L4.^2-2.*jac_hd1.*XX1.*Lb1.^2-2.*jac_hd1.*XX4.* ...
       Lb1.^2-8.*M3.*L3.*L4.*Lb1.^2.*cos(hd3)+2.*jac_hd2.*Lb1.^2.*XX3+ ...
       4.*MZ1.*L3.*Lb1.^2.*cos(hd1)-2.*jac_hd1.*XX3.*Lb1.^2+4.*MZ3.*L4.* ...
       Lb1.^2.*cos(hd3)+4.*MZ1.*L4.*Lb1.^2.*cos(hd1+hd3)-jac_hd3.*XX1.* ...
       Lb1.^2+4.*M4.*L3.^2.*Lb1.^2.*cos(-hd2+hd1)+4.*MZ3.*L3.*Lb1.^2+2.* ...
       jac_hd4.*Lb1.^2.*XX4+4.*MZ4.*L3.*Lb1.^2.*cos(-hd2-hd4+hd1)-4.* ...
       MY3.*L4.*Lb1.^2.*sin(-hd2+hd1+hd3)-4.*MY4.*L4.*Lb1.^2.*sin(-hd2- ...
       hd4+hd1+hd3)+4.*MZ4.*L4.*Lb1.^2-2.*M1.*L4.^2.*Lb1.^2+4.*MZ3.*L3.* ...
       Lb1.^2.*cos(-hd2+hd1)-4.*MY4.*L3.*Lb1.^2.*sin(hd4)-4.*MY4.*L3.* ...
       Lb1.^2.*sin(-hd2-hd4+hd1)-4.*M1.*L3.*L4.*Lb1.^2.*cos(hd3)-4.* ...
       MY1.*L3.*Lb1.^2.*sin(hd1)-4.*MY3.*L3.*Lb1.^2.*sin(-hd2+hd1)-4.* ...
       M4.*L3.*L4.*Lb1.^2.*cos(hd3)+4.*M4.*L3.*L4.*Lb1.^2.*cos(-hd2+hd1+ ...
       hd3)-4.*MZ4.*L3.*Lb1.^2.*cos(hd4)+4.*MZ4.*L4.*Lb1.^2.*cos(-hd2- ...
       hd4+hd1+hd3)+2.*jac_hd4.*Lb1.^2.*MY4.*L3.*sin(hd4)-2.*jac_hd4.* ...
       Lb1.^2.*MZ4.*L4.*cos(-hd2-hd4+hd1+hd3)-2.*jac_hd4.*Lb1.^2.*MZ4.* ...
       L3.*cos(-hd2-hd4+hd1)+2.*jac_hd4.*Lb1.^2.*MY4.*L4.*sin(-hd2-hd4+ ...
       hd1+hd3)+2.*jac_hd4.*Lb1.^2.*MZ4.*L3.*cos(hd4)+2.*jac_hd4.* ...
       Lb1.^2.*MY4.*L3.*sin(-hd2-hd4+hd1)+4.*MZ3.*L4.*Lb1.^2.*cos(-hd2+ ...
       hd1+hd3)-2.*jac_hd3.*MZ4.*L3.*Lb1.^2.*cos(hd4)+2.*jac_hd3.*MZ1.* ...
       L3.*Lb1.^2.*cos(hd1)+2.*jac_hd3.*M4.*L3.^2.*Lb1.^2.*cos(-hd2+ ...
       hd1)+2.*jac_hd3.*MZ4.*L3.*Lb1.^2.*cos(-hd2-hd4+hd1)+2.*jac_hd3.* ...
       MZ3.*L3.*Lb1.^2.*cos(-hd2+hd1)-2.*jac_hd3.*MY4.*L3.*Lb1.^2.* ...
       sin(hd4)-2.*jac_hd3.*MY4.*L3.*Lb1.^2.*sin(-hd2-hd4+hd1)-2.* ...
       jac_hd3.*MY1.*L3.*Lb1.^2.*sin(hd1)-2.*jac_hd3.*MY3.*L3.*Lb1.^2.* ...
       sin(-hd2+hd1)+2.*jac_hd2.*Lb1.^2.*XX4-2.*jac_hd3.*M3.*L3.^2.* ...
       Lb1.^2+2.*jac_hd3.*M3.*L4.^2.*Lb1.^2+2.*jac_hd3.*MZ3.*L3.*Lb1.^2- ...
       2.*jac_hd3.*MZ4.*L4.*Lb1.^2+jac_hd3.*M1.*L4.^2.*Lb1.^2-jac_hd3.* ...
       M1.*L3.^2.*Lb1.^2-2.*jac_hd3.*M4.*L3.^2.*Lb1.^2+2.*jac_hd3.*M4.* ...
       L4.^2.*Lb1.^2+4.*jac_hd3.*XXw.*L3.*L4+4.*jac_hd3.*XXb.*L3.*L4+4.* ...
       jac_hd3.*XXc.*L3.*L4-2.*XX1.*Lb1.^2-2.*jac_hd3.*XX3.*Lb1.^2+2.* ...
       jac_hd3.*XXw.*L4.^2+2.*jac_hd3.*XXb.*L4.^2-4.*MY1.*L4.*Lb1.^2.* ...
       sin(hd1+hd3)-2.*jac_hd2.*Lb1.^2.*MZ4.*L3.*cos(-hd2-hd4+hd1)+2.* ...
       jac_hd2.*Lb1.^2.*MY4.*L4.*sin(-hd2-hd4+hd1+hd3)+4.*jac_hd2.* ...
       Lb1.^2.*MY4.*L3.*sin(hd4)+4.*jac_hd2.*Lb1.^2.*MZ4.*L3.*cos(hd4)+ ...
       2.*jac_hd2.*Lb1.^2.*MY4.*L3.*sin(-hd2-hd4+hd1)-2.*jac_hd2.* ...
       Lb1.^2.*MZ4.*L4.*cos(-hd2-hd4+hd1+hd3)-2.*jac_hd2.*Lb1.^2.*MZ3.* ...
       L3.*cos(-hd2+hd1)+2.*jac_hd2.*Lb1.^2.*MY3.*L4.*sin(-hd2+hd1+hd3)- ...
       2.*jac_hd2.*Lb1.^2.*MZ3.*L4.*cos(-hd2+hd1+hd3)+2.*jac_hd2.* ...
       Lb1.^2.*MY3.*L3.*sin(-hd2+hd1)-2.*jac_hd2.*Lb1.^2.*M4.*L3.^2.* ...
       cos(-hd2+hd1)-2.*jac_hd2.*Lb1.^2.*M4.*L3.*L4.*cos(-hd2+hd1+hd3)+ ...
       2.*jac_hd2.*Lb1.^2.*M4.*L3.^2-4.*MY3.*L4.*Lb1.^2.*sin(hd3)-2.* ...
       jac_hd1.*M4.*L3.^2.*Lb1.^2+4.*jac_hd1.*XXw.*L3.*L4+4.*jac_hd1.* ...
       XXb.*L3.*L4+4.*jac_hd1.*XXc.*L3.*L4+2.*jac_hd1.*MZ3.*L3.*Lb1.^2.* ...
       cos(-hd2+hd1)-4.*jac_hd1.*MY4.*L3.*Lb1.^2.*sin(hd4)-2.*jac_hd1.* ...
       MY4.*L3.*Lb1.^2.*sin(-hd2-hd4+hd1)-2.*jac_hd1.*MY1.*L3.*Lb1.^2.* ...
       sin(hd1)+2.*jac_hd1.*M4.*L3.*L4.*Lb1.^2.*cos(-hd2+hd1+hd3)-4.* ...
       XX4.*Lb1.^2-4.*XX3.*Lb1.^2-2.*M1.*L3.^2.*Lb1.^2-4.*M4.*L3.^2.* ...
       Lb1.^2-4.*M4.*L4.^2.*Lb1.^2-4.*XXc.*L4.^2-4.*XXw.*L4.^2-4.*XXb.* ...
       L4.^2-2.*jac_hd1.*MY3.*L3.*Lb1.^2.*sin(-hd2+hd1)-4.*jac_hd1.* ...
       MZ4.*L3.*Lb1.^2.*cos(hd4)+2.*jac_hd1.*MZ4.*L4.*Lb1.^2.*cos(-hd2- ...
       hd4+hd1+hd3)+2.*jac_hd1.*MZ3.*L4.*Lb1.^2.*cos(-hd2+hd1+hd3)-2.* ...
       jac_hd1.*MY1.*L4.*Lb1.^2.*sin(hd1+hd3)+2.*jac_hd1.*MZ1.*L3.* ...
       Lb1.^2.*cos(hd1)+2.*jac_hd1.*MZ1.*L4.*Lb1.^2.*cos(hd1+hd3)+2.* ...
       jac_hd1.*M4.*L3.^2.*Lb1.^2.*cos(-hd2+hd1)+2.*jac_hd1.*MZ4.*L3.* ...
       Lb1.^2.*cos(-hd2-hd4+hd1)-2.*jac_hd1.*MY3.*L4.*Lb1.^2.*sin(-hd2+ ...
       hd1+hd3)-2.*jac_hd1.*MY4.*L4.*Lb1.^2.*sin(-hd2-hd4+hd1+hd3)).* ...
       Lb1.^2.*z2;

dq1L = -(jac_hd3+2.*jac_hd1+2).*Lb1.^2./(-4.*M3.*L3.^2.*Lb1.^2-4.*M3.* ...
      L4.^2.*Lb1.^2+2.*jac_hd3.*XXc.*L4.^2-2.*jac_hd1.*XX1.*Lb1.^2-2.* ...
      jac_hd1.*XX4.*Lb1.^2-8.*M3.*L3.*L4.*Lb1.^2.*cos(hd3)+2.*jac_hd2.* ...
      Lb1.^2.*XX3+4.*MZ1.*L3.*Lb1.^2.*cos(hd1)-2.*jac_hd1.*XX3.*Lb1.^2+ ...
      4.*MZ3.*L4.*Lb1.^2.*cos(hd3)+4.*MZ1.*L4.*Lb1.^2.*cos(hd1+hd3)- ...
      jac_hd3.*XX1.*Lb1.^2+4.*M4.*L3.^2.*Lb1.^2.*cos(-hd2+hd1)+4.*MZ3.* ...
      L3.*Lb1.^2+2.*jac_hd4.*Lb1.^2.*XX4+4.*MZ4.*L3.*Lb1.^2.*cos(-hd2- ...
      hd4+hd1)-4.*MY3.*L4.*Lb1.^2.*sin(-hd2+hd1+hd3)-4.*MY4.*L4.* ...
      Lb1.^2.*sin(-hd2-hd4+hd1+hd3)+4.*MZ4.*L4.*Lb1.^2-2.*M1.*L4.^2.* ...
      Lb1.^2+4.*MZ3.*L3.*Lb1.^2.*cos(-hd2+hd1)-4.*MY4.*L3.*Lb1.^2.* ...
      sin(hd4)-4.*MY4.*L3.*Lb1.^2.*sin(-hd2-hd4+hd1)-4.*M1.*L3.*L4.* ...
      Lb1.^2.*cos(hd3)-4.*MY1.*L3.*Lb1.^2.*sin(hd1)-4.*MY3.*L3.* ...
      Lb1.^2.*sin(-hd2+hd1)-4.*M4.*L3.*L4.*Lb1.^2.*cos(hd3)+4.*M4.*L3.* ...
      L4.*Lb1.^2.*cos(-hd2+hd1+hd3)-4.*MZ4.*L3.*Lb1.^2.*cos(hd4)+4.* ...
      MZ4.*L4.*Lb1.^2.*cos(-hd2-hd4+hd1+hd3)+2.*jac_hd4.*Lb1.^2.*MY4.* ...
      L3.*sin(hd4)-2.*jac_hd4.*Lb1.^2.*MZ4.*L4.*cos(-hd2-hd4+hd1+hd3)- ...
      2.*jac_hd4.*Lb1.^2.*MZ4.*L3.*cos(-hd2-hd4+hd1)+2.*jac_hd4.* ...
      Lb1.^2.*MY4.*L4.*sin(-hd2-hd4+hd1+hd3)+2.*jac_hd4.*Lb1.^2.*MZ4.* ...
      L3.*cos(hd4)+2.*jac_hd4.*Lb1.^2.*MY4.*L3.*sin(-hd2-hd4+hd1)+4.* ...
      MZ3.*L4.*Lb1.^2.*cos(-hd2+hd1+hd3)-2.*jac_hd3.*MZ4.*L3.*Lb1.^2.* ...
      cos(hd4)+2.*jac_hd3.*MZ1.*L3.*Lb1.^2.*cos(hd1)+2.*jac_hd3.*M4.* ...
      L3.^2.*Lb1.^2.*cos(-hd2+hd1)+2.*jac_hd3.*MZ4.*L3.*Lb1.^2.*cos(- ...
      hd2-hd4+hd1)+2.*jac_hd3.*MZ3.*L3.*Lb1.^2.*cos(-hd2+hd1)-2.* ...
      jac_hd3.*MY4.*L3.*Lb1.^2.*sin(hd4)-2.*jac_hd3.*MY4.*L3.*Lb1.^2.* ...
      sin(-hd2-hd4+hd1)-2.*jac_hd3.*MY1.*L3.*Lb1.^2.*sin(hd1)-2.* ...
      jac_hd3.*MY3.*L3.*Lb1.^2.*sin(-hd2+hd1)+2.*jac_hd2.*Lb1.^2.*XX4- ...
      2.*jac_hd3.*M3.*L3.^2.*Lb1.^2+2.*jac_hd3.*M3.*L4.^2.*Lb1.^2+2.* ...
      jac_hd3.*MZ3.*L3.*Lb1.^2-2.*jac_hd3.*MZ4.*L4.*Lb1.^2+jac_hd3.* ...
      M1.*L4.^2.*Lb1.^2-jac_hd3.*M1.*L3.^2.*Lb1.^2-2.*jac_hd3.*M4.* ...
      L3.^2.*Lb1.^2+2.*jac_hd3.*M4.*L4.^2.*Lb1.^2+4.*jac_hd3.*XXw.*L3.* ...
      L4+4.*jac_hd3.*XXb.*L3.*L4+4.*jac_hd3.*XXc.*L3.*L4-2.*XX1.* ...
      Lb1.^2-2.*jac_hd3.*XX3.*Lb1.^2+2.*jac_hd3.*XXw.*L4.^2+2.* ...
      jac_hd3.*XXb.*L4.^2-4.*MY1.*L4.*Lb1.^2.*sin(hd1+hd3)-2.*jac_hd2.* ...
      Lb1.^2.*MZ4.*L3.*cos(-hd2-hd4+hd1)+2.*jac_hd2.*Lb1.^2.*MY4.*L4.* ...
      sin(-hd2-hd4+hd1+hd3)+4.*jac_hd2.*Lb1.^2.*MY4.*L3.*sin(hd4)+4.* ...
      jac_hd2.*Lb1.^2.*MZ4.*L3.*cos(hd4)+2.*jac_hd2.*Lb1.^2.*MY4.*L3.* ...
      sin(-hd2-hd4+hd1)-2.*jac_hd2.*Lb1.^2.*MZ4.*L4.*cos(-hd2-hd4+hd1+ ...
      hd3)-2.*jac_hd2.*Lb1.^2.*MZ3.*L3.*cos(-hd2+hd1)+2.*jac_hd2.* ...
      Lb1.^2.*MY3.*L4.*sin(-hd2+hd1+hd3)-2.*jac_hd2.*Lb1.^2.*MZ3.*L4.* ...
      cos(-hd2+hd1+hd3)+2.*jac_hd2.*Lb1.^2.*MY3.*L3.*sin(-hd2+hd1)-2.* ...
      jac_hd2.*Lb1.^2.*M4.*L3.^2.*cos(-hd2+hd1)-2.*jac_hd2.*Lb1.^2.* ...
      M4.*L3.*L4.*cos(-hd2+hd1+hd3)+2.*jac_hd2.*Lb1.^2.*M4.*L3.^2-4.* ...
      MY3.*L4.*Lb1.^2.*sin(hd3)-2.*jac_hd1.*M4.*L3.^2.*Lb1.^2+4.* ...
      jac_hd1.*XXw.*L3.*L4+4.*jac_hd1.*XXb.*L3.*L4+4.*jac_hd1.*XXc.* ...
      L3.*L4+2.*jac_hd1.*MZ3.*L3.*Lb1.^2.*cos(-hd2+hd1)-4.*jac_hd1.* ...
      MY4.*L3.*Lb1.^2.*sin(hd4)-2.*jac_hd1.*MY4.*L3.*Lb1.^2.*sin(-hd2- ...
      hd4+hd1)-2.*jac_hd1.*MY1.*L3.*Lb1.^2.*sin(hd1)+2.*jac_hd1.*M4.* ...
      L3.*L4.*Lb1.^2.*cos(-hd2+hd1+hd3)-4.*XX4.*Lb1.^2-4.*XX3.*Lb1.^2- ...
      2.*M1.*L3.^2.*Lb1.^2-4.*M4.*L3.^2.*Lb1.^2-4.*M4.*L4.^2.*Lb1.^2- ...
      4.*XXc.*L4.^2-4.*XXw.*L4.^2-4.*XXb.*L4.^2-2.*jac_hd1.*MY3.*L3.* ...
      Lb1.^2.*sin(-hd2+hd1)-4.*jac_hd1.*MZ4.*L3.*Lb1.^2.*cos(hd4)+2.* ...
      jac_hd1.*MZ4.*L4.*Lb1.^2.*cos(-hd2-hd4+hd1+hd3)+2.*jac_hd1.*MZ3.* ...
      L4.*Lb1.^2.*cos(-hd2+hd1+hd3)-2.*jac_hd1.*MY1.*L4.*Lb1.^2.* ...
      sin(hd1+hd3)+2.*jac_hd1.*MZ1.*L3.*Lb1.^2.*cos(hd1)+2.*jac_hd1.* ...
      MZ1.*L4.*Lb1.^2.*cos(hd1+hd3)+2.*jac_hd1.*M4.*L3.^2.*Lb1.^2.* ...
      cos(-hd2+hd1)+2.*jac_hd1.*MZ4.*L3.*Lb1.^2.*cos(-hd2-hd4+hd1)-2.* ...
      jac_hd1.*MY3.*L4.*Lb1.^2.*sin(-hd2+hd1+hd3)-2.*jac_hd1.*MY4.*L4.* ...
      Lb1.^2.*sin(-hd2-hd4+hd1+hd3)).*z2;

x = [q31L q32L q41L q42L q1L dq31L dq32L dq41L dq42L dq1L];