%MAIN.M
%
%   Run simulation of walker with offset torso.

%Copyright (c) 2003 by Eric Westervelt and Jessy Grizzle.  This code
%may be freely used for noncommercial ends. If use of this code in
%part or in whole results in publication, proper citation must be
%included in that publication.  This code comes with no guarantees or
%support.

%Eric R. Westervelt & Jessy W. Grizzle
%3/22/00
%2/26/02 - updated for Geomview stuff
%11/29/03 - updated for CDC

addpath m_files

RUN_NAME = 'test';

disp(['RUN_NAME = ',RUN_NAME]);

res = [];

if ~isempty(dir([RUN_NAME,'_data.mat']))
  while isempty(res)
    res = input('Do you want to over run this trial? (0/1)');
  end
  if res == 0, return, end
end

[t,x,u,y,dy,f,step_t] = walk;

save(['mat_files/',RUN_NAME,'_data'], ...
     't','x','u','y','dy','f','step_t');

doplots = [1; % positions
           1; % velocities
	   1; % torques
	   1; % outputs
	   0; % foot and hip trajectories
	   0; % hip specs & knee deflection specs
	   1]; % stance let forces

doprints = 0;

make_plots(t,x,u,y,dy,f,step_t,doplots,doprints,'fig');

anim(t,x,1/15);