%MAIN_ZD.M
%
%   Run simulation of walker with offset torso.

%Copyright (c) 2003 by Eric Westervelt and Jessy Grizzle.  This code
%may be freely used for noncommercial ends. If use of this code in
%part or in whole results in publication, proper citation must be
%included in that publication.  This code comes with no guarantees or
%support.

%Eric R. Westervelt & Jessy W. Grizzle
%3/12/01
%11/30/03 - updated for the CDC

RUN_NAME = 'test'

disp(['RUN_NAME = ',RUN_NAME]);

res = [];

if ~isempty(dir([RUN_NAME,'_zd_data.mat']))
  while isempty(res)
    res = input('Do you want to over run this trial? (0/1)');
  end
  if res == 0, return, end
end

[t,z,step_t,te,ze,ie] = sim_zd;

I = 0;
nI = length(te);
for k = 1:nI, I(k+1) = find(t == te(k)); end

y = [];
dy = [];
f = [];
x = [];
u = [];
for j = 1:nI
  x(I(j)+1:I(j+1),:) = zd_s_lift(z(I(j)+1:I(j+1),:));
  for k = I(j)+1:I(j+1)
    [h,lfh] = decouple_lap_red(x(k,1:5)',x(k,6:10)');
    y = [y; h.'];
    dy = [dy; lfh.'];
    dx = walk(t(k),x(k,:)');
    [f_tan,f_norm] = stance_force(x(k,1:10),dx(1:10));
    f = [f;f_tan f_norm];
    u_tmp = control_synth(x(k,:));
    u = [u; u_tmp];
  end
end


save(['mat_files/',RUN_NAME,'_zd_data'], ...
     't','z','x','u','y','dy','f','step_t');

doplots = [1; % positions
           1; % velocities
	   1; % torques
	   1; % outputs
	   0; % foot and hip trajectories
	   0; % hip specs & knee deflection specs
	   1]; % stance let forces

doprints = 0;

make_plots(t,x,u,y,dy,f,step_t,doplots,doprints,'ps');

anim(t,x,1/30);
