function out = modelParameters
%MODELPARAMETERS   Model parameters for kneed biped.
%
%   [G,L1,L3,L4,M1,M3,M4,MY1,MZ1,MZ3,MZ4,XX1,XX3,XX4] = MODELPARAMETERS

%Copyright (c) 2003 by Eric Westervelt and Jessy Grizzle.  This code
%may be freely used for noncommercial ends. If use of this code in
%part or in whole results in publication, proper citation must be
%included in that publication.  This code comes with no guarantees or
%support.

%Eric Westervelt
%10/2/00

out.g = 9.81;

out.L1=0.625;
out.L3=0.4;
out.L4=0.4;

out.M1=12;
out.M3=6.8;
out.M4=3.2;

out.MY1=0;
out.MY3=0;
out.MY4=0.0696;

out.MZ1=4.0*12/20;
out.MZ3=1.1114;
out.MZ4=0.2420; 

out.XX1=2.22*12/20;
out.XX3=0.47125;
out.XX4=0.19985;

out.IA3=0.83;
out.IA4=0.83;

out.FV1=16.5;
out.FV2=16.5;
out.FV3=5.48;
out.FV4=5.48;

out.FS1=15.0;
out.FS2=15.0;
out.FS3=8.84;
out.FS4=8.84;

out.Lb1=1.4; % length of bar from base to RABBIT
out.Lt=0.8;  % height of the tower

Lb=1.5; % bar length
Mb=5;   % total mass of the bar
Mc=2;   % mass of the cables
Mw=0;   % weight of the bar

Lb2 = Lb - out.Lb1;

out.XXb = 1/2*Mb/Lb*(out.Lb1^3/3 + Lb2^3/3);
out.XXc = 1/2*Mc/out.Lb1*(out.Lb1^3/3);
out.XXw = 1/2*Mw*(Lb2^2);

out.PEbc = out.g/2*Mb/Lb*(out.Lb1^2 - Lb2^2);
out.PEcc = out.g/2*Mc/out.Lb1*out.Lb1^2;
out.PEwc = -out.g/2*Mw*Lb2;
