function symb_param_constraints
%SYMB_PARAM_CONSTRAINTS.M

%Copyright (c) 2003 by Eric Westervelt and Jessy Grizzle.  This code
%may be freely used for noncommercial ends. If use of this code in
%part or in whole results in publication, proper citation must be
%included in that publication.  This code comes with no guarantees or
%support.

%Eric R. Westervelt & Jessy W. Grizzle
%12/30/02
%1/6/02 - updated to do all constraints
%11/30/03 - updated for the CDC

symb = load('mat_files_sym/work_symb_control_lap.mat');

syms dz1_plus

hd_start = subs(symb.hd, symb.z1, symb.b);

jac_hd_start = subs(symb.jac_hd, symb.z1, symb.b);

hd_end = subs(symb.hd, symb.z1, symb.b + symb.m);

jac_hd_end = subs(symb.jac_hd, symb.z1, symb.b + ...
		  symb.m);

% solve for constraints at impact boundary
pos = symb.xi(1:4,1:4)*hd_end - hd_start;
a0 = solve(pos(1),sym('a0'));
b0 = solve(pos(2),sym('b0'));
c0 = solve(pos(3),sym('c0'));
d0 = solve(pos(4),sym('d0'));

vel = symb.H0*symb.dq - jac_hd_start*dz1_plus;
a1 = solve(vel(1),sym('a1'));
b1 = solve(vel(2),sym('b1'));
c1 = solve(vel(3),sym('c1'));
d1 = solve(vel(4),sym('d1'));

save mat_files_sym/work_symb_param_constraints ...
    a0 b0 c0 d0 ...
    a1 b1 c1 d1
disp('[DONE saving mat_files_sym/work_symb_param_constraints.mat]')
